using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Reflection;

namespace QuranNavigator
{
    partial class AboutBox1 : Form
    {
        public AboutBox1()
        {
            InitializeComponent();

            //  Initialize the AboutBox to display the product information from the assembly information.
            //  Change assembly information settings for your application through either:
            //  - Project->Properties->Application->Assembly Information
            //  - AssemblyInfo.cs
         //   this.Text = String.Format("About {0}", AssemblyTitle);
        //    this.labelProductName.Text = AssemblyProduct;
        //    this.labelVersion.Text = String.Format("Version {0}", AssemblyVersion);
        //    this.labelCopyright.Text = AssemblyCopyright;
        //    this.labelCompanyName.Text = AssemblyCompany;
        //    this.textBoxDescription.Text = AssemblyDescription;
        }

        #region Assembly Attribute Accessors

        public string AssemblyTitle
        {
            get
            {
                // Get all Title attributes on this assembly
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyTitleAttribute), false);
                // If there is at least one Title attribute
                if (attributes.Length > 0)
                {
                    // Select the first one
                    AssemblyTitleAttribute titleAttribute = (AssemblyTitleAttribute)attributes[0];
                    // If it is not an empty string, return it
                    if (titleAttribute.Title != "")
                        return titleAttribute.Title;
                }
                // If there was no Title attribute, or if the Title attribute was the empty string, return the .exe name
                return System.IO.Path.GetFileNameWithoutExtension(Assembly.GetExecutingAssembly().CodeBase);
            }
        }

        public string AssemblyVersion
        {
            get
            {
                return Assembly.GetExecutingAssembly().GetName().Version.ToString();
            }
        }

        public string AssemblyDescription
        {
            get
            {
                // Get all Description attributes on this assembly
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyDescriptionAttribute), false);
                // If there aren't any Description attributes, return an empty string
                if (attributes.Length == 0)
                    return "";
                // If there is a Description attribute, return its value
                return ((AssemblyDescriptionAttribute)attributes[0]).Description;
            }
        }

        public string AssemblyProduct
        {
            get
            {
                // Get all Product attributes on this assembly
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyProductAttribute), false);
                // If there aren't any Product attributes, return an empty string
                if (attributes.Length == 0)
                    return "";
                // If there is a Product attribute, return its value
                return ((AssemblyProductAttribute)attributes[0]).Product;
            }
        }

        public string AssemblyCopyright
        {
            get
            {
                // Get all Copyright attributes on this assembly
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false);
                // If there aren't any Copyright attributes, return an empty string
                if (attributes.Length == 0)
                    return "";
                // If there is a Copyright attribute, return its value
                return ((AssemblyCopyrightAttribute)attributes[0]).Copyright;
            }
        }

        public string AssemblyCompany
        {
            get
            {
                // Get all Company attributes on this assembly
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyCompanyAttribute), false);
                // If there aren't any Company attributes, return an empty string
                if (attributes.Length == 0)
                    return "";
                // If there is a Company attribute, return its value
                return ((AssemblyCompanyAttribute)attributes[0]).Company;
            }
        }
        #endregion

        private void labelVersion_Click(object sender, EventArgs e)
        {

        }

        private void AboutBox1_Load(object sender, EventArgs e)
        {
            if (!Quran.ActiveOK)
                label1.Text = "This program has not been activated yet";
            else
                label1.Text = "This program has been successfully activated";

            linkLabel1.Text = "Click here to visit our website";

            if (QuranSetting.Default.LanguageID == 3)
            {
                if(Quran.ActiveOK)
                    linkLabel1.Links.Add(0, linkLabel1.Text.Length, "http://www.qurannavigator.com/langthai/home.php");
                else
                    linkLabel1.Links.Add(0, linkLabel1.Text.Length, "http://www.qurannavigator.com/langthai/register.php");
            }
            else
            {
                if(Quran.ActiveOK)
                    linkLabel1.Links.Add(0, linkLabel1.Text.Length, "http://www.qurannavigator.com/home");
                else
                    linkLabel1.Links.Add(0, linkLabel1.Text.Length, "http://www.qurannavigator.com/register.php");
    
            }

        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start(e.Link.LinkData.ToString());

        }

        private void button1_Click(object sender, EventArgs e)
        {
            frmActivate fac = new frmActivate();
            fac.ShowDialog(this);

            if (!Quran.ActiveOK)
                label1.Text = "This program has not been activated yet";
            else
                label1.Text = "This program has been successfully activated";
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
    }
}
