using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Drawing.Text;

namespace QuranNavigator
{
    public class AyaImage
    {

        public AyaImage()
        {

        }

        int _page = 0;

        public int Page
        {
            get { return _page; }
            set
            {
                if (value < 1) value = 1;
                if (value > 604) value = 604;
                if (_page != value)
                {
                    loadpage(value);
                }
            }
        }

        public void loadpage(int page)
        {
            _page = page;
            myFont = new PrivateFontCollection();
            byte[] myMemFont = exportFile(fontPath, _page);
            MemFont = Marshal.UnsafeAddrOfPinnedArrayElement(myMemFont, 0);
            myFont.AddMemoryFont(MemFont, myMemFont.Length);
            pageFont = myFont.Families[0];

            initData();
            chkSign();
            addArb();
            addNewLine();
            addAyaInPage();
            addSuraAya();
            CalcImage();
        }

        public void CalcSize(int sura, int aya)
        {
            int x = 900, y = 900, w = 1, h = 1;

            for (int i = 0; i < myChar.Length; i++)
            {
                if (myChar[i].sura == sura && myChar[i].aya == aya)
                {
                    if (myChar[i].RC.X < x) x = (int)myChar[i].RC.X;
                    if (myChar[i].RC.Y < y) y = (int)myChar[i].RC.Y;
                    if (myChar[i].RC.X + myChar[i].RC.Width > w) w = (int)(myChar[i].RC.X + myChar[i].RC.Width);
                    if (myChar[i].RC.Y + myChar[i].RC.Height > h) h = (int)(myChar[i].RC.Y + myChar[i].RC.Height);
                    myChar[i].visible = true;
                    if (sura == 1 && aya == 1 && myChar[i].arb == "x")
                    {
                        myChar[i].visible = false;
                    }

                }
                else
                {
                    myChar[i].visible = false;
                }
            }

            sz = new Size(w - x + 15, h - y);
            pt = new Point(x, y);
        }

        Size sz;
        Point pt;
       
        public Bitmap getBlock(int sura, int aya)
        {
            if (aya == 0)
            {
                sura = 1;
                aya = 1;
            }

            int x = Quran.getPageID(sura, aya);

            Page = x;

            CalcSize(sura, aya);

            Bitmap DC = new Bitmap(sz.Width, sz.Height);

            Graphics g = Graphics.FromImage(DC);

            g.TextRenderingHint = TextRenderingHint.AntiAlias;
            //g.SmoothingMode = SmoothingMode.AntiAlias;

            string mean = "";

            RectangleF tmpRC;
            for (int i = 0; i < myChar.Length; i++)
            {
                if (myChar[i].visible)
                {
                    tmpRC = myChar[i].RC;
                    tmpRC.X -= pt.X;
                    tmpRC.Y -= pt.Y;
                    tmpRC.Width += 20;
                    mean += myChar[i].chr;
                    g.DrawString(myChar[i].chr, myChar[i].font, new SolidBrush(QuranSetting.Default.BackColor), tmpRC);
                    tmpRC.X += 1;
                    tmpRC.Y += 1;
                    g.DrawString(myChar[i].chr, myChar[i].font, new SolidBrush(QuranSetting.Default.ForeColor), tmpRC);
                }
            }

            GraphicsPath outlinePath = new GraphicsPath();
            StringFormat sformat = new StringFormat(StringFormat.GenericTypographic);
            
            sformat.FormatFlags = StringFormatFlags.DirectionRightToLeft;

            sformat.Alignment = StringAlignment.Center;

            outlinePath.AddString(mean, pageFont, (int)FontStyle.Bold, 32, new RectangleF(0, 0, 800, 500), sformat);
            RectangleF rf = outlinePath.GetBounds();
            
            DC  = new Bitmap(800, (int)rf.Height + 100);

            Graphics g1 = Graphics.FromImage(DC);

            g1.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            g1.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;

            g1.DrawPath(new Pen(new SolidBrush(Color.Black), 2), outlinePath);
            g1.FillPath(new SolidBrush(Color.White), outlinePath);

            outlinePath.Dispose();

            g.Dispose();
            g1.Dispose();
            ///////////////////////////////////////////////

            return DC;
        }

        PrivateFontCollection myFont;
        FontFamily pageFont;
        IntPtr MemFont;
        string AppDataPath = Application.StartupPath + "\\binary\\";
        string fontPath = Application.StartupPath + "\\binary\\gdi.rom";
        string dataPath = Application.StartupPath + @"\data\";
        public struct _myChar
        {
            public string chr;  // charactor for painting
            public string arb;  // arabic word without haragah
            public string arbH;  // arabic word with haragah
            public double chrSize; // charactor length
            public int signID;
            public bool EndWithNewLine;
            public bool EndWithNewLine2;
            public RectangleF RC;
            public int sura;
            public int aya;
            public int ayaInPage;
            public bool visible;
            public Color color;
            public Font font;
        }
        public _myChar[] myChar;
        int fontSize = 20;
        int linePixel = 42;

        string[] Chr;
        // Code for Charactor 's size
        double[] ChrSize;

        string[] Arb;
        string[] ArbH;
        string[] AyaPos;

        int curUserLine;
        string signAddOn = "";

        public void CalcImage()
        {
            Bitmap HDC = new Bitmap(420, 650);
            Graphics g = Graphics.FromImage(HDC);
            g.Clear(QuranSetting.Default.BackColor);
            g.TextRenderingHint = TextRenderingHint.AntiAlias;
            int startID, endID;

                startID = -1;
                endID = -1;
                string str = "";
                // Frame Size
                Rectangle layoutRectA = new Rectangle(0, 5, 500, 300);

                int addonpage = 0;
                int addLinePixel = 0;
                if (_page < 3)
                {
                    layoutRectA.Y += 100;
                    addLinePixel = 20;
                }

                curUserLine = 0;

                do
                {
                    curUserLine++;
                    startID = endID + 1;
                    endID = getEndChar(startID, ref str);

                    RectangleF[] rf = getOutletAya(str, layoutRectA, new Font(pageFont, fontSize + addonpage), g);
                    int o = 0;
                    if (endID > -1 && rf.Length > 0)
                    {
                        for (int i = startID; i <= endID; i++)
                        {
                            myChar[i].RC = rf[o++];
                        }
                    }
                    layoutRectA.Y += linePixel + addLinePixel;
                } while (endID > 0);

            RectangleF tmpRC;
            int headid = -1;

            for (int i = 0; i < myChar.Length; i++)
            {
                tmpRC = myChar[i].RC;
                tmpRC.X -= 5;
                tmpRC.Width += 30;

                Font mythisFont = new Font(pageFont, fontSize);
                myChar[i].font = mythisFont;

            }

            HDC = null;

        }

        private int getEndChar(int startpos, ref string str)
        {
            str = "";
            if (startpos < myChar.Length)
            {
                for (int i = startpos; i < myChar.Length; i++)
                {
                    str += myChar[i].chr + "";
                    if (myChar[i].EndWithNewLine || i == myChar.Length - 1) return i;
                }
            }
            return -1;
        }

        private RectangleF[] getRectPage(int pageno, int line)
        {
            string[] paRct1 = { "298,175,49,58|277,175,21,58|236,175,41,58|186,175,50,58|152,175,196,58"
                                ,"322,237,66,58|301,237,21,58|253,237,48,58|145,237,108,58|112,237,33,58"
                                ,"356,299,61,58|291,299,65,58|257,299,34,58|206,299,51,58|177,299,29,58|116,299,61,58|83,299,33,58"
                                ,"375,361,37,58|328,361,47,58|274,361,54,58|175,361,99,58|142,361,33,58|88,361,54,58"
                                ,"350,423,64,58|269,423,81,58|235,423,34,58|184,423,51,58|143,423,41,58|86,423,57,58"
                                ,"321,485,48,58|291,485,30,58|185,485,106,58|131,485,54,58"
                                ,"290,547,30,58|214,547,76,58|180,547,34,58",""};

            string[] paRct2 = { "371,217,31,58|337,217,34,58|297,217,40,58|216,217,81,58|202,217,14,58|167,217,35,58|166,217,1,58|139,217,27,58|138,217,1,58|98,217,40,58"
                                ,"360,279,53,58|326,279,34,58|288,279,38,58|237,279,51,58|186,279,51,58|134,279,52,58|87,279,47,58"
                                ,"387,341,29,58|332,341,55,58|277,341,55,58|243,341,34,58|192,341,51,58|139,341,53,58|116,341,23,58|84,341,32,58"
                                ,"373,403,43,58|344,403,29,58|314,403,30,58|292,403,22,58|250,403,42,58|188,403,62,58|168,403,20,58|117,403,51,58|84,403,33,58"
                                ,"324,465,51,58|295,465,29,58|251,465,44,58|227,465,24,58|190,465,37,58|188,465,2,58|125,465,63,58"
                                ,"299,527,29,58|205,527,94,58|172,527,33,58",""};

            if (pageno == 1)
            {
                string[] tt = paRct1[line - 1].Split("|".ToCharArray());
                RectangleF[] rgf = new RectangleF[tt.Length];
                for (int i = 0; i < rgf.Length; i++)
                {
                    rgf[i] = getRectFromString(tt[i]);
                }
                return rgf;
            }
            else if (pageno == 2)
            {
                string[] tt = paRct2[line - 1].Split("|".ToCharArray());
                RectangleF[] rgf = new RectangleF[tt.Length];
                for (int i = 0; i < rgf.Length; i++)
                {
                    rgf[i] = getRectFromString(tt[i]);
                }
                return rgf;
            }
            else
            {
                return new RectangleF[] { };
            }

        }

        private int val(string txt)
        {
            try
            {
                return Convert.ToInt32(txt);
            }
            catch
            {
                return 0;
            }
        }

        private RectangleF[] getOutletAya(string str, Rectangle layoutRectA, Font mythisFont, Graphics g)
        {
            if (_page < 3)
            {
                RectangleF[] thisRect = getRectPage(_page, curUserLine);
                for (int i = 0; i < thisRect.Length; i++)
                {
                    thisRect[i].X -= 40;
                }
                return thisRect;
            }

            //if (_page < 3) mythisFont = new Font(mythisFont.Name, mythisFont.Size + addSizeFont);

            StringFormat strFormat = new StringFormat();
            CharacterRange[] charRanges = new CharacterRange[str.Length];
            for (int i = 0; i < str.Length; i++) charRanges[i] = new CharacterRange(i, 1);
            Region[] charRegions = new Region[charRanges.Length];
            strFormat.Alignment = StringAlignment.Center;
            strFormat.SetMeasurableCharacterRanges(charRanges);

            charRegions = g.MeasureCharacterRanges(str, mythisFont, layoutRectA, strFormat);
            RectangleF[] rf = new RectangleF[charRegions.Length];

            for (int i = 0; i < charRegions.Length; i++)
            {
                rf[i] = charRegions[i].GetBounds(g);
                // reduce x position
                rf[i].X -= 40;
            }

            return rf;
        }

        public string[] getFile(string compactfile, string filename)
        {
            Cab rom = new Cab();
            Cab.CabInfo usercab = rom.getCabInfo(compactfile, "I love SdWr & Fiyah");
            byte[] myByte = rom.ExportRawString(usercab, filename);

            if (myByte == null) return null;

            string tmpFile = System.IO.Path.GetTempFileName();
            System.IO.File.WriteAllBytes(tmpFile, myByte);
            string[] content = System.IO.File.ReadAllLines(tmpFile);
            File.Delete(tmpFile);
            return content;
        }

        public string getFileContent(string compactfile, string filename)
        {
            Cab rom = new Cab();
            Cab.CabInfo usercab = rom.getCabInfo(compactfile, "I love SdWr & Fiyah");
            byte[] myByte = rom.ExportRawString(usercab, filename);

            if (myByte == null) return null;
            string tmpFile = System.IO.Path.GetTempFileName();
            System.IO.File.WriteAllBytes(tmpFile, myByte);
            string content = System.IO.File.ReadAllText(tmpFile);
            File.Delete(tmpFile);

            return content;
        }

        private RectangleF getRectFromString(string txt)
        {
            string[] t = txt.Split(",".ToCharArray());
            if (t.Length > 1)
            {
                return new RectangleF(val(t[0].Trim()), val(t[1].Trim()), val(t[2].Trim()), val(t[3].Trim()));
            }
            else
            {
                return new RectangleF();
            }
        }

        private void addNewLine()
        {
            string[] tmpstr = getFile(AppDataPath + "savenewline", _page.ToString() + ".txt");
            if (tmpstr != null)
            {
                string[] allnewlinestring = tmpstr;
                int nallnewline = allnewlinestring.Length;

                if (nallnewline > 0)
                {
                    int[] allnewline = new int[nallnewline];

                    for (int i = 0; i < nallnewline; i++)
                    {
                        allnewline[i] = Convert.ToInt32(allnewlinestring[i]);
                    }

                    for (int i = 0; i < nallnewline; i++)
                    {
                        myChar[allnewline[i]].EndWithNewLine = true;
                    }

                }
            }
        }

        private void addAyaInPage()
        {
            int curaya = 1;
            for (int i = 0; i < myChar.Length; i++)
            {
                myChar[i].ayaInPage = curaya;
                if (myChar[i].arb == "x") curaya++;
            }
        }

        private void addArb()
        {
            int b = -1;
            for (int i = 0; i < myChar.Length; i++)
            {
                if (myChar[i].signID == 0)
                {
                    b++;
                    if (b < Arb.Length)
                    {
                        myChar[i].arb = Arb[b];
                        myChar[i].arbH = ArbH[b].Replace("", "");
                    }
                }
            }
        }

        private void addSuraAya()
        {
            int[] sr = new int[AyaPos.Length];
            int[] ay = new int[sr.Length];

            for (int i = 0; i < AyaPos.Length; i++)
            {
                string[] to = AyaPos[i].Split(new char[] { ':' });
                sr[i] = int.Parse(to[0]);
                ay[i] = int.Parse(to[1]);

            }

            int p = _page;

            for (int i = 0; i < myChar.Length; i++)
            {
                int a = myChar[i].ayaInPage;
                if (a > sr.Length)
                {
                    myChar[i].sura = sr[sr.Length - 1];
                    myChar[i].aya = ay[ay.Length - 1];
                }
                else
                {
                    myChar[i].sura = sr[myChar[i].ayaInPage - 1];
                    myChar[i].aya = ay[myChar[i].ayaInPage - 1];
                }
            }
        }

        private void chkSign()
        {
            clsSign();
            for (int i = 0; i < myChar.Length; i++)
            {
                if (myChar[i].chrSize < 15)
                {
                    myChar[i].signID = 1;
                }
            }

            string tx = signAddOn;
            if (tx == "") return;
            if (tx.EndsWith(":")) tx = tx.Substring(0, tx.Length - 1);
            string[] spl = tx.Split(new char[] { ':' });
            for (int i = 0; i < spl.Length; i++)
            {
                int curid = Convert.ToInt32(spl[i]);
                if (myChar[curid].signID == 0)
                {
                    myChar[curid].signID = 1;
                }
                else
                {
                    myChar[curid].signID = 0;
                }
            }

        }

        private void clsSign()
        {
            for (int i = 0; i < myChar.Length; i++)
            {
                myChar[i].signID = 0;
                myChar[i].arb = "";
                myChar[i].EndWithNewLine = false;
                myChar[i].EndWithNewLine2 = false;
                myChar[i].RC = new RectangleF();
                myChar[i].sura = 0;
                myChar[i].aya = 0;
                myChar[i].ayaInPage = 0;
            }
        }

        private void initData()
        {
            string fil = _page.ToString() + ".txt";

            Chr = getFile(AppDataPath + "text", fil);
            Arb = getFile(AppDataPath + "textarab", fil);
            ArbH = getFile(AppDataPath + "textarabHara", fil);
            AyaPos = getFile(AppDataPath + "page", fil);

            string[] _chrsize = getFile(AppDataPath + "size", fil);

            ChrSize = new double[_chrsize.Length];

            for (int i = 0; i < _chrsize.Length; i++)
            {
                ChrSize[i] = Convert.ToDouble(_chrsize[i]);
            }

            if (Chr.Length != ChrSize.Length)
            {
                MessageBox.Show("Some Error occured, Chr & ChrSize is not Equal\n" + Chr.ToString() + " : " + ChrSize.ToString(), "initData function");
            }

            myChar = new _myChar[Chr.Length];
            for (int i = 0; i < Chr.Length; i++)
            {
                myChar[i].chr = Chr[i];
                myChar[i].chrSize = ChrSize[i];
                myChar[i].signID = 0;
                myChar[i].arb = "";
                myChar[i].aya = 0;
                myChar[i].sura = 0;
                myChar[i].ayaInPage = 0;
                myChar[i].visible = true;
            }

            signAddOn = "";
            string tmpstr = getFileContent(AppDataPath + "save", fil);
            if (tmpstr != null) signAddOn = tmpstr;

        }

        public byte[] exportFile(string compactfile, int fileno)
        {
            Cab rom = new Cab();
            Cab.CabInfo usercab = rom.getCabInfo(compactfile, "I love SdWr & Fiyah");
            byte[] myByte = rom.ExportRawString(usercab, fileno);
            rom = null;
            return myByte;
        }

    }

}
