using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Microsoft.Win32;
using System.Runtime.InteropServices;

namespace QuranNavigator
{
    public partial class FrmBoard : Form
    {
        public FrmBoard()
        {
            InitializeComponent();
        }

        public navigator nv;
        public PrivateFontCollection myFont;

        [DllImport("user32.dll")]
        static extern bool GetAsyncKeyState(System.Windows.Forms.Keys vKey);

        private void Form1_Load(object sender, EventArgs e)
        {
            //QuranSetting.Default.Reset();
            //QuranSetting.Default.isFirstTime = true;
            /*
            DateTime dt = DateTime.Now;
            if (dt.Year > 2009 || dt.Year < 2009)
            {
                Application.Exit();
                return;
            }
            */

            try
            {
                if (QuranSetting.Default.isFirstTime)
                {
                    string[] tones = QuranSetting.Default.ToneString.Split(new string[] { "\r\n" }, StringSplitOptions.None);
                    string[] tcolor = tones[0].Split(":".ToCharArray());
                    string[] acolor = tcolor[0].Split(",".ToCharArray());
                    string[] bcolor = tcolor[1].Split(",".ToCharArray());
                    string[] ccolor = tcolor[2].Split(",".ToCharArray());
                    string[] dcolor = tcolor[3].Split(",".ToCharArray());
                    string[] ecolor = tcolor[4].Split(",".ToCharArray());
                    string[] fcolor = tcolor[5].Split(",".ToCharArray());
                    string[] gcolor = tcolor[6].Split(",".ToCharArray());
                    string[] hcolor = tcolor[7].Split(",".ToCharArray());
                    string[] icolor = tcolor[8].Split(",".ToCharArray());


                    QuranSetting.Default.BackColor = Color.FromArgb(val(acolor[0]), val(acolor[1]), val(acolor[2]));
                    QuranSetting.Default.ForeColor = Color.FromArgb(val(bcolor[0]), val(bcolor[1]), val(bcolor[2]));

                    QuranSetting.Default.MouseOnColor = Color.FromArgb(val(ccolor[0]), val(ccolor[1]), val(ccolor[2]));
                    QuranSetting.Default.RecitingColor = Color.FromArgb(val(dcolor[0]), val(dcolor[1]), val(dcolor[2]));
                    QuranSetting.Default.SignColor = Color.FromArgb(val(ecolor[0]), val(ecolor[1]), val(ecolor[2]));
                    QuranSetting.Default.AyaColor = Color.FromArgb(val(fcolor[0]), val(fcolor[1]), val(fcolor[2]));
                    QuranSetting.Default.TitleBarColor = Color.FromArgb(val(gcolor[0]), val(gcolor[1]), val(gcolor[2]));
                    QuranSetting.Default.BarMoveColor = Color.FromArgb(val(hcolor[0]), val(hcolor[1]), val(hcolor[2]));
                    QuranSetting.Default.BarSelectColor = Color.FromArgb(val(icolor[0]), val(icolor[1]), val(icolor[2]));

                    // set Zoom
                    Size sf = new Size(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
                    if (sf.Width == 1280 && sf.Height == 800) QuranSetting.Default.zoom = 1f;
                    if (sf.Width == 1280 && sf.Height == 768) QuranSetting.Default.zoom = 1f;
                    if (sf.Width == 1280 && sf.Height == 720) QuranSetting.Default.zoom = 0.9f;
                    if (sf.Width == 1280 && sf.Height == 600) QuranSetting.Default.zoom = 0.7f;
                    if (sf.Width == 1024 && sf.Height == 768) QuranSetting.Default.zoom = 1f;
                    if (sf.Width == 800 && sf.Height == 600) QuranSetting.Default.zoom = 0.7f;

                    // set language
                    if (System.Globalization.CultureInfo.CurrentCulture.Name == "th-TH")
                    {
                        QuranSetting.Default.LanguageID = 3;
                        QuranSetting.Default.TranslationID = 15;
                    }

                    QuranSetting.Default.isFirstTime = false;
                    QuranSetting.Default.Save();

                }
            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.Message);
                string _sn = QuranSetting.Default.SerialNumber;
                string _ac = QuranSetting.Default.ActivationNumber;
                int _tid = QuranSetting.Default.TranslationID;
                int _st = QuranSetting.Default.Style;
                QuranSetting.Default.Reset();
                QuranSetting.Default.SerialNumber = _sn;
                QuranSetting.Default.ActivationNumber = _ac;
                QuranSetting.Default.TranslationID = _tid;
                QuranSetting.Default.Style = _st;
                QuranSetting.Default.Save();
            }

            if (QuranSetting.Default.Style == 5)
            {
                QuranSetting.Default.Style = 2;
            }

            //////// must be remove before make dvd
          //  Quran.SerialOK = true;
          //  Quran.ActiveOK = true;

          //  resumeprogram();
          //  loadfont();
          //  return;
            //////////////////////////////////////
            Random rnd = new Random(DateTime.Now.Second);
            int loop = rnd.Next(200) + 1000;
            for (int i = 0; i < loop; i++)
            {
                int b = i;
                b += i * 2;
                if (b == 400) break;
                if (b == 1000) break;
                if (b == 30000) break;
            }

            if (Quran.chkSerial() == 0) // not yet sn entry
            {
                loop = rnd.Next(200) + 1000;
                for (int i = 0; i < loop; i++)
                {
                    int b = i;
                    b += i * 2;
                    if (b == 400) break;
                    if (b == 1000) break;
                    if (b == 30000) break;
                }

                frmActivate fac = new frmActivate();
                fac.oneClick = true;
                fac.Height = 147;
                fac.ShowDialog(this);
            }

            loop = rnd.Next(200) + 1000;
            for (int i = 0; i < loop; i++)
            {
                int b = i;
                b += i * 2;
                if (b == 400) break;
                if (b == 1000) break;
                if (b == 30000) break;
            }

            if (Quran.SerialOK)
            {
                loop = rnd.Next(200) + 1000;
                for (int i = 0; i < loop; i++)
                {
                    int b = i;
                    b += i * 2 + loop;
                    if (b == 400) break;
                    if (b == 500) break;
                    if (b == 1000) break;
                    if (b == 30000) break;
                }
                resumeprogram();
            }
            else
            {
                Application.Exit();
            }

            loadfont();
        }

        private void loadfont()
        {
            myFont = new PrivateFontCollection();
            myFont.AddFontFile(Quran.proglocation + @"data\menu");
        }

        public static int val(string txt)
        {
            int myvalue = 0;
            try
            {
                myvalue = Convert.ToInt32(txt);
            }
            catch
            {
                myvalue = 0;
            }
            return myvalue;
        }

        public void resumeprogram()
        {
            nv = new navigator(pictureBox2);
            pictureBox2.Image = (Image)nv.createbar();
            setcolor();

            Quran.frmBoard = this;
            Quran.Init(Application.StartupPath);

            setSize(QuranSetting.Default.zoom);

            QuranDisplay = new display(pictureBox1);
            QuranTranslation = new translation(webBrowser1);
            QuranSound = new sound();
            QuranMenu = new menu();

            QuranSound.loadWavePoint();

            int value = QuranSetting.Default.Style;
            QuranSetting.Default.Style = -1;
            Style = value;

            OpenPage(QuranSetting.Default.Page);

            if (!Quran.ActiveOK)
            {
                Quran.frmBoard.Text = "Qur'an Navigator 2 - Not Activated - SerialNumber: " + FormatSerialString(QuranSetting.Default.SerialNumber) + " ComputerID: " + FormatSerialString(QuranSetting.Default.ComputerID);
            }

            Quran.ready = true;
            loadArrow();
        }

        private string FormatSerialString(string txt)
        {
            txt = txt.Insert(12, "-");
            txt = txt.Insert(8, "-");
            txt = txt.Insert(4, "-");
            return txt;
        }

        public void setcolor()
        {
            BackColor = QuranSetting.Default.BackColor;
            ForeColor = QuranSetting.Default.ForeColor;
            lblPageNumber.BackColor = QuranSetting.Default.BackColor;
            lblPageNumber.ForeColor = QuranSetting.Default.ForeColor;
            lblPageNumberOdd.BackColor = QuranSetting.Default.BackColor;
            lblPageNumberOdd.ForeColor = QuranSetting.Default.ForeColor;
            label3_MouseLeave(null, null);
            label2_MouseLeave(null, null);
            lblSuraName.BackColor = QuranSetting.Default.BackColor;
            lblSuraName.ForeColor = QuranSetting.Default.ForeColor;
            pictureBox1.BackColor = QuranSetting.Default.BackColor;        
            if(QuranDisplay!=null) QuranDisplay.refresh();
            if (QuranTranslation != null) QuranTranslation.OpenPage();
            nv.refresh();
        }

        public display QuranDisplay;
        public translation QuranTranslation;
        public sound QuranSound;
        public menu QuranMenu;

        private void loadArrow()
        {
            label2_MouseLeave(null, null);
            label3_MouseLeave(null, null);
        }

        private Bitmap createArrow(bool reverse, Color backColor, Color foreColor, Color lineColor)
        {
            backColor = QuranSetting.Default.TitleBarColor;

            Bitmap bb = new Bitmap(40, 25);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(backColor);

            Point[] cPoint = new Point[7];

            int startX = 5;


            int width = 15;
            int arrwidth = 20;
            int height = 22;
            int height2 = 4;
            int arrheight = 20;

            startX = (bb.Width - (width + arrwidth)) / 2;

            if (reverse)
            {
                cPoint[0] = new Point(startX, ((bb.Height - height) / 2));
                cPoint[1] = new Point(startX + width, ((bb.Height - height2) / 2));
                cPoint[2] = new Point(startX + width, ((bb.Height - arrheight) / 2));
                cPoint[3] = new Point(startX + width + arrwidth, bb.Height / 2);
                cPoint[4] = new Point(startX + width, bb.Height - ((bb.Height - arrheight) / 2));
                cPoint[5] = new Point(startX + width, bb.Height - ((bb.Height - height2) / 2));
                cPoint[6] = new Point(startX, bb.Height - ((bb.Height - height) / 2));
            }
            else
            {
                cPoint[0] = new Point(startX + width + arrwidth, ((bb.Height - height) / 2));
                cPoint[1] = new Point(startX + arrwidth, ((bb.Height - height2) / 2));
                cPoint[2] = new Point(startX + arrwidth, ((bb.Height - arrheight) / 2));
                cPoint[3] = new Point(startX, bb.Height / 2);
                cPoint[4] = new Point(startX + arrwidth, bb.Height - ((bb.Height - arrheight) / 2));
                cPoint[5] = new Point(startX + arrwidth, bb.Height - ((bb.Height - height2) / 2));
                cPoint[6] = new Point(startX + width + arrwidth, bb.Height - ((bb.Height - height) / 2));
            }

            g.FillPolygon(new SolidBrush(foreColor), cPoint);
            g.DrawPolygon(new Pen(new SolidBrush(Color.FromArgb(90, lineColor.R, lineColor.G, lineColor.B)), 2), cPoint);

            Bitmap mybit = new Bitmap(bb.Width, (bb.Height / 2) + 1);
            Graphics ge = Graphics.FromImage(mybit);
            ge.FillRectangle(Brushes.White, 0, 0, mybit.Width, mybit.Height);
            maketransparent(mybit, 60);
            g.DrawImage(mybit, new Point(0, 0));


            return bb;
        }

        private void maketransparent(Bitmap userBitmap, byte level)
        {
            try
            {
                PixelFormat pf = PixelFormat.Format32bppArgb;
                BitmapData bmData = userBitmap.LockBits(new Rectangle(0, 0, userBitmap.Width, userBitmap.Height), ImageLockMode.ReadWrite, pf);
                System.IntPtr Scan0 = bmData.Scan0;
                int curx;

                unsafe
                {
                    byte* p = (byte*)(void*)Scan0;
                    int nWidth = (userBitmap.Width * userBitmap.Height);
                    for (int x = 0; x < nWidth; x++)
                    {
                        curx = x * 4;
                        if (p[curx] > 0 || p[curx + 1] > 0 || p[curx + 2] > 0)
                        {
                            p[curx + 3] = level;
                        }
                    }
                }
                userBitmap.UnlockBits(bmData);
            }
            catch (Exception ex)
            {

            }
        }

        public void setSize(float Zoom)
        {
            QuranSetting.Default.zoom = Zoom;
            QuranSetting.Default.Save();
            setPositionAndSize();
        }


        public void setPositionAndSize()
        {
            //995, 734 frmsize
            //980, 695 picturesize

            // Size for Form

            this.Visible = false;
            Application.DoEvents();

            this.AutoScroll = false;

            int WorkingAreaWidth = Screen.PrimaryScreen.WorkingArea.Width;
            int WorkingAreaHeight = Screen.PrimaryScreen.WorkingArea.Height;

            float Zoom = QuranSetting.Default.zoom;
            // Size for pictureBox1

            int tLeft = 5;
            int tTop = 4;

            int picwidth = (int)(980 * Zoom);
            int picheight = (int)(695 * Zoom);

            if (QuranSetting.Default.Style == 0) picwidth = (int)(490 * Zoom);


            pictureBox1.Size = new Size(picwidth, picheight);

            //pictureBox1.Left = tLeft;
            if (this.WindowState == FormWindowState.Maximized)
            {
                int x = (this.Width - pictureBox1.Width) / 2;
                int y = (this.Height - pictureBox1.Height) / 2;
                if(x<0) x = tLeft;
                if(y<0) y = tTop;
                pictureBox1.Left = x;
                pictureBox1.Top = y;
            }
            else
            {
                pictureBox1.Left = tLeft;
                pictureBox1.Top = tTop;
            }



            int newWidth = picwidth + tLeft + 11;
            int newHeight = picheight + tTop + 38;

            if (newWidth > WorkingAreaWidth)
            {
                lblfrmsize.Left = newWidth - lblfrmsize.Width - 5;
                newWidth = WorkingAreaWidth;
            }
            else
            {
                lblfrmsize.Left = 10;
            }

            if (newHeight > WorkingAreaHeight)
            {
                lblfrmsize.Top = newHeight - lblfrmsize.Height - 30;
                newHeight = WorkingAreaHeight;
            }
            else
            {
                lblfrmsize.Top = 10;
            }

            this.Size = new Size(newWidth, newHeight);

            // size and post for web
            if (QuranSetting.Default.Style> 2)
            {
                webBrowser1.Width = (int)(910 * QuranSetting.Default.zoom);
                webBrowser1.Height = (int)(636 * QuranSetting.Default.zoom);
                //webBrowser1.Left = (int)(42 * QuranSetting.Default.zoom);
                webBrowser1.Left = (int)(37 * QuranSetting.Default.zoom) + pictureBox1.Left;
                //webBrowser1.Top = (int)(36 * QuranSetting.Default.zoom);
                webBrowser1.Top = (int)(32 * QuranSetting.Default.zoom) + pictureBox1.Top;
                
            }
            else
            {
                webBrowser1.Width = (int)(420 * QuranSetting.Default.zoom);
                webBrowser1.Height = (int)(630 * QuranSetting.Default.zoom);
                //webBrowser1.Left = (int)(530 * QuranSetting.Default.zoom);
                webBrowser1.Left = (int)(525 * QuranSetting.Default.zoom) + pictureBox1.Left;
                //webBrowser1.Top = (int)(35 * QuranSetting.Default.zoom);
                webBrowser1.Top = (int)(31 * QuranSetting.Default.zoom) + pictureBox1.Top;
            }


            // size and post to navigator page and surah label
            int halfboard = (pictureBox1.Width / 2);
            lblPageNumber.Left = ((halfboard - lblPageNumber.Width) / 2) + pictureBox1.Left;  //(int)(posx * Zoom);
            lblPageNumberOdd.Left = lblPageNumber.Left + halfboard;
            lblPageNumber.Top = lblPageNumberOdd.Top = (int)(15 * Zoom);

            label2.Left = pictureBox1.Left;
            label3.Left = pictureBox1.Left + (pictureBox1.Width - label3.Width);
            label2.Top = label3.Top = 0;

            label2.Visible = true;
            label3.Visible = true;
            lblPageNumber.Visible = true;
            lblPageNumberOdd.Visible = true;

            if (QuranSetting.Default.Style == 0)
            {
                lblPageNumberOdd.Visible = false;
                lblPageNumber.Left = ((pictureBox1.Width - lblPageNumber.Width) / 2) + pictureBox1.Left;
            }


            if (QuranSetting.Default.Style == 5)
            {
                label2.Visible = false;
                label3.Visible = false;
                lblPageNumber.Visible = false;
                lblPageNumberOdd.Visible = false;
            }

            lblSuraName.Left = ((pictureBox1.Width - lblSuraName.Width) / 2) + pictureBox1.Left;

            button1.Left = label2.Left + label2.Width + 5;
            button1.Width = (int)(57 * QuranSetting.Default.zoom);
            button1.Height = (int)(22 * QuranSetting.Default.zoom);

            pictureBox2.Left = pictureBox1.Left;
            pictureBox2.Top = pictureBox1.Top + pictureBox1.Height - pictureBox2.Height;
            this.AutoScroll = true;
            this.Visible = true;
            Application.DoEvents();
        }


        public int Style{

            get{ return QuranSetting.Default.Style;}
            set{
                int min =0;
                int max =6;

                if(value<min) value = min;
                if(value>max) value = max;
                if(value!= QuranSetting.Default.Style){
                    setStyle(value);
                }
            }
        }

        private void setStyle(int style)
        {
            if (style == QuranSetting.Default.Style) return;

            if (QuranSetting.Default.Style == 5) 
            {
                if(QuranDisplay.mySlide != null) QuranDisplay.mySlide.Pause();
            }

            QuranSetting.Default.Style = style;
            QuranSetting.Default.Save();

            if(style==2 || style==3 || style==4){
                webBrowser1.Visible = true;
            }else{
                webBrowser1.Visible = false;
            }

            lblSuraName.Visible = (style < 4);

            setPositionAndSize();

            if(QuranDisplay !=null)  QuranDisplay.SetStyle();


            if (QuranSetting.Default.Style == 4)
            {
                if (Quran.frmTrasList != null)
                {
                    if (!Quran.frmTrasList.IsDisposed) Quran.frmTrasList.Dispose();
                    Quran.frmTrasList = null;
                }

                Quran.frmTrasList = new frmTranslationList();
                Quran.frmTrasList.Show(this);
            }
            else
            {
                if (Quran.frmTrasList != null)
                {
                    if (!Quran.frmTrasList.IsDisposed) Quran.frmTrasList.Dispose();
                    Quran.frmTrasList = null;
                }

            }
//            pictureBox1.Left = 5;
//            pictureBox1.Top = 4;

        }

        private void FrmBoard_ResizeEnd(object sender, EventArgs e)
        {
            //MessageBox.Show("EEE");
        }

        public int Page
        {
            get
            {
                 return QuranSetting.Default.Page;
            }
            set
            {
                int min =1;
                int max =604;

                if (!Quran.ActiveOK && value > 49)
                {
                    Random rnd = new Random(DateTime.Now.Second);
                    int loop = rnd.Next(200) + 400;
                    for (int i = 0; i < loop; i++)
                    {
                        int b = i;
                        b += i * 2;
                        if (b == 400) break;
                        if (b == 1000) break;
                        if (b == 30000) break;
                    }

                    max = 49;
                    value = min;

                    loop = rnd.Next(2000) + 1000;
                    for (int i = 0; i < loop; i++)
                    {
                        int b = i;
                        b += i * 2;
                        if (b == 400) break;
                        if (b == 1000) break;
                        if (b == 30000) break;
                    }


                    Quran.showMessageActivateRequired();
                    //min = 562;
                   
                }

                if(value<min) value = min;
                if(value>max) value = max;

                if(value!= QuranSetting.Default.Page){
                    OpenPage(value);
                }
            }
        }

        public void refresh()
        {
            OpenPage(QuranSetting.Default.Page);
        }

        public void OpenPage(int page)
        {
            QuranSetting.Default.Page = page;
            QuranSetting.Default.Save();
            QuranDisplay.OpenPage();
            QuranTranslation.OpenPage();
        }

        private void webBrowser1_Navigating(object sender, WebBrowserNavigatingEventArgs e)
        {
            //MessageBox.Show(e.Url.ToString());
            if(e.Url.ToString().ToLower()!="about:blank"){
                e.Cancel = true;
                string url = e.Url.ToString();

                url = url.Replace("blank", "");

                if(url.StartsWith("about:[right]"))
                {
                    closeMenu();
                    url = url.Replace("about:[right]s", "").Replace("a", "").Replace("s", "");
                    string[] aya = url.Split("_".ToCharArray());
                    int suraClick = Quran.val(aya[0]);
                    int ayaClick = Quran.val(aya[1]);
                    int suralast = Quran.val(aya[2]);
                    int ayalast = Quran.val(aya[3]);
                    int surafirst = Quran.val(aya[4]);
                    int ayafirst = Quran.val(aya[5]);

                    displayMenu(webBrowser1, Quran.val(aya[6]) + webBrowser1.Left + this.Left , Quran.val(aya[7]) + webBrowser1.Top + this.Top ,suraClick,ayaClick,suralast,ayalast,surafirst, ayafirst);
                }
                else if(url.StartsWith("about:m;"))
                {
                    url = url.Replace("about:m;", "").Replace("a", "").Replace("s", "");
                    string[] aya = url.Split("_".ToCharArray());
                    int suraClick = Quran.val(aya[0]);
                    lblSuraName.Text = Quran.SuraTable[suraClick - 1].strTitle;
                }
                else
                {
                    closeMenu();
                    url = url.Replace("about:s", "").Replace("a", "").Replace("s", "");
                    string[] aya = url.Split("_".ToCharArray());
                    int suraClick = Quran.val(aya[0]);
                    int ayaClick = Quran.val(aya[1]);

                    if(suraClick==0){
                        closeMenu();
                        return;
                    }



                    if((suraClick==1 && ayaClick==1) || (suraClick>1 && ayaClick==0)){
                        QuranSound.readThisSura(suraClick);
                    }
                    else
                    {
                        int xtraKey = 0;
                        if (GetAsyncKeyState(Keys.ShiftKey)) xtraKey = 2;
                        if (GetAsyncKeyState(Keys.ControlKey)) xtraKey = 1;
                        if (xtraKey == 1)
                        {
                            Quran.frmBoard.QuranSound.addFromThisAya(suraClick, ayaClick);
                        }
                        else if (xtraKey == 2)
                        {
                            Quran.frmBoard.QuranSound.readThisSura(suraClick);
                        }
                        else
                        {
                            QuranSound.readThisAya(suraClick, ayaClick);
                        }
                    }
                }
            }
        }

        public void displayAya(int sura, int aya)
        {
            Quran.MouseClickSura = sura;
            Quran.MouseClickAya = aya;
            displayAya();
        }

        public void displayAya()
        {
            // chk is the page corrected
            if (Quran.MouseClickSura > 0)
            {
                int sura = Quran.MouseClickSura;
                int aya = Quran.MouseClickAya;

                if (aya == 0) aya = 1;
                int page = Quran.getPageID(sura, aya);
                //if (curPageEven != page && curPageOdd != page) openpage(page);
                // chk current page if not then openpage 
                Page = page;
            }

            QuranDisplay.selectaya();

            if (QuranTranslation!= null)
            {
                QuranTranslation.Focus(Quran.MouseClickSura, Quran.MouseClickAya);
            }
            if (Quran.MouseClickSura > 0)
            {
                lblSuraName.Text = Quran.SuraTable[Quran.MouseClickSura - 1].strTitle;
            }
        }

        private void tmrSound_Tick(object sender, EventArgs e)
        {

        }

        public void setReader(int index)
        {
            //MessageBox.Show(index.ToString());
            setReader(index, true);
        }

        public void setReader(int index, bool savestate)
        {
            if (index < 0) index = 0;
            if (index >= Quran.Reciter.Length) index = Quran.Reciter.Length - 1;

            //Quran.frmBoard.QuranSound.curReader = quran.Reader[index];
            //quran.curReaderID = index;
            //MessageBox.Show(index.ToString());
            QuranSetting.Default.ReciterID = index;
            Quran.frmBoard.QuranSound.loadWavePoint();
            QuranSetting.Default.Save();
        }


        public void timer2_Tick(object sender, EventArgs e)
        {
            bool cancel = false;
            Point pt = new Point();
            Quran.GetCursorPos(ref pt);
            if (pt.X >= Quran.menuMain.X && pt.X <= Quran.menuMain.X + Quran.menuMain.Width && pt.Y >= Quran.menuMain.Y && pt.Y <= Quran.menuMain.Y + Quran.menuMain.Height)
            {
                cancel = true;
            }
            if (Quran.menuCount == 2)
            {
                Quran.GetCursorPos(ref pt);
                if (pt.X >= Quran.menuSub.X && pt.X <= Quran.menuSub.X + Quran.menuSub.Width && pt.Y >= Quran.menuSub.Y && pt.Y <= Quran.menuSub.Y + Quran.menuSub.Height)
                {
                    cancel = true;
                }
            }
            if (!cancel) Quran.CloseMenuID--;

            if (Quran.CloseMenuID <1) closeMenu();
        }

        public void closeMenu()
        {
            if (Quran.frmBoard.QuranMenu.MainMenu != null) Quran.frmBoard.QuranMenu.MainMenu.CloseMenu();
            timer2.Enabled = false;
        }

        public static int curSurah=1;
        public static int curAya=1;

        public void displayMenu(Control pBox, int x, int y, int sura, int aya, int lastsura, int lastaya, int firstsura, int firstaya)
        {
            closeMenu();
            if(lastsura==0){
                lastsura = firstsura;
                lastaya = firstaya;
            }

            if (lastsura < 1)
            {
                return;
            }

            Quran.mnuSura = lastsura;
            Quran.mnuAya = lastaya;

            Quran.frmBoard.QuranMenu = new menu();


           // curSura = lastsura;
            curAya = lastaya;

            Quran.frmBoard.QuranMenu.setChk();

            Quran.frmBoard.QuranMenu.MainMenu.findItem("4").Visible = Quran.isReading;
            Quran.frmBoard.QuranMenu.MainMenu.findItem("2").Visible = (sura > 0 && aya > 0);

            if (sura == 0 && aya == 0 && lastsura == 0 && lastaya == 0 & firstsura == 0 & firstaya == 0)
            {
                //MessageBox.Show("aaaa");
                Quran.frmBoard.QuranMenu.MainMenu.findItem("4").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("2").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("3").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("90").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("89").Visible = false;
            }

            if (QuranSetting.Default.Style == 5)
            {
                Quran.frmBoard.QuranMenu.MainMenu.findItem("2").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("3").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("89").Visible = false;
            }

            /*
            if (Quran.menuFrom == 0 || Quran.menuFrom ==3)
            {
                Quran.frmBoard.QuranMenu.MainMenu.findItem("2").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("3").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("90").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("89").Visible = false;
                Quran.frmBoard.QuranMenu.MainMenu.findItem("97").Visible = false;
                if(Quran.menuFrom ==3)Quran.frmBoard.QuranMenu.MainMenu.findItem("9").Visible = false;
            }
            */

            Quran.frmBoard.QuranMenu.MainMenu.setColor(QuranSetting.Default.BackColor, QuranSetting.Default.ForeColor);
            //qMenu.MainMenu.ShowMenu(pBox, x, y);

            Quran.frmBoard.QuranMenu.MainMenu.ShowMenu(x, y);
        
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mshtml.IHTMLDocument2 doc = webBrowser1.Document.DomDocument as mshtml.IHTMLDocument2;
            mshtml.IHTMLTxtRange range = doc.selection.createRange() as mshtml.IHTMLTxtRange;
            Clipboard.SetData(DataFormats.Text, range.text);
        }

        private void selectAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webBrowser1.Document.ExecCommand("SelectAll", false, null);
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            //if(e.Button == MouseButtons.Right){
            //    displayMenu(pictureBox1,e.X,e.Y,0,0,1,1,1,1);
            //}else{
            //    closeMenu();
            //}
            
            bool rightclick = false;
            if (e.Button == MouseButtons.Right) rightclick = true;

            int xtraKey = 0;
            if (GetAsyncKeyState(Keys.ShiftKey)) xtraKey = 2;
            if (GetAsyncKeyState(Keys.ControlKey)) xtraKey = 1;
            


            if (Quran.frmBoard.QuranDisplay.qsd != null)
            {
                Quran.frmBoard.QuranDisplay.qsd.chkMouseUp(new Point(e.X, e.Y), rightclick, xtraKey);
            }
            else if (Quran.frmBoard.QuranDisplay.mySlide != null)
            {
                if (rightclick)
                    displayMenu(pictureBox1, e.X, e.Y, 1, 1, 1, 1, 1, 1);
                else
                    closeMenu();

            }

        }

        private void FrmBoard_Click(object sender, EventArgs e)
        {
            //MessageBox.Show(pictureBox1.Left.ToString()  + ":" + pictureBox1.Top.ToString());
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (Quran.frmBoard.QuranDisplay != null)
            {
                if (Quran.frmBoard.QuranDisplay.qsd != null)
                {
                    Quran.frmBoard.QuranDisplay.qsd.chkMouseOver(new Point((int)((float)e.X / QuranSetting.Default.zoom), (int)((float)e.Y / QuranSetting.Default.zoom)));
                }
            }
        }

        private void webBrowser1_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            if(QuranTranslation!=null) QuranTranslation.Focus();
        }

        private void label2_Click(object sender, EventArgs e)
        {
            closeMenu();
            int newpage = QuranSetting.Default.Page + 1;
            if (QuranSetting.Default.Style == 1) newpage++;
            Page = newpage;
        }

        private void label3_Click(object sender, EventArgs e)
        {
            closeMenu();
            int newpage = QuranSetting.Default.Page - 1;
            if (QuranSetting.Default.Style == 1) newpage--;
            Page = newpage;
        }

        private void label2_MouseLeave(object sender, EventArgs e)
        {
            label2.Image = (Image)createArrow(false, Color.Black, QuranSetting.Default.BackColor, QuranSetting.Default.BackColor);
        }

        private void label3_MouseLeave(object sender, EventArgs e)
        {
            label3.Image = (Image)createArrow(true, Color.Black, QuranSetting.Default.BackColor, QuranSetting.Default.BackColor);
        }

        private void label2_MouseHover(object sender, EventArgs e)
        {
            label2.Image = (Image)createArrow(false, Color.Black, QuranSetting.Default.MouseOnColor, QuranSetting.Default.MouseOnColor);
        }

        private void label3_MouseHover(object sender, EventArgs e)
        {
            label3.Image = (Image)createArrow(true, Color.Black, QuranSetting.Default.MouseOnColor, QuranSetting.Default.MouseOnColor);
        }

        private void pictureBox2_MouseMove(object sender, MouseEventArgs e)
        {
            if (nv != null) nv.chkMouseMove(e.X, e.Y);
        }

        private void pictureBox2_MouseUp(object sender, MouseEventArgs e)
        {
            if (nv != null) nv.chkMouseClick(e.X, e.Y);
        }

        private void lblSuraName_Click(object sender, EventArgs e)
        {
            closeMenu();
            frmSuralist frmsura = new frmSuralist();
            frmsura.ShowDialog(this);
        }

        private void lblPageNumber_Click(object sender, EventArgs e)
        {
            closeMenu();
            frmMoveToPage frmpage = new frmMoveToPage();
            frmpage.ShowDialog(this);
        }

        private void FrmBoard_SizeChanged(object sender, EventArgs e)
        {
            setPositionAndSize();
        }

        private void FrmBoard_MouseUp(object sender, MouseEventArgs e)
        {
            bool rightclick = false;
            if (e.Button == MouseButtons.Right) rightclick = true;            

            if (Quran.frmBoard.QuranDisplay.qsd != null)
            {
                int xtraKey = 0;
                if (GetAsyncKeyState(Keys.ShiftKey)) xtraKey = 2;
                if (GetAsyncKeyState(Keys.ControlKey)) xtraKey = 1;

                Quran.frmBoard.QuranDisplay.qsd.chkMouseUp(new Point(e.X, e.Y), rightclick, xtraKey);
            }
            else if (Quran.frmBoard.QuranDisplay.mySlide != null)
            {
                if (rightclick)
                    displayMenu(pictureBox1, e.X, e.Y, 1, 1, 1, 1, 1, 1);
                else
                    closeMenu();

            }
        }
       
        private void pictureBox2_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            int lastsura, lastaya, firstsura, firstaya;

            try
            {
                lastsura = Quran.frmBoard.QuranDisplay.qsd.lastSura;
                lastaya = Quran.frmBoard.QuranDisplay.qsd.lastAya;
                firstsura = Quran.frmBoard.QuranDisplay.qsd.firstSura;
                firstaya = Quran.frmBoard.QuranDisplay.qsd.firstAya;
            }
            catch (Exception ex)
            {
                lastsura = 1;
                lastaya = 1;
                firstsura = 1;
                firstaya = 1;
            }

            displayMenu(button1, Left + button1.Left, Top + button1.Top, lastsura, lastaya, lastsura, lastaya, firstsura, firstaya);
        }






    }
}