using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Drawing.Text;
//using iTextSharp.text;
//using iTextSharp.text.pdf;

namespace QuranNavigator
{
    public class display
    {

        public display(PictureBox picturebox)
        {
            pictureBox1 = picturebox;
        }
      
        public PictureBox pictureBox1;

        // position of pageposition
        public RectangleF[] PagePosition;

        public Bitmap hBoard;
        public qsd_font qsd;
        public superSlide mySlide;

        public void SetStyle(){
            qsd = null;
            if (mySlide != null)
            {
                mySlide.Dispose();
                mySlide = null;
            }
            refresh();
           
            switch(QuranSetting.Default.Style){
                case 0: // Quran in one page
                    qsd = new qsd_font(pictureBox1);
                    qsd.doublepage = false;
                    break;
                case 1: // Quran in dual page
                    qsd = new qsd_font(pictureBox1);
                    qsd.doublepage = true;
                    break;
                case 2: // Quran with Translation
                    qsd = new qsd_font(pictureBox1);
                    qsd.doublepage = false;
                    break;
                case 3: // Quran with Translation 2

                    break;
                case 4: // Quran With many translations

                    break;
                case 5: // Slide Show
                    //hBoard = new Bitmap(980, 695);
                    mySlide = new superSlide(pictureBox1);
                    mySlide.Start();
                    break;
            }


        }

        public void refresh()
        {
            if (QuranSetting.Default.Style == 0)
                hBoard = new Bitmap(490, 695);
            else
                hBoard = new Bitmap(980, 695);

            string filename = Quran.proglocation + "\\data\\bg.png";
            if(QuranSetting.Default.Style > 2) filename = Quran.proglocation + "\\data\\bg2.png";
            
            Image bg = Image.FromFile(filename);
            Graphics g = Graphics.FromImage(hBoard);
            g.Clear(QuranSetting.Default.BackColor);
       
 
            if(QuranSetting.Default.Style==0)
            {
                g.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.TitleBarColor), 15), 10, 10, 471, 677);
                g.DrawImageUnscaledAndClipped(bg, new Rectangle(0, 0, bg.Width, bg.Height));
            }
            else if(QuranSetting.Default.Style==1 || QuranSetting.Default.Style==2)
            {
                g.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.TitleBarColor), 15), 10, 10, 471, 677);
                g.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.TitleBarColor), 15), 500, 10, 471, 677);
                g.DrawImageUnscaledAndClipped(bg, new Rectangle(0,0,bg.Width,bg.Height) );
                g.DrawImageUnscaledAndClipped(bg, new Rectangle(bg.Width,0,bg.Width,bg.Height) );
            }
            else if(QuranSetting.Default.Style==3 || QuranSetting.Default.Style==4 || QuranSetting.Default.Style==5)
            {
                g.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.TitleBarColor), 15), 10, 10, 962, 677);
                g.DrawImageUnscaledAndClipped(bg, new Rectangle(0, 0, bg.Width, bg.Height));
            }


            if (qsd != null)
            {
                qsd.clearColor();
                qsd.paintBlock();
            }

            pictureBox1.Image = (Image)hBoard;
        }

        public void OpenPage()
        {
            //if (QuranSetting.Default.Style == 1) qsd.doublepage = true;
            if(qsd != null) qsd.Page = QuranSetting.Default.Page;
        }

        public void selectaya(){
            if(qsd !=null) qsd.Focus(Quran.MouseClickSura, Quran.MouseClickAya);
            if (mySlide != null) mySlide.focus(Quran.MouseClickSura, Quran.MouseClickAya);
        }
  


    }

}
