using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace QuranNavigator
{
    public partial class frmAddFavorite : Form
    {
        public frmAddFavorite()
        {
            InitializeComponent();
        }

        string[] QuranStr;

        public int pC1 = -1;
        public int pC2 = -1;
        public int pC3 = -1;
        public int pC4 = -1;
        public int pC5 = -1;

        private void frmAddFavorite_Load(object sender, EventArgs e)
        {
            QuranStr = System.IO.File.ReadAllLines(Quran.proglocation + "Tran\\arb.txt", Encoding.GetEncoding(1256));

            this.BackColor = QuranSetting.Default.BackColor;
            this.ForeColor = QuranSetting.Default.ForeColor;

            for (int i = 0; i < Quran.SuraTable.Length; i++)
            {
                comboBox1.Items.Add((i + 1).ToString() + " - " + Quran.SuraTable[i].strTitle);
                comboBox5.Items.Add((i + 1).ToString() + " - " + Quran.SuraTable[i].strTitle);
            }

            int pid = 0;
            int[] allreader = { 13, 14, 15, 16, 17, 109, 110, 117, 120, 121 };
            for (int i = 0; i < allreader.Length; i++)
            {
                if (Quran.installReciter[i])
                {
                    comboBox4.Items.Add(Quran.allstring[allreader[i]]);
                    lblReciter.Items.Add(i.ToString());
                }
                if (pC5 == i) pC5 = lblReciter.Items.Count - 1;
            }

            comboBox1.SelectedIndex = 0;
            comboBox5.SelectedIndex = 0;

            comboBox4.SelectedIndex = 0;

            if (pC1 > -1) comboBox1.SelectedIndex = pC1;
            if (pC2 > -1) comboBox2.SelectedIndex = pC2;
            if (pC3 > -1) comboBox5.SelectedIndex = pC3;
            if (pC4 > -1) comboBox3.SelectedIndex = pC4;

            if (pC5 > -1) comboBox4.SelectedIndex = pC5;

        }

        ListBox lblReciter = new ListBox();

        private string getQuranStr(int sura, int aya)
        {
            string q = QuranStr[Quran.LineFromAya(sura, aya)];
            if (q.Length > 85)
            {
                int x = q.IndexOf(' ', 70);
                if (x > -1) q = q.Substring(0, x) + " ...";
            }
            return q;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            comboBox2.Items.Clear();
            label5.Text = "";

            for (int i = 0; i < Quran.SuraTable[comboBox1.SelectedIndex].ayaCount; i++)
            {
                comboBox2.Items.Add((i + 1).ToString());
            }

            comboBox2.SelectedIndex = 0;
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox3.SelectedIndex < comboBox2.SelectedIndex) comboBox3.SelectedIndex = comboBox2.SelectedIndex;
            label5.Text = getQuranStr(comboBox5.SelectedIndex + 1, comboBox3.SelectedIndex + 1);
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((comboBox1.SelectedIndex > comboBox5.SelectedIndex) ||(comboBox1.SelectedIndex == comboBox5.SelectedIndex && comboBox3.SelectedIndex < comboBox2.SelectedIndex))
            {
                comboBox5.SelectedIndex = comboBox1.SelectedIndex;
                //comboBox3.SelectedIndex = comboBox2.SelectedIndex;
                comboBox3.SelectedIndex = comboBox3.Items.Count - 1;
            }

            label5.Text = getQuranStr(comboBox1.SelectedIndex + 1, comboBox2.SelectedIndex + 1);
        }

        private int val(string txt)
        {
            try
            {
                return Convert.ToInt32(txt);
            }
            catch
            {
                return 0;
            }
        }

        public int getReciter(int index)
        {
            int x = val(lblReciter.Items[index].ToString());
            return x;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
        }

        private void comboBox5_SelectedIndexChanged(object sender, EventArgs e)
        {
            comboBox3.Items.Clear();
            label5.Text = "";

            for (int i = 0; i < Quran.SuraTable[comboBox5.SelectedIndex].ayaCount; i++)
            {
                comboBox3.Items.Add((i + 1).ToString());
            }

            comboBox3.SelectedIndex = 0;

        }
    }
}