using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;

namespace QuranNavigator
{
    public partial class frmBookmark : Form
    {
        public frmBookmark()
        {
            InitializeComponent();
        }

        private Image createStar(Color backColor)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);

            //Point[] pt = new Point[5];
            /*
            Point[] pt = new Point[10];
            pt[0] = new Point(1, 5);
            pt[1] = new Point(6, 5);
            pt[2] = new Point(8, 1);
            pt[3] = new Point(10, 5);
            pt[4] = new Point(15, 5);
             
            pt[5] = new Point(10, 7);
            pt[6] = new Point(9, 15);
            pt[7] = new Point(8, 11);
            pt[8] = new Point(3, 15);
            pt[9] = new Point(4, 7);
            */

            //g.FillPolygon(new SolidBrush(backColor), pt);
            //g.DrawPolygon(new Pen(Color.Black, 1), pt);

            Rectangle rt = new Rectangle(1, 4, 8, 8);
            g.FillRectangle(new SolidBrush(backColor), rt);
            g.DrawRectangle(new Pen(QuranSetting.Default.TitleBarColor, 1), rt);

            g.Dispose();
            return (Image)bt;
        }

        private Image createDelete(Color backColor)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);
            Point[] pt = new Point[4];

            pt[0] = new Point(1, 1);
            pt[1] = new Point(15, 15);
            pt[2] = new Point(15, 1);
            pt[3] = new Point(1, 15);

            g.DrawLine(new Pen(Brushes.Red, 2), pt[0], pt[1]);
            g.DrawLine(new Pen(Brushes.Red, 2), pt[2], pt[3]);

            g.Dispose();
            return (Image)bt;
        }

        private Image createArrow(Color backColor, bool up)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);
            Point[] pt = new Point[7];
            if (up)
            {
                pt[0] = new Point(8, 3);
                pt[1] = new Point(1, 10);
                pt[2] = new Point(5, 10);
                pt[3] = new Point(3, 15);
                pt[4] = new Point(13, 15);
                pt[5] = new Point(11, 10);
                pt[6] = new Point(15, 10);
            }
            else
            {
                pt[0] = new Point(8, 13);
                pt[1] = new Point(1, 6);
                pt[2] = new Point(5, 6);
                pt[3] = new Point(3, 1);
                pt[4] = new Point(13, 1);
                pt[5] = new Point(11, 6);
                pt[6] = new Point(15, 6);
            }

            g.FillPolygon(new SolidBrush(backColor), pt);
            g.DrawPolygon(new Pen(Color.Black, 1), pt);
            g.Dispose();
            return (Image)bt;
        }

        private void setcolor()
        {
            BackColor = QuranSetting.Default.BackColor;
            ForeColor = QuranSetting.Default.ForeColor;
            dataGridView1.BackgroundColor = QuranSetting.Default.BackColor;
        }

        private void frmBookmark_Load(object sender, EventArgs e)
        {
            setcolor();

            toolStripButton4.Image = createArrow(QuranSetting.Default.BackColor, true);
            toolStripButton5.Image = createArrow(QuranSetting.Default.BackColor, false);
            toolStripButton3.Image = createDelete(QuranSetting.Default.BackColor);

            string bo = QuranSetting.Default.bookmark;
            if (bo != "")
            {
                string[] mybo = bo.Split(new string[] { "#@_@#" } , StringSplitOptions.None);
                int counts = mybo.Length;
                for (int i = 0; i < counts; i++)
                {
                    
                    string curbookmark = mybo[i];
                    if (curbookmark.Trim() != "")
                    {
                        lbBookmark.Items.Add(curbookmark);
                    }
                }
            }

            UpdateBookmark();
            if(dataGridView1.Rows.Count > 0)
            dataGridView1.Rows[0].Selected = true;


        }

        private int val(string txt)
        {
            try
            {

                return Convert.ToInt32(txt);
            }
            catch
            {
                return 1;
            }
        }

        ListBox lbBookmark = new ListBox();

        private void setSelectTree(int index)
        {
            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                dataGridView1.Rows[i].Selected = false;
            }

            if (index > -1)
                dataGridView1.Rows[index].Selected = true;
        }


        private int getNodeSelectID()
        {
            if (lbBookmark.Items.Count > 0)
            {
                for (int i = 0; i < lbBookmark.Items.Count; i++)
                {
                    if (dataGridView1.Rows[i].Selected) return i; 
                }
            }
            return -1;
        }

        private void UpdateBookmark()
        {
            dataGridView1.Rows.Clear();
            if (lbBookmark.Items.Count > 0)
            {
                for (int i = 0; i < lbBookmark.Items.Count; i++)
                {
                    string curbookmark = lbBookmark.Items[i].ToString();
                    string[] arrcurbookmark = curbookmark.Split(new char[] { '@' });
                    arrcurbookmark[1] = Quran.SuraTable[val(arrcurbookmark[1])].strTitle;
                    dataGridView1.Rows.Add(arrcurbookmark);
                }
            }
            SaveBookmark();
        }

        private void SaveBookmark()
        {
            string allbmk = "";

            for (int i = 0; i < lbBookmark.Items.Count; i++)
            {
                if (i == 0)
                    allbmk += lbBookmark.Items[i].ToString();
                else
                    allbmk += "#@_@#" + lbBookmark.Items[i].ToString();
            }

            QuranSetting.Default.bookmark = allbmk;
            QuranSetting.Default.Save();
        }

        private void EDITBMK()
        {
            int x = getNodeSelectID();
            if (x == -1) return;

            frmInput frminp = new frmInput();
            frminp.label1.Text = "Enter new bookmark name";

            string[] allstring = lbBookmark.Items[x].ToString().Split(new char[] { '@' });

            frminp.textBox1.Text = allstring[0];

            if (frminp.ShowDialog(this) == DialogResult.OK)
            {
                string txt = frminp.textBox1.Text.Trim();
                if (txt != "")
                {
                    lbBookmark.Items[x] = txt + "@" + allstring[1] + "@" + allstring[2];
                    UpdateBookmark();
                    setSelectTree(x);
                }
            }
        }

        private void MOVEUPBMK()
        {
            int x = getNodeSelectID();
            if (x > 0)
            {
                reposition(x, x - 1);
                UpdateBookmark();
                setSelectTree(x - 1);
            }
        }

        private void MOVEDOWNBMK()
        {
            int x = getNodeSelectID();
            if (x == -1) return;

            if (x < lbBookmark.Items.Count - 1)
            {
                reposition(x, x + 1);
                UpdateBookmark();
                setSelectTree(x + 1);
            }

        }

        private void reposition(int x, int y)
        {
            object t = lbBookmark.Items[x];
            lbBookmark.Items[x] = lbBookmark.Items[y];
            lbBookmark.Items[y] = t;
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            EDITBMK();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            REMOVEBMK();
        }

        private void REMOVEBMK()
        {
            int x = getNodeSelectID();
            if (x > -1)
            {
                lbBookmark.Items.RemoveAt(x);
                UpdateBookmark();
                if (x > lbBookmark.Items.Count - 1) x--;
                if (x > -1) setSelectTree(x);
            }
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            MOVEUPBMK();
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            MOVEDOWNBMK();
        }


    }
}