using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace QuranNavigator
{
    public partial class frmFavorite : Form
    {
        //public string[] allFavour;
        //public int nAllFavour;
        //int curFavorite = -1;
        string curFavoriteContain = "";

        ListBox lbFavorite;

        public frmFavorite()
        {
            InitializeComponent();
        }

        private string getNewFavorite()
        {
            int x = treeView1.Nodes.Count;
            string strFavorite="";
            if (x > 0)
            {
                bool founded = false;
                int no = 1;
                do
                {
                    strFavorite = "Favorite " + no.ToString();
                    founded = false;
                    for (int i = 0; i < x; i++)
                    {
                        if (strFavorite == treeView1.Nodes[i].Text) founded = true;
                    }
                    no++;
                } while (founded);
            }
            else
            {
                strFavorite = "Favorite 1";
            }

            return strFavorite;
        }

        private void saveFavorite()
        {
            string allfavou = "";

            for (int i = 0; i < lbFavorite.Items.Count; i++)
            {
                if (i == 0)
                    allfavou += lbFavorite.Items[i].ToString();
                else
                    allfavou += "#@_@#" + lbFavorite.Items[i].ToString();
            }

            QuranSetting.Default.favourite = allfavou;
            QuranSetting.Default.Save();
        }

        private void setSelectTree(int index)
        {
            if (index <0) return;
            if (index > treeView1.Nodes.Count - 1) return;

            TreeNode tnode = treeView1.Nodes[index];
            treeView1.SelectedNode = tnode;
        }

        string[] allReader;

        private Image createStar(Color backColor)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);

            //Point[] pt = new Point[5];
            /*
            Point[] pt = new Point[10];
            pt[0] = new Point(1, 5);
            pt[1] = new Point(6, 5);
            pt[2] = new Point(8, 1);
            pt[3] = new Point(10, 5);
            pt[4] = new Point(15, 5);
             
            pt[5] = new Point(10, 7);
            pt[6] = new Point(9, 15);
            pt[7] = new Point(8, 11);
            pt[8] = new Point(3, 15);
            pt[9] = new Point(4, 7);
            */

            //g.FillPolygon(new SolidBrush(backColor), pt);
            //g.DrawPolygon(new Pen(Color.Black, 1), pt);

            Rectangle rt = new Rectangle(1, 4, 8, 8);
            g.FillRectangle(new SolidBrush(backColor), rt);
            g.DrawRectangle(new Pen(QuranSetting.Default.TitleBarColor, 1), rt);

            g.Dispose();
            return (Image)bt;
        }

        private Image createDelete(Color backColor)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);
            Point[] pt = new Point[4];

            pt[0] = new Point(1, 1);
            pt[1] = new Point(15, 15);
            pt[2] = new Point(15, 1);
            pt[3] = new Point(1, 15);

            g.DrawLine(new Pen(Brushes.Red, 2), pt[0], pt[1]);
            g.DrawLine(new Pen(Brushes.Red, 2), pt[2], pt[3]);

            g.Dispose();
            return (Image)bt;
        }

        private Image createArrow(Color backColor, bool up)
        {
            Bitmap bt = new Bitmap(16, 16);
            Graphics g = Graphics.FromImage(bt);            
            Point[] pt = new Point[7];
            if (up)
            {
                pt[0] = new Point(8, 3);
                pt[1] = new Point(1, 10);
                pt[2] = new Point(5, 10);
                pt[3] = new Point(3, 15);
                pt[4] = new Point(13, 15);
                pt[5] = new Point(11, 10);
                pt[6] = new Point(15, 10);
            }
            else
            {
                pt[0] = new Point(8, 13);
                pt[1] = new Point(1, 6);
                pt[2] = new Point(5, 6);
                pt[3] = new Point(3, 1);
                pt[4] = new Point(13, 1);
                pt[5] = new Point(11, 6);
                pt[6] = new Point(15, 6);
            }

            g.FillPolygon(new SolidBrush(backColor), pt);
            g.DrawPolygon(new Pen(Color.Black, 1), pt);
            g.Dispose();
            return (Image)bt;
        }

        private void initFavorite()
        {
            lbFavorite = new ListBox();

            string allfavour = QuranSetting.Default.favourite;
            if (allfavour.Trim() != "")
            {
                string[] all = allfavour.Split(new string[] { "#@_@#" } , StringSplitOptions.None);
                for (int i = 0; i < all.Length; i++)
                {
                    lbFavorite.Items.Add(all[i]);
                }
            }

        }

        private void UpdateFavorite()
        {
            treeView1.Nodes.Clear();
            for (int i = 0; i < lbFavorite.Items.Count; i++)
            {
                string[] allstring = lbFavorite.Items[i].ToString().Split(new char[] { '@' });
                treeView1.Nodes.Add(i.ToString(), allstring[0], 0,1);
            }
            saveFavorite();
            chkEnabled();
        }

        private void frmFavorite_Load(object sender, EventArgs e)
        {
            imageList1.ImageSize = new Size(24, 24);
            imageList1.Images.Add("0", createStar(QuranSetting.Default.BackColor));
            imageList1.Images.Add("1", createStar(QuranSetting.Default.ForeColor));

            toolStripButton4.Image = toolStripButton9.Image = createArrow(QuranSetting.Default.BackColor, true);
            toolStripButton5.Image = toolStripButton10.Image = createArrow(QuranSetting.Default.BackColor, false);
            toolStripButton3.Image = toolStripButton8.Image = createDelete(QuranSetting.Default.BackColor);

            getd();

            initFavorite();
            UpdateFavorite();
        }

        private void getd()
        {
            imageList1.ImageSize = new Size(24, 24);
            imageList1.Images.Add("0", createStar(QuranSetting.Default.BackColor));
            imageList1.Images.Add("1", createStar(QuranSetting.Default.ForeColor));

            setcolor();

            dataGridView1.Font = new Font("Tahoma", 10);


            int[] allreader = { 13, 14, 15, 16, 17, 109, 110, 117, 120, 121 };
            allReader = new string[allreader.Length];

            for (int i = 0; i < allreader.Length; i++)
            {
                allReader[i] = Quran.allstring[allreader[i]];
            }

            // test //////////////////////////

            //Quran.Init(Application.StartupPath);
            //for (int i = 0; i < allreader.Length; i++)
           // {
           //     allReader[i] = "name : " + i.ToString();
            //}
            //////////////////////////////

        }

        private void setcolor()
        {
            BackColor = QuranSetting.Default.BackColor;
            ForeColor = QuranSetting.Default.ForeColor;

            label2.BackColor = QuranSetting.Default.BackColor;
            label2.ForeColor = QuranSetting.Default.ForeColor;

            splitContainer1.Panel1.BackColor = QuranSetting.Default.BackColor;
            splitContainer1.Panel1.ForeColor = QuranSetting.Default.ForeColor;

            splitContainer1.Panel2.BackColor = QuranSetting.Default.BackColor;
            splitContainer1.Panel2.ForeColor = QuranSetting.Default.ForeColor;

            dataGridView1.BackgroundColor = QuranSetting.Default.BackColor;

        }

        private string getFavoriteContain()
        {
            /*
            string allstring = "";
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (i == 0)
                    allstring = getContain(i);
                else
                    allstring += "|" + getContain(i);
            }
            return textBox1.Text + "@" + allstring;
             */
            return "";
        }

        private string getReaderID(string txt)
        {

            for (int i = 0; i < allReader.Length; i++)
            {
               if (txt == allReader[i]) return i.ToString();
            }
            return "0";
        }

        private string getSuraID(string txt)
        {
            for (int i = 0; i < Quran.SuraTable.Length; i++)
            {
                if (txt == Quran.SuraTable[i].strTitle) return i.ToString();
            }
            return "0"; // return default
        }

        private string getContain(int line)
        {
            string[] allstring ={ "", "", "", "" };

            for (int i = 0; i < 4; i++)
            {
                if (dataGridView1.Rows[line].Cells[i].Value != null) allstring[i] = dataGridView1.Rows[line].Cells[i].Value.ToString();
            }
            return getSuraID(allstring[0]) + ";" + allstring[1] + ";" + allstring[2] + ";" + getReaderID(allstring[3]);
        }

        int lastList = -1;

        private void showFavourite()
        {
            int curindex = getNodeSelectID();
            if (curindex < 0) return;

            curFavoriteContain = lbFavorite.Items[curindex].ToString();

            string[] allstring = curFavoriteContain.Split(new char[] { '@' });

            dataGridView1.Rows.Clear();

            if (allstring[1] == "") return;
            string[] allrows = allstring[1].Split(new char[] { '|' });

            for (int i = 0; i < allrows.Length; i++)
            {
                string[] allcells = allrows[i].Split(new char[] { ';' });

                if (allcells.Length == 4)
                {
                    string[] mycells = new string[4];
                    mycells[0] = Quran.SuraTable[val(allcells[0])].strTitle;
                    if (allcells[1] != "") mycells[1] = allcells[1];
                    if (allcells[2] != "") mycells[2] = allcells[2];
                    mycells[3] = allReader[val(allcells[3])];
                    dataGridView1.Rows.Add(mycells);
                }
            }

           dataGridView1.Enabled = true;

            /*
           if (withScroll)
           {
               if (dataGridView1.Rows.Count > 3)
               {
                   dataGridView1.FirstDisplayedScrollingRowIndex = allrows.Length - 1;
                   dataGridView1.Rows[allrows.Length - 1].Selected = true;
               }
           }
             */ 
        }

        private void chkEnabled()
        {
            dataGridView1.Enabled =  toolStrip1.Enabled = (treeView1.Nodes.Count > 0);
            lastList = -1;
        }

        private int val(string txt)
        {
            int myvalue = 0;
            try
            {
                myvalue = Convert.ToInt32(txt);
            }
            catch 
            {

            }
            return myvalue;
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void dataGridView1_CellLeave(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            // add new index
            DOITEM(0);
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            // add new index
            DOITEM(2);
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            // add new index
            DOITEM(1);
        }

        private int getNodeSelectID()
        {
            int x = -1;
            for (int i = 0; i < treeView1.Nodes.Count; i++)
            {
                if (treeView1.Nodes[i].IsSelected)
                {
                    return i;
                }
            }
            return x;
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            int listid = getNodeSelectID();
            if (listid != lastList)
            {
                //showFavourite();
                SHOWITEM();
                lastList = listid;
            }

        }

        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            ADDFAVORITE();
        }

        private void REMOVEFAVORITE()
        {
            int x = getNodeSelectID();
            if (x > -1)
            {
                lbFavorite.Items.RemoveAt(x);
                UpdateFavorite();

                if (x > lbFavorite.Items.Count - 1) x--;
                if (x > -1) setSelectTree(x);
            }
        }

        private void ADDFAVORITE()
        {
            int x = getNodeSelectID();
            x++;
            if (x == 0) x = lbFavorite.Items.Count;

            frmInput frminp = new frmInput();

            frminp.textBox1.Text = getNewFavorite();

            if (frminp.ShowDialog(this) == DialogResult.OK)
            {
                string txt = frminp.textBox1.Text.Trim() + "@";
                if (txt != "")
                {
                    lbFavorite.Items.Insert(x, txt);
                    UpdateFavorite();
                    setSelectTree(x);
                }
            }
        }

        private void EDITFAVORITE()
        {
            int x = getNodeSelectID();
            if (x == -1) return;

            frmInput frminp = new frmInput();

            string[] allstring = lbFavorite.Items[x].ToString().Split(new char[] { '@' });

            frminp.textBox1.Text = allstring[0];
            if (frminp.ShowDialog(this) == DialogResult.OK)
            {
                string txt = frminp.textBox1.Text.Trim();
                if (txt != "")
                {
                    lbFavorite.Items[x] = txt + "@" + allstring[1];
                    UpdateFavorite();
                    setSelectTree(x);
                }
            }
        }

        private void MOVEUPFAVORITE()
        {
            int x = getNodeSelectID();
            if (x > 0)
            {
                reposition(x, x - 1);
                UpdateFavorite();
                setSelectTree(x - 1);
            }
        }

        private void MOVEDOWNFAVORITE()
        {
            int x = getNodeSelectID();
            if (x == -1) return;

            if (x < lbFavorite.Items.Count - 2)
            {
                reposition(x, x + 1);
                UpdateFavorite();
                setSelectTree(x + 1);
            }

        }

        private void reposition(int x, int y)
        {
            object t = lbFavorite.Items[x];
            lbFavorite.Items[x] = lbFavorite.Items[y];
            lbFavorite.Items[y] = t;
        }

        private void DOITEM(int AddEditDelete)
        {
            int index = -1;
            if (dataGridView1.Rows.Count > 0)
            {
                for (int i = 0; i < dataGridView1.Rows.Count; i++)
                {
                    if (dataGridView1.Rows[i].Selected) index = i;
                }
            }

            if (AddEditDelete == 0) index++;

            if (index == -1) return;

            int x = getNodeSelectID();
            if (x == -1) return;
            string[] allstring = lbFavorite.Items[x].ToString().Split(new char[] { '@' });
            ListBox lbSelect = new ListBox();
            if (allstring[1].Trim() != "")
            {
                string[] stringline = allstring[1].Split("|".ToCharArray());
                for (int i = 0; i < stringline.Length; i++)
                {
                    if(stringline[i].Trim()!="")  lbSelect.Items.Add(stringline[i]);
                }
            }

            string txt = "";
            if (AddEditDelete < 2) // Add or Edit
            {
                frmAddFavorite frmadd = new frmAddFavorite();

                if(AddEditDelete==1) // Edit
                {
                    string[] allstr = lbSelect.Items[index].ToString().Split(";".ToCharArray());
                    frmadd.pC1 = val(allstr[0]);
                    frmadd.pC2 = val(allstr[1]) - 1;
                    frmadd.pC3 = val(allstr[2]);
                    frmadd.pC4 = val(allstr[3]) - 1;
                    frmadd.pC5 = val(allstr[4]);
                }

                if (frmadd.ShowDialog(this) == DialogResult.OK)
                {
                    int cSura1 = frmadd.comboBox1.SelectedIndex;
                    int cAya1 = frmadd.comboBox2.SelectedIndex + 1;
                    int cAya2 = frmadd.comboBox3.SelectedIndex + 1;
                    int cReciter = frmadd.getReciter(frmadd.comboBox4.SelectedIndex);
                    int cSura2 = frmadd.comboBox5.SelectedIndex;

                    txt = cSura1.ToString() + ";" + cAya1.ToString() + ";" +
                                                   cSura2.ToString() + ";" + cAya2.ToString() + ";" + cReciter.ToString();
                    frmadd = null;
                }
                else
                {
                    frmadd = null;
                    return;
                }
            }

            if (AddEditDelete == 0) // Add
            {
                lbSelect.Items.Insert(index, txt);
            }
            else if (AddEditDelete == 1) // Edit
            {
                lbSelect.Items[index] = txt;
            }
            else if (AddEditDelete == 2) // Delete
            {
                lbSelect.Items.RemoveAt(index);
            }
            else if (AddEditDelete == 3) // MoveUp
            {
                if (index > 0)
                {
                    object obj = lbSelect.Items[index];
                    lbSelect.Items[index] = lbSelect.Items[index - 1];
                    lbSelect.Items[index - 1] = obj;
                    index--;
                }
            }
            else if (AddEditDelete == 4) // MoveDown
            {
                if (index < lbSelect.Items.Count - 1)
                {
                    object obj = lbSelect.Items[index];
                    lbSelect.Items[index] = lbSelect.Items[index + 1];
                    lbSelect.Items[index + 1] = obj;
                    index++;
                }
            }

            string allitem = "";
            if (lbSelect.Items.Count > 0)
            {
                //MessageBox.Show("lblSelect : " + lbSelect.Items.Count.ToString());
                for (int i = 0; i < lbSelect.Items.Count; i++)
                {
                    if (i == 0)
                    {
                        allitem = lbSelect.Items[i].ToString();
                    }
                    else
                    {
                        allitem += "|" + lbSelect.Items[i].ToString();
                    }
                }
            }

            lbFavorite.Items[x] = allstring[0] + "@" + allitem;
            SHOWITEM();

            if (index > dataGridView1.Rows.Count - 1) index--;

            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                dataGridView1.Rows[i].Selected = (i==index);
            }
            saveFavorite();
        }

        private void SHOWITEM()
        {
            dataGridView1.Rows.Clear();
            int x = getNodeSelectID();
            if (x == -1) return;
            string[] allstring = lbFavorite.Items[x].ToString().Split(new char[] { '@' });
            ListBox lbSelect = new ListBox();
            if (allstring[1].Trim() != "")
            {

                int[] allreader = { 13, 14, 15, 16, 17, 109, 110, 117, 120, 121 };

                string[] stringline = allstring[1].Split("|".ToCharArray());
                for (int i = 0; i < stringline.Length; i++)
                {
                    //MessageBox.Show("ShowItem " + i.ToString() + " : " + stringline[i]);
                    if (stringline[i].Trim() != "")
                    {
                        string[] allstr = stringline[i].Split(";".ToCharArray());
                        allstr[0] = Quran.SuraTable[val(allstr[0])].strTitle;
                        allstr[2] = Quran.SuraTable[val(allstr[2])].strTitle;
                        allstr[4] = Quran.allstring[allreader[ val(allstr[4])]];// Quran.Reciter[val(allstr[4])].strTitle;
                        dataGridView1.Rows.Add(allstr);
                    }
                }
            }
        }

        private void toolStripButton8_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Clear();
            REMOVEFAVORITE();
        }

        private void toolStripButton7_Click(object sender, EventArgs e)
        {
            EDITFAVORITE();
        }

        private void toolStripButton9_Click(object sender, EventArgs e)
        {
            MOVEUPFAVORITE();
        }

        private void toolStripButton10_Click(object sender, EventArgs e)
        {
            MOVEDOWNFAVORITE();
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            DOITEM(3);
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            DOITEM(4);
        }

    }
}