using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace QuranNavigator
{
    public partial class frmSuralist : Form
    {
        public frmSuralist()
        {
            InitializeComponent();
        }

        int[] medi = new int[115];

        private void frmSuralist_Load(object sender, EventArgs e)
        {
            BackColor = QuranSetting.Default.BackColor;
            ForeColor = QuranSetting.Default.ForeColor;


            int[] medina = { 2, 3, 4, 5, 8, 9, 13, 22, 24, 33, 47, 48, 49, 55, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 76, 98, 99, 110 };
            for (int i = 0; i < 115; i++)
            {
                medi[i] = 0;
            }
            for (int i = 0; i < medina.Length; i++)
            {
                medi[medina[i]] = 1;
            }

            int lasty = 10;
            int surano = 0;
            int curx = 20;

            for (int o = 0; o < 5; o++)
            {
                curx = (o * 140) + 10;
                for (int i = 0; i < 23; i++)
                {
                    if (surano > 114) break;
                    Label lbl = new Label();
                    lbl.Visible = (surano != 0);
                    lbl.Left = curx;
                    lasty = (20 * i) + 5;
                    lbl.Top = lasty;
                    lbl.Width = 130;
                    lbl.Height = 17;
                    lbl.Name = (surano).ToString();
                    if(surano>0) lbl.Text = (surano).ToString() + " - " + Quran.SuraTable[surano-1].strTitle;
                    if (medi[surano] == 0)
                        lbl.BackColor = Color.PaleGoldenrod;
                    else
                        lbl.BackColor = Color.LightGreen;

                    lbl.ForeColor = Color.Black;
                    lbl.Cursor = Cursors.Hand;
                    lbl.MouseMove += new MouseEventHandler(lbl_MouseMove);
                    lbl.MouseLeave += new EventHandler(lbl_MouseLeave);
                    lbl.Tag = 0;
                    lbl.Click += new EventHandler(lbl_Click);
                    this.Controls.Add(lbl);
                    surano++;
                }
            }

            StringBuilder sb = new StringBuilder();
            sb.Append("<html><head>");

            sb.Append("<script>");
            sb.Append("\r\nfunction openme(surano,ayano){");
            sb.Append("\r\nlocation.href='s'+surano+':'+ayano");
            sb.Append("\r\n}");
            sb.Append("\r\n</script>" + "\r\n");           
            sb.Append("</head><body bgcolor='#" + Color2HTML(QuranSetting.Default.BackColor) + "'>");
            sb.Append("<table border='0' cellpadding='3' cellspacing='3' style='font-family: Tahoma; font-size: 10pt'>");

            string tColor = " width='130' style='cursor:pointer' onmouseout='bgColor=\"\"' onmousemove='bgColor=\"" + ColorHTML(Color.LightSlateGray) + "\"'";

            for (int i = 1; i < 24; i++)
            {

                sb.Append("<tr style='background-color: #ffffcc;' height='17'>");

                sb.Append("<td" + tColor + " onclick='openme(" + (i).ToString() + ",0)'>" + (i).ToString() + "- " + Quran.SuraTable[i - 1].strTitle + "</td>");
                sb.Append("<td" + tColor + " onclick='openme(" + (i + 22).ToString() + ",0)'>" + (i + 22).ToString() + "- " + Quran.SuraTable[i + 22 - 1].strTitle + "</td>");
                sb.Append("<td" + tColor + " onclick='openme(" + (i + 45).ToString() + ",0)'>" + (i + 45).ToString() + "- " + Quran.SuraTable[i + 45 - 1].strTitle + "</td>");
                sb.Append("<td" + tColor + " onclick='openme(" + (i + 68).ToString() + ",0)'>" + (i + 68).ToString() + "- " + Quran.SuraTable[i + 68 - 1].strTitle + "</td>");

                if (i == 23)
                {
                    sb.Append("<td width='130'>&nbsp;</td>");
                }
                else
                {
                    sb.Append("<td " + tColor + " onclick='openme(" + (i + 92).ToString() + ",0)'>" + (i + 92).ToString() + "- " + Quran.SuraTable[i + 92 - 1].strTitle + "</td>");
                }

                sb.Append("</tr>");

            }
            sb.Append("</table>");
            webBrowser1.DocumentText = sb.ToString();
        }

        private string Color2HTML(Color _color)
        {
            string colorR = "00" + Convert.ToString(_color.R, 16);
            string colorG = "00" + Convert.ToString(_color.G, 16);
            string colorB = "00" + Convert.ToString(_color.B, 16);
            colorR = colorR.Substring(colorR.Length - 2);
            colorG = colorG.Substring(colorG.Length - 2);
            colorB = colorB.Substring(colorB.Length - 2);
            return colorR + colorG + colorB;
        }

        private string ColorHTML(Color thisColor)
        {
            return "#" + Convert.ToString(thisColor.R, 16) + Convert.ToString(thisColor.G, 16) + Convert.ToString(thisColor.B, 16);
        }

        void lbl_MouseLeave(object sender, EventArgs e)
        {
            Label lb = (Label)sender;
            if (Convert.ToInt32(lb.Tag) == 0)
            {
                //lb.BackColor = Color.PaleGoldenrod;
                if (medi[Convert.ToInt32(lb.Name)] == 0)
                    lb.BackColor = Color.PaleGoldenrod;
                else
                    lb.BackColor = Color.LightGreen;
            }
        }

        void lbl_MouseMove(object sender, MouseEventArgs e)
        {
            Label lb = (Label)sender;
            if (Convert.ToInt32(lb.Tag) == 0) lb.BackColor = Color.LightSlateGray;
        }

        void lbl_Click(object sender, EventArgs e)
        {
            Label lb = (Label)sender;
            int suraSelected = Convert.ToInt32(lb.Name);
            Quran.frmBoard.displayAya(suraSelected, 0);
           // this.Dispose();

        }

        private void webBrowser1_Navigating(object sender, WebBrowserNavigatingEventArgs e)
        {
            if (e.Url.ToString().ToLower() != "about:blank")
            {
                string[] sinfo = e.Url.ToString().Substring(1).Split(":".ToCharArray());

                int sura = val(sinfo[0]);
                int aya = val(sinfo[1]);

                Quran.frmBoard.displayAya(sura, aya);
                e.Cancel = true;
                this.Close();
            }
        }

        private int val(string txt)
        {
            try
            {
                return Convert.ToInt32(txt);
            }
            catch
            {
                return 1;
            }
        }

    }
}
