using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace QuranNavigator
{
    public class navigator
    {
        private PictureBox pbox;

        public navigator(PictureBox pb)
        {
            pbox = pb;
            initbar();
        }

        Color nBackColor = Color.Black;
        Color nlineColor = Color.DarkGreen;
        Color nAreaColor = Color.Lime;

        public void chkMouseMove(int x, int y)
        {
            int id = -1;
            for (int i = 0; i < Buttons.Length; i++)
            {
                if (x >= Buttons[i].Rect.X && x <= Buttons[i].Rect.X + Buttons[i].Rect.Width &&
                    y >= Buttons[i].Rect.Y && y <= Buttons[i].Rect.Y + Buttons[i].Rect.Height)
                {
                    id = i;
                    break;
                }
            }
            setMouseOn(id);

        }

        public void chkMouseClick(int x, int y)
        {
            if (lastIndex > -1)
            {
                for (int i = 0; i < Buttons.Length; i++)
                {
                    if (Buttons[i].status == 1) Buttons[i].status = 0;
                }

                pbox.Image = (Image)createbar();
                if (lastIndex == 0)// prev
                {
                    Quran.frmBoard.QuranSound.prev();
                }
                else if (lastIndex == 1) // play
                {
                    Quran.frmBoard.QuranSound.resume();
                }
                else if (lastIndex == 2) // pause
                {
                    Quran.frmBoard.QuranSound.pause();
                }
                else if (lastIndex == 3) // stop 
                {
                    Quran.frmBoard.QuranSound.stop();
                }
                else if (lastIndex == 4) // Next
                {
                    Quran.frmBoard.QuranSound.next();
                }


            }
        }

        int lastIndex = -1;
        int curIndex = -1;

        public void setMouseOn(int index)
        {
            curIndex = index;
            if (curIndex != lastIndex)
            {
                if (lastIndex > -1) Buttons[lastIndex].status = 0;
                if (curIndex > -1) Buttons[curIndex].status = 2;
            }
            lastIndex = curIndex;
            pbox.Image = (Image)createbar();
        }

        public iconstate[] Buttons;

        public struct iconstate
        {
            public int id;
            public Rectangle Rect;
            public int status;
        }

        public int selectedItem = 1;

        private void initbar()
        {
            //Buttons = new iconstate[5];
            Buttons = new iconstate[5];
            for (int i = 0; i < 5; i++)
            {
                Buttons[i].Rect = new Rectangle((i * 40) + 10, 2, 30, 20);
                //Buttons[i].Rect = new Rectangle((i * 32) + 10, 2, 30, 20);
                Buttons[i].status = 0;
            }
            /*
            for (int i = 5; i < Buttons.Length; i++)
            {
                Buttons[i].Rect = new Rectangle(((i-5) * 15) + 180, 2, 5, 20);
                Buttons[i].status = 0;
            }
            */
        }

        public Bitmap createbar()
        {
            Bitmap bb = new Bitmap(205, 26);

            Bitmap[] bt = new Bitmap[5];

            for (int i = 0; i < Buttons.Length; i++)
            {
                if (i == selectedItem) Buttons[i].status = 1;
            }

            bt[0] = bPrev(Buttons[0].status);
            bt[1] = bPlay(Buttons[1].status);
            bt[2] = bPause(Buttons[2].status);
            bt[3] = bStop(Buttons[3].status);
            bt[4] = bNext(Buttons[4].status);
            //bt[5] = bVolumn(Buttons[5].status);

            Graphics g = Graphics.FromImage(bb);
            //g.Clear(nBackColor);
            g.Clear(QuranSetting.Default.TitleBarColor);

            for (int i = 0; i < bt.Length; i++)
            {
                if (Quran.frmBoard != null)
                {
                    if (Quran.frmBoard.QuranSound.nsoundItem > 1)
                    {
                        g.DrawImage(bt[i], new Rectangle(Buttons[i].Rect.X, Buttons[i].Rect.Y, Buttons[i].Rect.Width, Buttons[i].Rect.Height), new Rectangle(0, 0, Buttons[i].Rect.Width, Buttons[i].Rect.Height), GraphicsUnit.Pixel);
                    }
                    else
                    {
                        if (i != 0 && i != 4) g.DrawImage(bt[i], new Rectangle(Buttons[i].Rect.X, Buttons[i].Rect.Y, Buttons[i].Rect.Width, Buttons[i].Rect.Height), new Rectangle(0, 0, Buttons[i].Rect.Width, Buttons[i].Rect.Height), GraphicsUnit.Pixel);
                    }
                }
            }

            Bitmap mybit = new Bitmap(bb.Width, (bb.Height / 2) + 1);
            Graphics ge = Graphics.FromImage(mybit);
            ge.FillRectangle(Brushes.White, 0, 0, mybit.Width, mybit.Height);

            maketransparent(mybit, 60);
            g.DrawImage(mybit, new Point(0, 0));
            //            g.DrawImage(mybit, new Point(0, -10));

            return bb;
        }

        private void setColor(int status)
        {

            if (status == 1)
            {
                nAreaColor = Color.Lime;
                nlineColor = Color.DarkGreen;
            }
            else if (status == 2)
            {
                nAreaColor = Color.Red;
                nlineColor = Color.DarkRed;
            }
            else
            {
                nAreaColor = Color.Gray;
                nlineColor = Color.DarkGray;
            }
        }

        private void maketransparent(Bitmap userBitmap, byte level)
        {
            try
            {
                PixelFormat pf = PixelFormat.Format32bppArgb;
                BitmapData bmData = userBitmap.LockBits(new Rectangle(0, 0, userBitmap.Width, userBitmap.Height), ImageLockMode.ReadWrite, pf);
                System.IntPtr Scan0 = bmData.Scan0;
                int curx;

                unsafe
                {
                    byte* p = (byte*)(void*)Scan0;
                    int nWidth = (userBitmap.Width * userBitmap.Height);
                    for (int x = 0; x < nWidth; x++)
                    {
                        curx = x * 4;
                        if (p[curx] > 0 || p[curx + 1] > 0 || p[curx + 2] > 0)
                        {
                            p[curx + 3] = level;
                        }
                    }
                }
                userBitmap.UnlockBits(bmData);
            }
            catch (Exception ex)
            {

            }
        }

        public Bitmap bPlay(int status)
        {
            setColor(status);

            Bitmap bb = new Bitmap(24, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 0;
            int addY = 0;

            Size r = new Size(12, 12);

            addX = (bb.Width - r.Width) / 2;
            addY = (bb.Height - r.Height) / 2;

            Point[] cPoint = new Point[3];

            cPoint[0] = new Point(addX, addY);
            cPoint[1] = new Point((r.Width) + addX, (r.Height / 2) + addY);
            cPoint[2] = new Point(addX, r.Height + addY);

            g.FillPolygon(new SolidBrush(nAreaColor), cPoint);
            g.DrawPolygon(new Pen(new SolidBrush(nlineColor)), cPoint);


            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }

        public Bitmap bNext(int status)
        {
            setColor(status);

            Bitmap bb = new Bitmap(24, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 2;
            int addY = 4;

            Size r = new Size(6, 12);

            addX = (bb.Width - 15) / 2;
            addY = (bb.Height - r.Height) / 2;

            Point[] cPoint = new Point[3];
            cPoint[0] = new Point(addX, addY);
            cPoint[1] = new Point(r.Width + addX, (bb.Height / 2));
            cPoint[2] = new Point(addX, r.Height + addY);

            g.FillPolygon(new SolidBrush(nAreaColor), cPoint);
            // g.DrawPolygon(new Pen(new SolidBrush(nActivelineColor)), cPoint);

            addX += 6;
            cPoint[0] = new Point(addX, addY);
            cPoint[1] = new Point(r.Width + addX, (bb.Height / 2));
            cPoint[2] = new Point(addX, r.Height + addY);

            g.FillPolygon(new SolidBrush(nAreaColor), cPoint);

            //  g.DrawPolygon(new Pen(new SolidBrush(nActivelineColor)), cPoint);

            addX += 7;
            r = new Size(2, 12);

            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r.Width, r.Height));
            //g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r.Width, r.Height));

            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }

        public Bitmap bPrev(int status)
        {
            setColor(status);

            Bitmap bb = new Bitmap(24, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 2;
            int addY = 4;

            Size r = new Size(2, 12);

            addX = (bb.Width - 15) / 2;
            addY = (bb.Height - r.Height) / 2;


            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r.Width, r.Height));
            //g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r.Width, r.Height));

            r = new Size(6, 12);

            addX += 3;

            Point[] cPoint = new Point[3];
            cPoint[0] = new Point(r.Width + addX, addY);
            cPoint[1] = new Point(addX, (bb.Height / 2));
            cPoint[2] = new Point(r.Width + addX, r.Height + addY);

            g.FillPolygon(new SolidBrush(nAreaColor), cPoint);
            //g.DrawPolygon(new Pen(new SolidBrush(nlineColor)), cPoint);

            addX += 6;
            cPoint[0] = new Point(r.Width + addX, addY);
            cPoint[1] = new Point(addX, (bb.Height / 2));
            cPoint[2] = new Point(r.Width + addX, r.Height + addY);

            g.FillPolygon(new SolidBrush(nAreaColor), cPoint);
            //g.DrawPolygon(new Pen(new SolidBrush(nlineColor)), cPoint);


            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }


        public void setSelect(int index)
        {
            for (int i = 0; i < Buttons.Length; i++)
            {
                if (Buttons[i].status == 1) Buttons[i].status = 0;
            }

            selectedItem = index;
            refresh();
        }

        public void refresh()
        {
            pbox.Image = (Image)createbar();
        }

        public Bitmap bPause(int status)
        {
            setColor(status);
            Bitmap bb = new Bitmap(24, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 1;
            int addY = 3;

            Size[] r = new Size[2];
            r[0] = new Size(3, 12);
            r[1] = new Size(3, 12);

            addX = (bb.Width - (r[0].Width * 3)) / 2;
            addY = (bb.Height - r[0].Height) / 2;

            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r[0].Width, r[0].Height));
            g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r[0].Width, r[0].Height));

            addX += (r[0].Width * 2);
            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r[1].Width, r[1].Height));
            g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r[1].Width, r[1].Height));

            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }

        public Bitmap bStop(int status)
        {
            setColor(status);
            Bitmap bb = new Bitmap(24, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 8;
            int addY = 3;

            Size r = new Size(12, 12);
            addX = (bb.Width - r.Width) / 2;
            addY = (bb.Height - r.Height) / 2;

            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r.Width, r.Height));
            g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r.Width, r.Height));

            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }

        public Bitmap bVolumn(int status)
        {
            setColor(status);
            Bitmap bb = new Bitmap(5, 20);
            Graphics g = Graphics.FromImage(bb);
            g.Clear(nBackColor);

            int addX = 8;
            int addY = 3;

            Size r = new Size(2, 5);
            addX = (bb.Width - r.Width) / 2;
            addY = (bb.Height - r.Height) / 2;

            g.FillRectangle(new SolidBrush(nAreaColor), new Rectangle(addX, addY, r.Width, r.Height));
            g.DrawRectangle(new Pen(new SolidBrush(nAreaColor), 1), new Rectangle(addX, addY, r.Width, r.Height));

            g.DrawRectangle(new Pen(new SolidBrush(nlineColor)), new Rectangle(1, 1, bb.Width - 2, bb.Height - 2));

            return bb;
        }

    }
}
