using System;
using System.Collections.Generic;
using System.Text;
using System.Management;
using System.Windows.Forms;
using System.Net.NetworkInformation;

namespace QuranNavigator
{

    public class regme
    {

        public string convertCPUid(string cpuid)
        {
            string tmpstring = replacevalue(cpuid);
            return tmpstring;
        }

        public string replacevalue(string txt)
        {
            txt = txt.ToLower();
            string tmp = "";
            string[] tmpstr = { "6", "7", "9", "8", "a", "e", "b", "d", "e", "2", "f", "1", "3", "4", "5", "0" };
            if (txt.Length > 0)
            {
                for (int i = 0; i < txt.Length; i++)
                {
                    string curchr = txt.Substring(i, 1);
                    int nextvalue = 1;
                    for (int o = 0; o < tmpstr.Length; o++)
                    {
                        if (curchr == tmpstr[o])
                        {
                            nextvalue = o;
                        }
                    }
                    tmp += (nextvalue % 10).ToString();
                }
            }
            return tmp;
        }

        public string replacenondigit(string txt)
        {
            txt = txt.ToLower();
            txt = txt.Replace("a", "1");
            txt = txt.Replace("b", "2");
            txt = txt.Replace("c", "5");
            txt = txt.Replace("d", "9");
            txt = txt.Replace("e", "3");
            txt = txt.Replace("f", "7");
            txt = txt.Replace("s", "0");
            return txt;
        }

        public string getupcid()
        {
            string CPUid = "F0DEBC9A78563412123456789ABCDEF0";
            ManagementObjectSearcher searcher = new ManagementObjectSearcher("select * from Win32_Processor");
            try
            {
                foreach (ManagementObject share in searcher.Get())
                {
                    foreach (PropertyData PC in share.Properties)
                    {
                        if (PC.Name.ToLower() == "processorid")
                        {
                            if (PC.Value != null && PC.Value.ToString() != "")
                            {
                                switch (PC.Value.GetType().ToString())
                                {
                                    case "System.String[]":
                                        string[] str = (string[])PC.Value;

                                        string str2 = "";
                                        foreach (string st in str)
                                            str2 += st + " ";

                                        CPUid = str2;
                                        break;
                                    case "System.UInt16[]":
                                        ushort[] shortData = (ushort[])PC.Value;


                                        string tstr2 = "";
                                        foreach (ushort st in shortData)
                                            tstr2 += st.ToString() + " ";

                                        CPUid = tstr2;
                                        break;

                                    default:
                                        CPUid = PC.Value.ToString();
                                        break;
                                }
                            }
                            else
                            {
                                bool DontInsertNull = false;
                                if (!DontInsertNull)
                                {
                                    //CPUid = "No Information available";
                                    CPUid = GetMACAddress();// "0495123412341234";
                                }
                                else
                                    continue;
                            }

                        }
                    }

                }
            }
            catch (Exception exp)
            {
                // must be remove in final released version
                //MessageBox.Show(exp.Message);
                CPUid = GetMACAddress();// "0495123412341234";

            }

            CPUid += "F0DEBC0A78563412123456789ABCDEF0";
            return replaceComputerID(CPUid.Substring(0, 16));
        }

        public string GetMACAddress()
        {
            string macStr = "";
            try
            {
                NetworkInterface[] interfaces = NetworkInterface.GetAllNetworkInterfaces();

                foreach (NetworkInterface adapter in interfaces)
                {
                    PhysicalAddress address = adapter.GetPhysicalAddress();
                    byte[] mac = address.GetAddressBytes();
                    for (int i = 0; i < mac.Length; i++)
                    {
                        macStr += mac[i].ToString() + "";
                    }
                    macStr += "8";
                }
            }
            catch (Exception ex)
            {
                macStr = "0495333312223495";
            }
            if (macStr == "-" || macStr == "") macStr = "0495333312223495";
            return macStr;
        }


        public string replaceComputerID(string oldCode)
        {
            oldCode = replacenondigit(oldCode);

            string[] code = new string[16];
            string[] codex = new string[16];

            code[0] = "850" + "14329" + "76";
            code[1] = "591" + "603" + "2487";
            code[2] = "2456" + "038" + "791";
            code[3] = "34" + "08127" + "956";
            code[4] = "735" + "198" + "4620";
            code[5] = "15" + "38027" + "694";
            code[6] = "910" + "28635" + "47";
            code[7] = "392" + "5481" + "760";
            code[8] = "54" + "290" + "738" + "61";
            code[9] = "0786" + "542" + "139";
            code[10] = "45" + "627319" + "08";
            code[11] = "1630" + "84" + "9752";
            code[12] = "62" + "94587" + "130";
            code[13] = "570" + "9341" + "268";
            code[14] = "694" + "37520" + "18";
            code[15] = "4590" + "3276" + "18";

            codex[0] = "96" + "05413" + "728";
            codex[1] = "60" + "17342" + "598";
            codex[2] = "78" + "24510" + "963";
            codex[3] = "46" + "0125" + "3798";
            codex[4] = "38952" + "7061" + "4";
            codex[5] = "830" + "15967" + "42";
            codex[6] = "25" + "13806" + "794";
            codex[7] = "843" + "1672" + "905";
            codex[8] = "073" + "5948" + "162";
            codex[9] = "596" + "7483" + "201";
            codex[10] = "718" + "34592" + "60";
            codex[11] = "4658" + "790" + "231";
            codex[12] = "207" + "5486" + "931";
            codex[13] = "273" + "10984" + "56";
            codex[14] = "69" + "17053" + "842";
            codex[15] = "691" + "7053" + "842";

            for (int i = 0; i < 16; i++)
            {
                code[i] = reverseString(code[i]);
                codex[i] = reverseString(codex[i]);
            }

            string newCode = "";
            string returnCode = "Fa20";
            string curOldCode = "";
            string lastOldCode = "";

            for (int i = 4; i < 16; i++)
            {
                curOldCode = oldCode.Substring(i, 1);
                lastOldCode = oldCode.Substring(i - 1, 1);

                if ("24680".IndexOf(lastOldCode) > -1)
                {
                    newCode = code[i].Substring(Convert.ToInt32(curOldCode), 1);
                }
                else
                {
                    newCode = codex[i].Substring(Convert.ToInt32(curOldCode), 1);
                }
                returnCode += newCode;
            }
            //MessageBox.Show(returnCode);
            return returnCode;

        }

        public string reverseString(string txt)
        {
            string tt = "";
            for (int i = 0; i < txt.Length; i++)
            {
                tt = txt.Substring(i, 1) + tt;
            }
            return tt;
        }
        
        public string realcode = "";

        public int val(string txt)
        {
            try
            {
                return Convert.ToInt32(txt);
            }
            catch
            {
                return 9;
            }
        }

        public bool chkValidID(string txt)
        {
            realcode = "";

            txt = txt.ToLower();
            if (txt.Length != 16) return false;
            if (txt.Substring(0, 2) != "d" + "s") return false;

            txt = replacenondigit(txt);

            int[] digit = new int[16];

            for (int i = 0; i < 16; i++)
            {
                digit[i] = val(txt.Substring(i, 1));
            }

            int[] codex = new int[4];

            codex[0] = (digit[4] + digit[8] + 1) % 10;
            codex[1] = (digit[5] + digit[9] + 3) % 10;
            codex[2] = (digit[6] + digit[10] + 9) % 10;
            codex[3] = (digit[7] + digit[11] + 3) % 10;

            realcode = codex[0].ToString() + codex[1].ToString() + codex[2].ToString() + codex[3].ToString();

            if (codex[0] == digit[12] && codex[1] == digit[13] && codex[2] == digit[14] && codex[3] == digit[15]) return true;
            return false;
        }

        public string getvatid(string txt, string txt2)
        {
            txt = txt.ToLower();
            txt2 = txt2.ToLower();

            if (!chkValidID(txt)) return "codex1err";

            string tm2 = convertCPUid(getupcid());
            if (tm2 != txt2) return "codex2err " + tm2 + " <> " + txt2;

            int[] codex = new int[16];
            int[] value = { 3, 5, 0, 9, 9, 0, 1, 0, 7, 8, 6, 1 };

            string codex3 = "FA20";
            for (int i = 4; i < 16; i++)
            {
                int ood;
                for (int o2 = 0; o2 < 200; o2++)
                {
                    ood = o2 * 333;
                }

                codex[i] = (val(txt.Substring(i, 1)) + val(txt2.Substring(i, 1)) + value[i - 4]) % 10;
                codex3 += codex[i].ToString();
                if (codex[i] == i)
                    ood = 344 * i;
                else
                    ood = 544 * i;
            }
            //return codex3;
            return getCodeLevel2(codex3);
        }
        
        public string getCodeLevel2(string oldCode)
        {
            string[] code = new string[16];
            string[] codex = new string[16];

            code[0] = "14" + "230" + "798" + "65";
            code[1] = "0786" + "139" + "542";
            code[2] = "30" + "94587" + "162";
            code[3] = "34" + "08127" + "956";
            code[4] = "198" + "735" + "4620";
            code[5] = "15" + "38694" + "027";
            code[6] = "268" + "9341" + "570";
            code[7] = "694" + "37520" + "18";
            code[8] = "4590" + "3276" + "18";
            code[9] = "850" + "14329" + "76";
            code[10] = "248" + "603" + "5917";
            code[11] = "2791" + "038" + "456";
            code[12] = "08" + "627319" + "45";
            code[13] = "9752" + "84" + "1630";
            code[14] = "407" + "28635" + "91";
            code[15] = "542" + "3981" + "760";

            codex[0] = "78" + "24510" + "963";
            codex[1] = "46" + "0125" + "3798";
            codex[2] = "96" + "05413" + "728";
            codex[3] = "60" + "17342" + "598";
            codex[4] = "38952" + "7061" + "4";
            codex[5] = "596" + "7483" + "201";
            codex[6] = "207" + "5486" + "931";
            codex[7] = "69" + "17053" + "842";
            codex[8] = "691" + "7053" + "842";
            codex[9] = "273" + "10984" + "56";
            codex[10] = "830" + "15967" + "42";
            codex[11] = "25" + "13806" + "794";
            codex[12] = "843" + "1672" + "905";
            codex[13] = "718" + "34592" + "60";
            codex[14] = "4658" + "790" + "231";
            codex[15] = "073" + "5948" + "162";

            string newCode = "";
            string returnCode = "DS20";
            string curOldCode = "";
            string lastOldCode = "";
            
            for (int i = 4; i < 16; i++)
            {
                curOldCode = oldCode.Substring(i, 1);
                lastOldCode = oldCode.Substring(i - 1, 1);

                if ("24680".IndexOf(lastOldCode) > -1)
                {
                    newCode = code[i].Substring(Convert.ToInt32(curOldCode),1);
                }
                else
                {
                    newCode = codex[i].Substring(Convert.ToInt32(curOldCode), 1);
                }
                returnCode += newCode;
            }
            //MessageBox.Show(returnCode);
            return getCodeLevel3(returnCode);
        }

        public string getCodeLevel3(string oldCode)
        {
            // calc first 4 digit
            int[] scode = new int[16];
            int[] scodex = new int[16];

            // convert string to int
            for (int i = 4; i < 16; i++)
            {
                scode[i] = val(oldCode.Substring(i, 1));
            }

            scodex[0] = (scode[4] + scode[8] + scode[12]) % 10;
            scodex[1] = (scode[11] + scode[9] + scode[5]) % 10;
            scodex[2] = (scode[7] + scode[10] + scode[13]) % 10;
            scodex[3] = (scode[14] + scode[15] + scode[6]) % 10;


            scodex[4] = (scode[1] + scode[4] + scode[15] + scode[6] + 6) % 10;
            scodex[5] = (scode[2] + scode[5] + scode[9] + scode[1] + 2) % 10;
            scodex[6] = (scode[3] + scode[6] + scode[14] + scode[4] + 2) % 10;
            scodex[7] = (scode[4] + scode[7] + scode[8] + scode[6] + 5) % 10;
            scodex[8] = (scode[5] + scode[8] + scode[10] + scode[12]) % 10;
            scodex[9] = (scode[10] + scode[9] + scode[7] + scode[5] + 3) % 10;
            scodex[10] = (scode[10] + scode[10] + scode[11] + scode[0] + 5) % 10;
            scodex[11] = (scode[5] + scode[11] + scode[6] + scode[3] + 1) % 10;
            scodex[12] = (scode[4] + scode[12] + scode[12] + scode[5] + 4) % 10;
            scodex[13] = (scode[3] + scode[13] + scode[5] + scode[15] + 6) % 10;
            scodex[14] = (scode[2] + scode[14] + scode[13] + scode[9] + 2) % 10;
            scodex[15] = (scode[1] + scode[15] + scode[4] + scode[5] + 4) % 10;

            string ret = "";
            for (int i = 0; i < 16; i++)
            {
                ret += scodex[i].ToString();
            }
            ret += "39790495729304863627294567";

            return ret.Substring(0, 16);

            string[] code = new string[16];
            string[] codex = new string[16];

            code[0] = "4590" + "328776" + "18";
            code[1] = "850" + "143269" + "766";
            code[2] = "2485" + "603" + "55917";
            code[3] = "27961" + "038" + "4556";
            code[4] = "084" + "627319" + "425";
            code[5] = "30" + "3945787" + "162";
            code[6] = "384" + "08127" + "9562";
            code[7] = "1918" + "735" + "46200";
            code[8] = "15" + "38694" + "02756";
            code[9] = "25" + "1380476" + "794";
            code[10] = "84383" + "1672" + "905";
            code[11] = "38952" + "7061" + "429";
            code[12] = "596" + "748103" + "201";
            code[13] = "073" + "594882" + "162";
            code[14] = "78" + "2451740" + "963";
            code[15] = "26568" + "9341" + "570";

            codex[0] = "2037" + "5486" + "9831";
            codex[1] = "69" + "167053" + "8482";
            codex[2] = "7118" + "345292" + "60";
            codex[3] = "46558" + "790" + "2361";
            codex[4] = "6994" + "37520" + "108";
            codex[5] = "6915" + "70653" + "842";
            codex[6] = "273" + "109847" + "596";
            codex[7] = "97512" + "84" + "16230";
            codex[8] = "4307" + "28635" + "951";
            codex[9] = "542" + "398671" + "760";
            codex[10] = "1954" + "230" + "798" + "65";
            codex[11] = "830" + "1596767" + "42";
            codex[12] = "46" + "0125" + "379898";
            codex[13] = "96" + "0541333" + "728";
            codex[14] = "6560" + "17342" + "598";
            codex[15] = "4658" + "77890" + "231";

            string newCode = "";
            string returnCode = "DS20";
            string curOldCode = "";
            string lastOldCode = "";

            int[] b = { 9, 3, 11, 6, 0, 2, 1, 5, 8, 4, 7, 10 };
            int[] b2 = { 8, 2, 4, 3, 7, 9, 10, 0, 6, 11, 1, 5 };

            for (int i = 0; i < 12; i++)
            {
                string curc = oldCode.Substring(b[i] + 4, 1);
                if ("02468".IndexOf(curc) > -1)
                {
                    newCode = code[b2[i]].Substring(i, 1);
                }
                else
                {
                    newCode = codex[b2[i]].Substring(i, 1);
                }
                returnCode += newCode;
            }
            //MessageBox.Show(returnCode);

            ///
            string[] returntmpcode = new string[16];
            for (int i = 0; i < returnCode.Length; i++)
            {
                returntmpcode[i] = returnCode.Substring(i, 1);               
            }

            int v1 = (int)(val(returntmpcode[2]) * val(returntmpcode[5]) + val(returntmpcode[10]) - val(returntmpcode[14]));
            int v2 = (int)(val(returntmpcode[3]) * val(returntmpcode[4]) + val(returntmpcode[11]) - val(returntmpcode[12]));
            string strv1 = v1.ToString().Substring(v1.ToString().Length - 1);
            string strv2 = v2.ToString().Substring(v2.ToString().Length - 1);
            if (strv1 == "0" || strv1 == ".") strv1 = "7";
            if (strv2 == "0" || strv2 == ".") strv2 = "3";
            returntmpcode[2] = strv1;
            returntmpcode[3] = strv2;

            returnCode = "";
            for (int i = 0; i < 16; i++)
            {
                returnCode += returntmpcode[i];
            }

            ///

            return returnCode;
        }

    }

}
