using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;
using System.Collections;

namespace QuranNavigator
{
    public class sTitle
    {

        public byte[] exportFile(string compactfile, int fileno)
        {
            Cab rom = new Cab();
            Cab.CabInfo usercab = rom.getCabInfo(compactfile, "I love SdWr & Fiyah");
            byte[] myByte = rom.ExportRawString(usercab, fileno);
            rom = null;
            return myByte;
        }

        public string getExportFile(string compactfile, int fileno, Encoding encode)
        {
            byte[] bt = exportFile(compactfile, fileno);
            string buf = encode.GetString(bt);
            return buf;
        }

        public string[] getExportFileLine(string compactfile, int fileno, Encoding encode)
        {
            string buf = getExportFile(compactfile, fileno, encode);
            buf = buf.Replace("\r", "");
            if (buf.EndsWith("\n"))
            {
                buf = buf.Substring(0, buf.Length - 1);
            }
            string[] line = buf.Split("\n".ToCharArray());
            return line;
        }


        public void importFile(string compactfile, string[] filename)
        {
            Cab rom = new Cab();
            string path = @"D:\Documents and Settings\Terabus\Desktop\";
            rom.compactFile(filename, path + compactfile, "I love SdWr & Fiyah", false, path.Length + 1);

        }

        public sTitle(TreeView treeview)
        {
            treeView1 = treeview;

            Tree = new ArrayList[6];
            for (int i = 0; i < Tree.Length; i++)
            {
                Tree[i] = new ArrayList();
            }

            //importFile("root", new string[] { Quran.proglocation + @"data\root.inf" });
           
            //importFile("titleaya", new string[] { Quran.proglocation + @"data\Titleaya.txt",
            //Quran.proglocation + @"data\titles.inf"});

            SearchAya = new _searchTitleAya[3000];
            int o = 0;

            string[] tt = getExportFileLine(Quran.proglocation + "data\\titleaya", 0, Encoding.Default);

            //System.IO.File.WriteAllLines(@"c:\3.txt", tt);

            for (int i = 0; i < tt.Length; i++)
            {
                string[] ttt = tt[i].Split(new char[] { '@' });
                SearchAya[o].name = ttt[0];
                SearchAya[o].aya = ttt[1];
                o++;
            }

            string curLang = Quran.langInfo[QuranSetting.Default.LanguageID].location;
            if ("|ar|en|fr|th|ma|".IndexOf("|" + curLang.ToLower() + "|") == -1)
            {
                curLang = "en";
            }
            Encoding enCoding = Encoding.UTF32;
            if (curLang.ToLower() == "th") enCoding = Encoding.GetEncoding(874);

            string[] sTitle = getExportFileLine(Quran.proglocation + "data\\titleaya", 1, Encoding.Default);

            String[] sTitle2 = File.ReadAllLines(Quran.proglocation + @"Lang\" + curLang + @"\titles.txt", enCoding);

            //System.IO.File.WriteAllLines(@"c:\1.txt", sTitle);
            //System.IO.File.WriteAllLines(@"c:\2.txt", sTitle2);


            TitleString = new _searchTitle[sTitle.Length];
            for (int i = 0; i < sTitle.Length; i++)
            {
                TitleString[i] = new _searchTitle();
                TitleString[i].name = sTitle2[i].Replace("[", "").Replace("]", "");
                if (sTitle[i].StartsWith("Tree"))
                    TitleString[i].isParent = true;
                else
                    TitleString[i].isParent = false;

                TitleString[i].child = sTitle[i].Substring(17);
                TitleString[i].floor = TitleString[i].child.Split(new char[] { '-' }).Length;

            }

            surahInfo = new surainfo[114];
            int[] Aya = { 7, 286, 200, 176, 120, 165, 206, 75, 129, 109, 123, 111, 43, 52, 99, 128, 111, 110, 98, 135, 112, 78, 118, 64, 77, 227, 93, 88, 69, 60, 34, 30, 73, 54, 45, 83, 182, 88, 75, 85, 54, 53, 89, 59, 37, 35, 38, 29, 18, 45, 60, 49, 62, 55, 78, 96, 29, 22, 24, 13, 14, 11, 11, 18, 12, 12, 30, 52, 52, 44, 28, 28, 20, 56, 40, 31, 50, 40, 46, 42, 29, 19, 36, 25, 22, 17, 19, 26, 30, 20, 15, 21, 11, 8, 8, 19, 5, 8, 8, 11, 11, 8, 3, 9, 5, 4, 7, 3, 6, 3, 5, 4, 5, 6 };
            int line = 0;
            for (int i = 0; i < 114; i++)
            {
                surahInfo[i].ayaCount = Aya[i];
                surahInfo[i].strTitle = Quran.SuraTable[i].strTitle;
                surahInfo[i].line = line;
                line += Aya[i];
            }


            for (int i = 0; i < 14; i++)
            {
                Tree[0].Add(TitleString[i].name + "_" + i.ToString());
            }

        }

        public string getSelectAya(string txt)
        {
            string SearchStr = "";

            for (int i = 0; i < SearchAya.Length; i++)
            {
                if (SearchAya[i].name == txt)
                {
                    SearchStr = SearchAya[i].aya;
                    break;
                }
            }
            return SearchStr;
        }

        public ListBox listBox1;

        public ArrayList[] Tree;

        public struct _searchTitle
        {
            public string name;
            public string child;
            public bool isParent;
            public int floor;
        }

        public _searchTitle[] TitleString;
        public _searchTitleAya[] SearchAya;
        public int curLevel = 0;
        public struct surainfo
        {
            public int ayaCount;
            public string strTitle;
            public int line;
        }
        public surainfo[] surahInfo;


        public struct _searchTitleAya
        {
            public string name;
            public string aya;
        }

        public string[] showVerse(int CurSearchTitle)
        {
            string[] ayas = null;
            if (!TitleString[CurSearchTitle].isParent)
            {
                ayas = getVerse(CurSearchTitle);
            }
            return ayas;
        }


        public string[] getVerse(int ChildID)
        {

            string txt = TitleString[ChildID].child;
            string itemFound = "";
            for (int i = 0; i < SearchAya.Length; i++)
            {
                if (txt == SearchAya[i].name)
                {
                    itemFound = SearchAya[i].aya;
                    break;
                }
            }

            return itemFound.Split(new char[] { ';' });
        }

        public string[] getVerse(String ChildStr)
        {
            string txt = ChildStr;
            string itemFound = "";
            for (int i = 0; i < SearchAya.Length; i++)
            {
                if (txt == SearchAya[i].name)
                {
                    itemFound = SearchAya[i].aya;
                    break;
                }
            }

            return itemFound.Split(new char[] { ';' });
        }


        public string HTMLString(string titleText)
        {
            StringBuilder webBrowse = new StringBuilder("<html><head>");

            webBrowse.Append("\r\n<script>");
            webBrowse.Append("\r\nfunction openme(surano,ayano){");
            webBrowse.Append("\r\nlocation.href='s'+surano+':'+ayano");
            webBrowse.Append("\r\n}");
            webBrowse.Append("\r\n</script>\r\n");
            
            webBrowse.Append("</head><body width='100%' dir='rtl' style='background-color: #FFFFFF'>");

            string[] verses = getVerse(titleText);
            if (verses != null)
            {

                loadLang();
                webBrowse.Append("<table border='0' cellpadding='0' cellspacing='0'>");
                string[] userColor = { "#E4F8D3", "#FFFFCC" };
                for (int i = 0; i < verses.Length; i++)
                {
                    string[] t = verses[i].Split(new char[] { ':' });
                    int sura = val(t[0]);
                    int aya = val(t[1]);
                    int curno = 0;
                    if (i % 2 == 0) curno = 1;
                    webBrowse.Append("<tr onclick='openme(" + sura.ToString() + ", " + aya.ToString() + ")' style='cursor:pointer;background-color: " + userColor[curno] + ";'><td width='30' valign='top' align='center'>" + (i + 1).ToString() + "</td><td><p style='text-align: justify;direction: rtl;'><font face='Traditional Arabic' size='5'>" + getAyaString(sura, aya) + "</font>&nbsp;&nbsp;&nbsp;&nbsp;<font face='Traditional Arabic' size='4'>{" + surahInfo[sura - 1].strTitle + ":" + aya.ToString() + "}</font></p></td></tr>");
                    webBrowse.Append("<tr style='background-color: #ffffff;'><td width='30' valign='top' align='center'>&nbsp;</td><td><p style='text-align: left;direction: ltr;font-family: Tahoma; font-size: 12pt'>" + FormatString(getAyaStringOtherLang(sura, aya)) + "&nbsp;&nbsp;&nbsp;&nbsp;<span style='font-family: Tahoma; font-size: 10pt'>[" + OtherLangChapters[sura - 1] + ":" + aya.ToString() + "]</p></td></tr>");
                }

                unloadLang();
                webBrowse.Append("</table>");
            }
            webBrowse.Append("</body></html>");
            return webBrowse.ToString();
        }

        private int val(string txt)
        {
            try
            {
                return Convert.ToInt32(txt);
            }
            catch
            {
                return 0;
            }
        }

        private string repl(string txt)
        {
            int x = txt.IndexOf(";");
            if (x > -1)
            {
                txt = txt.Substring(0, x) + "@" + txt.Substring(x + 1);
            }
            else
            {
                MessageBox.Show("Error : " + txt);
            }
            return txt;
        }

        public string[] getChild(int ChildID)
        {
            string[] txt;
            int CurFloor = TitleString[ChildID].floor;
            txt = new string[2000];
            int curtxt = 0;
            for (int i = 0; i < TitleString.Length; i++)
            {
                string t = "";
                if (TitleString[i].isParent) t = "[]";

                if (TitleString[i].child.StartsWith(TitleString[ChildID].child) && TitleString[i].floor == (CurFloor + 1))
                {
                    txt[curtxt] = t + TitleString[i].name + "_" + i.ToString();
                    curtxt++;
                }
            }
            Array.Resize(ref txt, curtxt);
            return txt;
        }

        string[] ArabLang;
        string[] OtherLang;
        string[] OtherLangChapters;

        public void loadLang()
        {
            ArabLang = File.ReadAllLines(Quran.proglocation + "Tran\\arb.txt", Encoding.GetEncoding(1256));
            OtherLang = File.ReadAllLines(Quran.proglocation + "tran\\" + Quran.translationInfo[QuranSetting.Default.TranslationID].location + ".txt", Encoding.GetEncoding(874));
            OtherLangChapters = File.ReadAllLines(Quran.proglocation + "tran\\" + Quran.translationInfo[QuranSetting.Default.TranslationID].location + ".lst", Encoding.GetEncoding(874));
        }

        public void unloadLang()
        {
            ArabLang = null;
            OtherLang = null;
            OtherLangChapters = null;
        }

        public string getAyaString(int sura, int aya)
        {
            int userLine = surahInfo[sura - 1].line + (aya - 1);
            return ArabLang[userLine];
        }

        public string getAyaStringOtherLang(int sura, int aya)
        {
            int userLine = surahInfo[sura - 1].line + (aya - 1);
            return OtherLang[userLine];
        }

        private string FormatString(string txt)
        {
            string[] tx = txt.Replace("<bookmark>", "^").Split(new char[] { '^' });

            for (int i = 0; i < 21; i++)
            {
                tx[0] = tx[0].Replace("(*" + i.ToString() + ")", "(*" + i.ToString() + "*)");
                tx[0] = tx[0].Replace("(" + i.ToString() + "*)", "(*" + i.ToString() + "*)");
                tx[0] = tx[0].Replace("(*" + i.ToString() + "*)", "<font style='font-family: Tahoma; font-size: 10pt'><sup>[" + i.ToString() + "]</sup></font>");
            }

            if (tx.Length == 2)
            {
                for (int i = 1; i < 21; i++)
                {
                    tx[1] = tx[1].Replace("(" + i.ToString() + ")", "<br />[" + i.ToString() + "]");
                }
            }

            txt = "<p style='text-indent: 30px;font-family: Tahoma; font-size: 12pt; text-align: justify; direction: ltr;'>" + tx[0] + "&nbsp;";

            //if (tx.Length > 1) txt += "<p style='color: #666633;font-family: Tahoma; font-size: 10pt; margin-left: 30px;text-align: justify; direction: ltr;'>" + tx[1] + "</p>";

            return txt;
        }

        public void CreateTree()
        {
            treeView1.BeginUpdate();
            treeView1.Nodes.Clear();
            for (int i = 0; i < Tree[0].Count; i++)
            {
                TreeNode td = new TreeNode(TitleString[i].name, 0, 1);
                td.Tag = TitleString[i].child;
                treeView1.Nodes.Add(td);
            }


            for (int i = Tree[0].Count; i < TitleString.Length; i++)
            {
                int imgid = 0;
                if (!TitleString[i].isParent) imgid = 2;

                string[] alllvl = getAllLevel(TitleString[i].child);

                TreeNode curNode = new TreeNode();
                for (int o = 0; o < alllvl.Length - 1; o++)
                {
                    if (o == 0)
                    {
                        curNode = getNode(null, alllvl[o]);
                    }
                    else
                    {
                        curNode = getNode(curNode, alllvl[o]);
                    }
                }
                int imgid2 = imgid + 1;

                TreeNode tNewNode = new TreeNode(TitleString[i].name, imgid, imgid2);
                tNewNode.Tag = TitleString[i].child;
                curNode.Nodes.Add(tNewNode);
            }
            treeView1.EndUpdate();
        }

        private string[] getAllLevel(string text)
        {
            string[] tx = text.Split(new char[] { '-' });
            string[] item = new string[tx.Length - 2];
            item[0] = tx[0] + "-" + tx[1] + "-";
            for (int i = 1; i < item.Length; i++)
            {
                if (item.Length > i) item[i] = item[i - 1] + tx[i + 1] + "-";
            }
            return item;
        }

        public TreeView treeView1;

        private TreeNode getNode(TreeNode userNode, string text)
        {
            TreeNode tn = new TreeNode();

            if (userNode == null)
            {
                for (int i = 0; i < treeView1.Nodes.Count; i++)
                {
                    if (treeView1.Nodes[i].Tag.ToString() == text) return treeView1.Nodes[i];
                }
            }
            else
            {
                for (int i = 0; i < userNode.Nodes.Count; i++)
                {
                    if (userNode.Nodes[i].Tag.ToString() == text) return userNode.Nodes[i];
                }
            }

            return tn;
        }


    }

}