using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;
using System.IO;
using System.IO.Compression;

namespace QuranNavigator
{
    class sdCab
    {
    }

    class Data
    {

        private int randomInt = 250;

        public struct DBInfo
        {
            public string src;
            public string password;
            public int count;
            public int countField;
            public bool isDb;
            public bool isPassword;
            public bool isCompress;
            public bool isReady;
            public int firstRow;
            public int lastRow;
            public int NoRecAddr;
            public int nextRow;
            public int prevRow;
            private FileStream db;
            public bool isOpening;
            private Cab mycab;
            private BinaryReader br;
            private string[] mystring;

            public void moveNext()
            {
                int lastAddr = Convert.ToInt32(db.Position);
                int NextAddr = 0, PrevAddr = 0;
                bool okRow = br.ReadBoolean();
                PrevAddr = br.ReadInt32();
                NextAddr = br.ReadInt32();
                db.Position = NextAddr;
            }

            public void movePrevious()
            {
                int lastAddr = Convert.ToInt32(db.Position);
                int NextAddr = 0, PrevAddr = 0;
                bool okRow = br.ReadBoolean();
                PrevAddr = br.ReadInt32();
                NextAddr = br.ReadInt32();

                db.Position = PrevAddr;
            }

            public void moveFirst()
            {
                db.Position = firstRow;
            }
            public void moveLast()
            {
                db.Position = lastRow;
            }
            public void openDB()
            {
                if (!isReady) return;
                if (!isOpening)
                {
                    db = new FileStream(src, FileMode.Open, FileAccess.ReadWrite);
                    br = new BinaryReader(db);
                    mystring = new string[countField];
                }
                db.Position = firstRow;
                mycab = new Cab();
                isOpening = true;
            }

            public void closeDB()
            {
                if (isOpening)
                {
                    br.Close();
                    db.Close();
                    mycab = null;
                    isOpening = false;
                }
            }

            public void addItem(string[] strRow)
            {
                if (!isOpening) return;

                db.Seek(-8, SeekOrigin.End);

                bool okRow = true;
                int size = 0;

                // Save LastAddr
                int previousAddr = 0;
                previousAddr = lastRow;

                // Save new LastRowPosition
                lastRow = Convert.ToInt32(db.Position);

                BinaryWriter wr = new BinaryWriter(db);
                wr.Write(okRow);

                // Write PositionofPreviousAndNextRecord
                wr.Write(size);
                wr.Write(size);

                for (int i = 0; i < countField; i++)
                {
                    byte[] buffer = StringToByte(strRow[i]);
                    size = buffer.Length;
                    wr.Write(size);
                    mycab.EncodeSd(buffer, password, false);
                    wr.Write(buffer);
                }

                // Save CurPosition 
                int nextAddr = 0;
                nextAddr = Convert.ToInt32(db.Position);

                // Update Firstrow and lastrow Position

                wr.Write(firstRow);
                wr.Write(lastRow);

                // Write PreviousAddr and NextAddr
                db.Position = lastRow + 1;

                wr.Write(previousAddr);
                wr.Write(nextAddr);

                // Update count of record
                db.Position = NoRecAddr;
                count++;
                wr.Write(count);

                // return to LastPosition
                moveLast();

            }

            public string[] Field()
            {
                //               string[] mystring = new string[countField];
                //                if (!isOpening) return mystring;

                // Save Current Position
                int lastAddr = Convert.ToInt32(db.Position);

                BinaryReader r = new BinaryReader(db);

                db.Seek(9, SeekOrigin.Current);
                byte[] buffer;
                for (int i = 0; i < countField; i++)
                {
                    int size = r.ReadInt32();
                    buffer = new byte[size];
                    buffer = r.ReadBytes(size);
                    mycab.EncodeSd(buffer, password, true);
                    mystring[i] = ByteToString(buffer);
                }
                db.Position = lastAddr;
                return mystring;
            }



            private byte[] StringToByte(string Text)
            {
                return System.Text.Encoding.Unicode.GetBytes(Text);
            }

            private string ByteToString(byte[] bytes)
            {
                return System.Text.Encoding.Unicode.GetString(bytes);
            }


        }
        Cab rom = new Cab();

        private int _stamp = 987654320;
        private byte[] crypto ={ 0, 11, 22, 33, 44, 55, 66, 77, 88, 99, 110, 121, 132, 143, 154, 165, 176, 187, 198, 209, 220, 231, 242, 253, 0 };

        public void CreateDataBase(string DBName, string password, int countField, bool withCompress)
        {
            FileStream fs = new FileStream(DBName, FileMode.Create, FileAccess.Write);
            BinaryWriter r = new BinaryWriter(fs);

            // write stamp format
            r.Write(_stamp);

            // write password check
            int numberOfCrypto = crypto.Length; ;
            byte[] crypto2 = new byte[numberOfCrypto];
            Array.Copy(crypto, crypto2, numberOfCrypto);
            rom.EncodeSd(crypto2, password, false);
            r.Write(crypto2);

            Random rnd = new Random();
            for (int i = 0; i < randomInt; i++)
            {
                r.Write(rnd.Next());
            }

            // WithCompress or not

            r.Write(withCompress);

            // Number of Rows
            r.Write(countField);

            // save Number of Records Address
            int NoRecAddr = Convert.ToInt32(fs.Position);

            // Number of Records
            int count = 0;
            r.Write(count);

            // FirstRow
            int row = Convert.ToInt32(fs.Position);
            r.Write(row);

            // LastRow
            row = Convert.ToInt32(fs.Position);
            r.Write(row);

            //          MessageBox.Show(fs.Position.ToString());
            r.Close();
            fs.Close();
        }

        public DBInfo getDBInfo(string dbFile, string password)
        {

            DBInfo userDB = new DBInfo();
            userDB.isReady = false;
            userDB.isDb = false;
            userDB.isPassword = false;

            if (!File.Exists(dbFile)) return userDB;

            FileStream fs = new FileStream(dbFile, FileMode.Open, FileAccess.Read);
            BinaryReader r = new BinaryReader(fs);

            userDB.src = dbFile;
            userDB.password = password;

            if (isFileFormat(fs)) userDB.isDb = true;
            if (isPasswordOK(fs, password)) userDB.isPassword = true;

            if (!userDB.isDb || !userDB.isPassword) return userDB;

            userDB.isReady = true;

            int numberOfCrypto = crypto.Length;

            // Get WithCompress or not
            int rndint = randomInt * 4;
            userDB.isCompress = ReadBool(fs, numberOfCrypto + 4 + rndint);

            // Get size of each files
            userDB.countField = ReadInt32(fs, numberOfCrypto + 5 + rndint);

            // Get size of each files
            userDB.count = ReadInt32(fs, numberOfCrypto + 9 + rndint);

            // Get Position of RecordCountAddr
            userDB.NoRecAddr = numberOfCrypto + 9 + rndint;
            // Get First and Last row Positions

            fs.Seek(-8, SeekOrigin.End);
            int row = r.ReadInt32();
            userDB.firstRow = row;
            row = r.ReadInt32();
            userDB.lastRow = row;

            r.Close();
            fs.Close();
            return userDB;

        }

        private int ReadInt32(FileStream fs, int Position)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadInt32();
        }

        private bool ReadBool(FileStream fs, int Position)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadBoolean();
        }

        private byte[] ReadBytes(FileStream fs, int Position, int count)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadBytes(count);
        }

        private Boolean isFileFormat(FileStream fs)
        {
            int userStamp = ReadInt32(fs, 0);
            if (userStamp == _stamp) return true;
            MessageBox.Show("Unsupport File Format");
            return false;
        }

        private Boolean isFileFormat(string compactFile)
        {
            FileStream fs = new FileStream(compactFile, FileMode.Open, FileAccess.Read);
            return isFileFormat(fs);
        }

        private Boolean isPasswordOK(FileStream fs, string password)
        {
            int numberOfCrypto = crypto.Length;
            byte[] bytes = ReadBytes(fs, 4, numberOfCrypto);

            rom.EncodeSd(bytes, password, true);

            bool isPassword = true;
            for (int i = 0; i < 8; i++)
            {
                if (bytes[i] != crypto[i]) isPassword = false;
            }
            if (!isPassword) MessageBox.Show("Incorrect Password");
            return isPassword;
        }


    }

    public class Cab
    {
        private int _stamp = 987654321;
        private byte[] crypto ={ 0, 11, 22, 33, 44, 55, 66, 77, 88, 99, 110, 121, 132, 143, 154, 165, 176, 187, 198, 209, 220, 231, 242, 253, 0 };

        public struct _FileInfo
        {
            public string Fullpath;
            public string FileName;
            public string FilePath;
            public int startPos;
            public int size;
        }

        public struct CabInfo
        {
            public string src;
            public string password;
            public _FileInfo[] Files;
            public int count;
            public bool isCab;
            public bool isPassword;
            public bool isCompress;
            public bool isReady;

            public int startContentFile;
            public int startFileSize;
            public int startFilename;
            public int FilenameSize;

        }

        public bool ExportFile(CabInfo usercab, string path, string filename)
        {
            if (!usercab.isReady) return false;
            int userid = getCabID(usercab, filename);
            if (userid > -1)
            {
                ExportFile(usercab, path, userid);
                return true;
            }
            return false;
        }

        public byte[] ExportRawString(CabInfo usercab, string filename)
        {
            if (!usercab.isReady) return null;
            int userid = getCabID(usercab, filename);

            if (userid > -1)
            {
                return ExportRawString(usercab, userid);
            }
            return null;
        }

        public byte[] ExportRawString(CabInfo usercab, int lineno)
        {
            if (!usercab.isReady || lineno < 0 || lineno > usercab.count - 1) return null;
            return extractFile2Byte(usercab.src, usercab.Files[lineno].startPos, usercab.Files[lineno].size, usercab.password, usercab.isCompress);
        }

        public void ExportFile(CabInfo usercab, string path, int no)
        {
            if (!usercab.isReady) return;
            extractFile(usercab.src, path + "\\" + usercab.Files[no].Fullpath, usercab.Files[no].startPos, usercab.Files[no].size, usercab.password, usercab.isCompress);
        }

        public void ExportFiles(CabInfo usercab, string path)
        {
            if (!usercab.isReady) return;
            for (int i = 0; i < usercab.count; i++)
            {
                extractFile(usercab.src, path + "\\" + usercab.Files[i].Fullpath, usercab.Files[i].startPos, usercab.Files[i].size, usercab.password, usercab.isCompress);
                //label1.Text = (i + 1).ToString() + " \\ " + usercab.count.ToString();
                if ((i + 1) % 100 == 0) Application.DoEvents();
            }
        }

        public int getCabID(CabInfo usercab, string filename)
        {
            if (!usercab.isReady) return -1;
            for (int i = 0; i < usercab.count; i++)
            {
                if (usercab.Files[i].Fullpath.ToLower() == filename.ToLower())
                {
                    return i;
                }
            }
            return -1;
        }

        private int ReadInt32(FileStream fs, int Position)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadInt32();
        }

        private bool ReadBool(FileStream fs, int Position)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadBoolean();
        }

        private byte[] ReadBytes(FileStream fs, int Position, int count)
        {
            BinaryReader r = new BinaryReader(fs);
            fs.Position = Position;
            return r.ReadBytes(count);
        }

        private Boolean isFileFormat(FileStream fs)
        {
            int userStamp = ReadInt32(fs, 0);
            if (userStamp == _stamp) return true;
            MessageBox.Show("Unsupport File Format");
            return false;
        }

        private Boolean isFileFormat(string compactFile)
        {
            FileStream fs = new FileStream(compactFile, FileMode.Open, FileAccess.Read);
            return isFileFormat(fs);
        }

        private Boolean isPasswordOK(FileStream fs, string password)
        {
            int numberOfCrypto = crypto.Length;
            byte[] bytes = ReadBytes(fs, 4, numberOfCrypto);

            EncodeSd(bytes, password, true);

            bool isPassword = true;
            for (int i = 0; i < 8; i++)
            {
                if (bytes[i] != crypto[i]) isPassword = false;
            }
            if (!isPassword) MessageBox.Show("Incorrect Password");
            return isPassword;
        }

        public string[] getSubFiles(FileStream fs, int beginPos, int size, string password)
        {
            // Read FileNameRecord
            BinaryReader r = new BinaryReader(fs);
            byte[] buffer = new byte[size];
            fs.Position = beginPos;
            r.Read(buffer, 0, size);
            // Encoding FileNameRecord
            EncodeSd(buffer, password, true);
            string FileNameRecord = ByteToString(buffer);
            char[] tmpchar ={ ';' };
            return FileNameRecord.Split(tmpchar);
        }

        private int getSubFileCount(string compactFile, string password)
        {
            FileStream fs = new FileStream(compactFile, FileMode.Open, FileAccess.Read);
            if (!isFileFormat(fs)) return -1;
            if (!isPasswordOK(fs, password)) return -1;
            // Get size of each files
            int numberOfCrypto = crypto.Length;
            int count = ReadInt32(fs, numberOfCrypto + 5);
            fs.Close();
            return count;
        }

        public CabInfo getCabInfo(string compactFile, string password)
        {

            CabInfo userCab = new CabInfo();
            userCab.isReady = false;
            userCab.isCab = false;
            userCab.isPassword = false;

            if (!File.Exists(compactFile)) return userCab;

            FileStream fs = new FileStream(compactFile, FileMode.Open, FileAccess.Read);
            BinaryReader r = new BinaryReader(fs);

            userCab.src = compactFile;
            userCab.password = password;

            if (isFileFormat(fs)) userCab.isCab = true;
            if (isPasswordOK(fs, password)) userCab.isPassword = true;

            if (!userCab.isCab || !userCab.isPassword) return userCab;

            userCab.isReady = true;

            int numberOfCrypto = crypto.Length;
            // Get WithCompress or not
            userCab.isCompress = ReadBool(fs, numberOfCrypto + 4);

            // Get size of each files
            userCab.count = ReadInt32(fs, numberOfCrypto + 5);

            fs.Seek(-16, SeekOrigin.End);
            userCab.startContentFile = r.ReadInt32();
            userCab.startFileSize = r.ReadInt32();
            userCab.startFilename = r.ReadInt32();
            userCab.FilenameSize = r.ReadInt32();

            // Read LIST Files in cab
            string[] _FileName = getSubFiles(fs, userCab.startFilename, userCab.FilenameSize, password);
            userCab.Files = new _FileInfo[userCab.count];
            for (int i = 0; i < userCab.count; i++)
            {
                userCab.Files[i].FileName = getFileInfo(_FileName[i], false, true, true);
                userCab.Files[i].FilePath = getFileInfo(_FileName[i], true, false, false);
                userCab.Files[i].Fullpath = _FileName[i];
            }

            // Get Each File Position
            fs.Position = userCab.startFileSize;
            for (int i = 0; i < userCab.count; i++)
            {
                userCab.Files[i].size = r.ReadInt32();
            }

            // Get each file Start Position
            int BeginFile = userCab.startContentFile;
            for (int i = 0; i < userCab.count; i++)
            {
                userCab.Files[i].startPos = BeginFile;
                BeginFile += userCab.Files[i].size;
            }

            r.Close();
            fs.Close();

            return userCab;
        }

        private byte[] extractFile2Byte(string cabFile, int startPos, int count, string password, Boolean compress)
        {
            // Read contain file
            FileStream fs = new FileStream(cabFile, FileMode.Open, FileAccess.Read);
            BinaryReader r = new BinaryReader(fs);
            fs.Seek(startPos, SeekOrigin.Begin);
            byte[] myByte = new byte[count];
            r.Read(myByte, 0, count);
            r.Close();
            fs.Close();

            // decode file
            EncodeSd(myByte, password, true);
            return myByte;
        }

        private void extractFile(string cabFile, string NewFile, int startPos, int count, string password, Boolean compress)
        {
            string curPath = getFileInfo(NewFile, true, false, false);
            if (curPath.EndsWith("\\")) curPath = curPath.Substring(0, curPath.Length - 1);
            Directory.CreateDirectory(curPath);

            // Read contain file
            FileStream fs = new FileStream(cabFile, FileMode.Open, FileAccess.Read);
            BinaryReader r = new BinaryReader(fs);
            fs.Seek(startPos, SeekOrigin.Begin);
            byte[] myByte = new byte[count];
            r.Read(myByte, 0, count);
            r.Close();
            fs.Close();

            // decode file
            EncodeSd(myByte, password, true);

            // Write file
            FileStream fs2 = new FileStream(NewFile, FileMode.Create, FileAccess.Write);
            BinaryWriter w = new BinaryWriter(fs2);
            w.Write(myByte);
            w.Close();
            fs2.Close();

            // decompress file
            if (compress)
            {
                string tmpFile = NewFile + ".tmp";
                File.Move(NewFile, tmpFile);
                DecompressFile(tmpFile, NewFile);
                File.Delete(tmpFile);
            }
        }

        public void compactFile(string[] fileName, string dstFile, string password, bool withCompress, int pathLength)
        {
            File.Delete(dstFile);

            int count = fileName.Length;
            int[] _sizeFile = new int[count];

            FileStream fs = new FileStream(dstFile, FileMode.Create, FileAccess.Write);
            BinaryWriter r = new BinaryWriter(fs);

            // write stamp format
            r.Write(_stamp);

            // write password check
            int numberOfCrypto = crypto.Length; ;
            byte[] crypto2 = new byte[numberOfCrypto];
            Array.Copy(crypto, crypto2, numberOfCrypto);
            EncodeSd(crypto2, password, false);
            r.Write(crypto2);

            // WithCompress or not

            r.Write(withCompress);

            // Number of File
            r.Write(count);

            // Contain of each files
            //string tmp = "c:\\~tmp.dir";
            string tmp = Environment.GetFolderPath(Environment.SpecialFolder.Desktop) + "\\~tmp.dir";

            int startContentFile = Convert.ToInt32(fs.Position);

            for (int i = 0; i < count; i++)
            {
                byte[] myByte;
                File.Delete(tmp);
                // Compress File
                if (withCompress)
                {
                    CompressFile(fileName[i], tmp);
                    myByte = System.IO.File.ReadAllBytes(tmp);
                }
                else
                {
                    myByte = System.IO.File.ReadAllBytes(fileName[i]);
                }

                // GetSizeOfEachFile
                _sizeFile[i] = myByte.Length;

                // Encode File
                EncodeSd(myByte, password, false);

                // Write Contain of Files
                r.Write(myByte);

                //label1.Text = (i + 1).ToString() + " / " + count.ToString();
                //label1.Refresh();
                if ((i + 1) % 100 == 0) Application.DoEvents();
            }
            File.Delete(tmp);

            // GetPosition of EachFileSizeStartPosition
            int startFileSize = 0;
            startFileSize = Convert.ToInt32(fs.Position);

            // Size of each files
            for (int i = 0; i < count; i++)
            {
                r.Write(_sizeFile[i]);
            }

            // StartFilenameRecord
            int startFilenameRecord = Convert.ToInt32(fs.Position);


            // Get all Filename
            StringBuilder mb = new StringBuilder();
            for (int i = 0; i < count; i++)
            {
                mb.Append(fileName[i].Substring(pathLength) + ";");
            }
            string AllString = mb.ToString();

            // Convert String to Byte
            byte[] buffer = StringToByte(AllString);

            // EncodeSd to Byte
            EncodeSd(buffer, password, false);

            // Write Encoded Bytes
            r.Write(buffer);

            // write StartFileSize & StartFileNameRecord & FilenameRecordSize

            r.Write(startContentFile);
            r.Write(startFileSize);
            r.Write(startFilenameRecord);
            r.Write(buffer.Length);

            r.Close();
            fs.Close();

        }


        private string getFileInfo(string filename, bool path, bool name, bool extension)
        {
            int x = filename.LastIndexOf("\\");
            string strPath = "", strName = "", strExtension = "";
            if (path) strPath = filename.Substring(0, x + 1);
            strName = filename.Substring(x + 1);
            x = strName.LastIndexOf(".");
            if (x > -1)
            {
                strExtension = strName.Substring(x);
                strName = strName.Substring(0, x);
            }
            if (!name) strName = "";
            if (!extension) strExtension = "";
            return strPath + strName + strExtension;
        }


        private byte[] StringToByte(string Text)
        {
            return System.Text.Encoding.Unicode.GetBytes(Text);
        }

        private string ByteToString(byte[] bytes)
        {
            return System.Text.Encoding.Unicode.GetString(bytes);
        }

        public void EncodeSd(byte[] sByte, string Password, bool Decode)
        {
            try
            {
                int X;
                byte[] PwS = new Byte[100]; int i, a = 0;
                if (Password == "") Password = "The quick brown fox jumps over the lazy dog. 1234567890";
                Password = Password.Insert(Password.Length, Password);
                Password = Password.Insert(Password.Length, "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
                for (i = 0; i < 51; i++)
                {
                    PwS[i] = (byte)Convert.ToChar(Password.Substring(i, 1));
                }
                if (Decode)
                {
                    for (i = 0; i < sByte.Length; i++)
                    {
                        X = sByte[i];
                        X += PwS[a];
                        if (X > 255) X -= 256;
                        sByte[i] = (byte)X;
                        a += 1;
                        if (a > 50) a = 0;
                    }
                }
                else
                {
                    for (i = 0; i < sByte.Length; i++)
                    {
                        X = sByte[i];
                        X -= PwS[a];
                        if (X < 0) X += 256;
                        sByte[i] = (byte)X;
                        a += 1;
                        if (a > 50) a = 0;
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public string[] getFiles(string path, string pattern, bool fullpath, bool includeSubFolder)
        {
            if (pattern == "" || pattern == null) pattern = "*.*";
            DirectoryInfo mydir = new DirectoryInfo(path);
            FileInfo[] myfiles;
            string[] Files;
            try
            {
                if (includeSubFolder)
                    myfiles = mydir.GetFiles(pattern, SearchOption.AllDirectories);
                else
                    myfiles = mydir.GetFiles(pattern);

                if (myfiles.Length > 0)
                {
                    Files = new string[myfiles.Length];
                    for (int i = 0; i < myfiles.Length; i++)
                    {
                        if (fullpath)
                            Files[i] = myfiles[i].FullName;
                        else
                            Files[i] = myfiles[i].Name;
                    }
                    Array.Sort(Files);
                    return Files;
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            return null;
        }

        public string[] getFolders(string path, string pattern, bool fullpath, bool includeSubFolder)
        {
            if (pattern == "" || pattern == null) pattern = "*.*";
            DirectoryInfo mydir = new DirectoryInfo(path);
            DirectoryInfo[] myfolders;
            string[] Folders;

            try
            {
                if (includeSubFolder)
                    myfolders = mydir.GetDirectories(pattern, SearchOption.AllDirectories);
                else
                    myfolders = mydir.GetDirectories(pattern);

                if (myfolders.Length > 0)
                {

                    Folders = new string[myfolders.Length];

                    for (int i = 0; i < myfolders.Length; i++)
                    {
                        if (fullpath)
                            Folders[i] = myfolders[i].FullName;
                        else
                            Folders[i] = myfolders[i].Name;
                    }
                    return Folders;
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            return null;
        }

        private byte[] CompressByte(byte[] buffer, CompressionMode comPress)
        {
            string tmp = "c:\\tmp.dir", tmp2 = "c:\\tmp2.dir";

            File.WriteAllBytes(tmp, buffer);
            if (comPress == CompressionMode.Compress)
                CompressFile(tmp, tmp2);
            else
                DecompressFile(tmp, tmp2);

            buffer = File.ReadAllBytes(tmp2);

            File.Delete(tmp);
            File.Delete(tmp2);

            return buffer;

        }

        private void CompressFile(string sourceFile, string destinationFile)
        {

            if (File.Exists(sourceFile) == false)
            {
                MessageBox.Show("File Not Found");
                return;
            }

            // Create the streams and byte arrays needed
            byte[] buffer = null;
            FileStream sourceStream = null;
            FileStream destinationStream = null;
            GZipStream compressedStream = null;

            try
            {
                // Read the bytes from the source file into a byte array
                sourceStream = new FileStream(sourceFile, FileMode.Open, FileAccess.Read, FileShare.Read);

                // Read the source stream values into the buffer
                buffer = new byte[sourceStream.Length];
                int checkCounter = sourceStream.Read(buffer, 0, buffer.Length);

                if (checkCounter != buffer.Length)
                {
                    MessageBox.Show("Applicatoin Error");
                }

                // Open the FileStream to write to
                destinationStream = new FileStream(destinationFile, FileMode.OpenOrCreate, FileAccess.Write);

                // Create a compression stream pointing to the destiantion stream
                compressedStream = new GZipStream(destinationStream, CompressionMode.Compress, true);

                // Now write the compressed data to the destination file
                compressedStream.Write(buffer, 0, buffer.Length);
            }
            catch (ApplicationException ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                // Make sure we allways close all streams
                if (sourceStream != null)
                    sourceStream.Close();

                if (compressedStream != null)
                    compressedStream.Close();

                if (destinationStream != null)
                    destinationStream.Close();
            }
        }

        private void DecompressFile(string sourceFile, string destinationFile)
        {
            // make sure the source file is there
            if (File.Exists(sourceFile) == false)
            {
                MessageBox.Show("File not found");
            }

            // Create the streams and byte arrays needed
            FileStream sourceStream = null;
            FileStream destinationStream = null;
            GZipStream decompressedStream = null;
            byte[] quartetBuffer = null;

            try
            {
                // Read in the compressed source stream
                sourceStream = new FileStream(sourceFile, FileMode.Open);

                // Create a compression stream pointing to the destiantion stream
                decompressedStream = new GZipStream(sourceStream, CompressionMode.Decompress, true);

                // Read the footer to determine the length of the destiantion file
                quartetBuffer = new byte[4];
                int position = (int)sourceStream.Length - 4;
                sourceStream.Position = position;
                sourceStream.Read(quartetBuffer, 0, 4);
                sourceStream.Position = 0;
                int checkLength = BitConverter.ToInt32(quartetBuffer, 0);

                byte[] buffer = new byte[checkLength + 100];

                int offset = 0;
                int total = 0;

                // Read the compressed data into the buffer
                while (true)
                {
                    int bytesRead = decompressedStream.Read(buffer, offset, 100);

                    if (bytesRead == 0)
                        break;

                    offset += bytesRead;
                    total += bytesRead;
                }

                // Now write everything to the destination file
                destinationStream = new FileStream(destinationFile, FileMode.Create);
                destinationStream.Write(buffer, 0, total);

                // and flush everyhting to clean out the buffer
                destinationStream.Flush();
            }
            catch (ApplicationException ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                // Make sure we allways close all streams
                if (sourceStream != null)
                    sourceStream.Close();

                if (decompressedStream != null)
                    decompressedStream.Close();

                if (destinationStream != null)
                    destinationStream.Close();
            }

        }

        private byte[] intToByte(int userint)
        {
            byte[] b = new byte[2];
            int left = userint % 256;
            if (userint > 255) b[1] = Convert.ToByte((int)userint / 256);
            b[0] = Convert.ToByte(left);
            return b;
        }

        private int byteToInt(byte[] userbyte)
        {
            return userbyte[0] + (userbyte[1] * 256);
        }
    }


}
