using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace QuranNavigator
{
    public class sound
    {
        #region // Varieble Declarations

        // public AxMediaPlayer.AxMediaPlayer mp3;
        public MP3Player mplayer;

        public Timer tmrPrayer = new Timer();
        public string[] wavePoint;

        public struct myMedia
        {
            public int sura;
            public int aya;
            public string mediaSrc;
            public bool isSomePart;
            public double startPos;
            public double endPos;
            public bool isStart;
            public bool isEnd;
            public string message;
        }

        public myMedia[] soundItem;

        public ArrayList arrSoundItem;

        public int nsoundItem = 0;
        public int cursoundItem = 0;

        double curPositionStart = -1;
        double curPositionEnd = -1;

        //public string Quran.Reciter[QuranSetting.Default.ReciterID].location= "";

        public string lastReader = "";
        public bool isDirty = false;
        public bool isRepeat = false;
        public bool isInvalidate = false;
        public bool ReaderMustChange = false;

 
        #endregion

        public sound()
        {

            ///// initSound
            mplayer = new MP3Player();
            mplayer.EndOfStream += new MP3Player.EndOfStreamEventHandler(mplayer_EndOfStream);
            //mplayer.VolumeAll = 1000;
            //mplayer.VolumeBass = 1000;
            //mplayer.VolumeTreble = 1000;

            tmrPrayer.Tick += new EventHandler(tmrPrayer_Tick);
            tmrPrayer.Enabled = false;
            tmrPrayer.Interval = 200;
            
            soundItem = new myMedia[500];
            nsoundItem = 0;
            isInvalidate = true;
            //////// end initSound
        }

        void mplayer_EndOfStream(object sender, EndOfStreamEventArgs eea)
        {
            tmrPrayer.Enabled = false;
            //Application.DoEvents();
            //System.Threading.Thread.Sleep(50);
            //Quran.frmBoard.label5.Text = "mplay_EndOfStream";
            cursoundItem++;
            startPlaySound();
        }

        private void tmrPrayer_Tick(object sender, EventArgs e)
        {
            //Quran.frmBoard.label5.Text = mplayer.CurrentPosition.ToString() + " : " + curPositionStart.ToString() + " -> " + curPositionEnd.ToString();
            //Application.DoEvents();
            if (mplayer.CurrentPosition >= curPositionEnd)
            {
                mplayer_EndOfStream(null, null);
            }
        }


        //////////////////////////////////////////////

        public void playSound(String wavefile, double startPos, double endPos)
        {
            //MessageBox.Show(wavefile + "\n" + startPos.ToString());
            if (endPos < 0.000001) endPos = 99999;
            if (startPos == 0) startPos = 0.001;

            curPositionStart = startPos * 1000;
            curPositionEnd = endPos * 1000;

            //Quran.frmBoard.label5.Text = ("isStart = " + soundItem[cursoundItem].isStart.ToString() + " : isDirty = " + isDirty.ToString());
            
            if (soundItem[cursoundItem].isStart || isDirty == true)
            {
                isDirty = false;

                mplayer.Stop();
                mplayer.OpenAt(wavefile, (ulong)curPositionStart);
            }

            tmrPrayer.Enabled = true;

            Quran.MouseClickSura = soundItem[cursoundItem].sura;
            Quran.MouseClickAya = soundItem[cursoundItem].aya;
            Quran.frmBoard.displayAya();
        }

        public void stopSound()
        {
            tmrPrayer.Enabled = false;
            mplayer.Stop();
            Quran.isReading = false;
            Quran.MouseClickSura = 0;
            Quran.MouseClickAya = 0;
            Quran.frmBoard.displayAya();
            Quran.frmBoard.displayAya();

            Quran.unloadNavigator();
        }

        public void clsSound()
        {
            nsoundItem = 0;
            cursoundItem = 0;
            Array.Resize(ref soundItem, 500);
            isInvalidate = true;
        }

        //////////////

        public void resume()
        {
            mplayer.Pause();
        }

        public void pause()
        {
            mplayer.Pause();    
        }

        public void prev()
        {
            cursoundItem--;
            if (cursoundItem < 0) cursoundItem = 0;
            playSound(soundItem[cursoundItem].mediaSrc, soundItem[cursoundItem].startPos, soundItem[cursoundItem].endPos);
            mplayer.Seek( (ulong) soundItem[cursoundItem].startPos * 1000);
        }

        public void next()
        {
            cursoundItem++;
            if (cursoundItem > nsoundItem - 1) cursoundItem = nsoundItem - 1;
            playSound(soundItem[cursoundItem].mediaSrc, soundItem[cursoundItem].startPos, soundItem[cursoundItem].endPos);
            mplayer.Seek((ulong)soundItem[cursoundItem].startPos * 1000);
        }

        public void stop()
        {
            stopSound();
        }

        public void startPlaySound()
        {

            if (nsoundItem == 0) return;

            // MessageBox.Show(isInvalidate.ToString());
            if (cursoundItem > 0)
            {
                if (cursoundItem >= nsoundItem)
                {

                }
                else if (soundItem[cursoundItem].sura == soundItem[cursoundItem - 1].sura && soundItem[cursoundItem].aya < soundItem[cursoundItem - 1].aya)
                {
                    isInvalidate = true;
                }
            }

            if (isInvalidate)
            {
                soundInitial();
            }

            if (cursoundItem >= nsoundItem)
            {
                if (isRepeat)
                {
                    cursoundItem = 0;
                }
                else
                {
                    stopSound();
                    return;
                }
            }


            if (Quran.Reciter[QuranSetting.Default.ReciterID].location != lastReader && ReaderMustChange)
            {
                changeReader();
            }

            Quran.isReading = true;
            lastReader = Quran.Reciter[QuranSetting.Default.ReciterID].location;
            if (cursoundItem < 0) cursoundItem = 0;
            playSound(soundItem[cursoundItem].mediaSrc, soundItem[cursoundItem].startPos, soundItem[cursoundItem].endPos);
            //cursoundItem++;
            Quran.loadNavigator();
        }


        public void changeReader()
        {
            //  loadWavePoint();
            int nItem = nsoundItem;

            if (nItem == 0) return;

            int[] sur = new int[nItem];
            int[] ay = new int[nItem];

            for (int i = 0; i < nItem; i++)
            {
                sur[i] = soundItem[i].sura;
                ay[i] = soundItem[i].aya;
            }

            nsoundItem = 0;

            for (int i = 0; i < nItem; i++)
            {
                addAya(sur[i], ay[i]);
            }
            isDirty = true;

        }

        public void loadWavePoint()
        {

          // Extract files
            /*
                        for (int i = 0; i < 12; i++)
                        {
                            string fileloc2 = Quran.proglocation + @"Data\LocSound";
                            string txt2 = getFile(fileloc2, i);
                            System.IO.File.WriteAllText(@"D:\Documents and Settings\Terabus\Desktop\locsound\" + (i + 1) + ".txt", txt2);
                        }
            */
            // Pack files
            /*
            string textbox1 = @"D:\Documents and Settings\Terabus\Desktop\locsound\";
                        Cab cb = new Cab();
                       //string[] mystring = cb.getFiles(textbox1, "*.*", true, false);
                       string[] mystring = new string[12];
                        for (int i = 0; i < mystring.Length; i++)
                        {
                            mystring[i] = textbox1 + (i + 1).ToString() + ".txt";
                        }
                        cb.compactFile(mystring, @"D:\Documents and Settings\Terabus\Desktop\locsound3", "I love SdWr & Fiyah", false, textbox1.Length + 1);
            */


            string fileloc = Quran.proglocation + @"Data\loImg";
            string txt = "";
           //MessageBox.Show(QuranSetting.Default.ReciterID.ToString());

            /*
            if (QuranSetting.Default.ReciterID == 10)
                txt = getFile(fileloc, 12);
            else if (QuranSetting.Default.ReciterID == 9)
                txt = getFile(fileloc, 11);
            else if (QuranSetting.Default.ReciterID == 8)
                txt = getFile(fileloc, 10);
            else if (QuranSetting.Default.ReciterID == 7)
                txt = getFile(fileloc, 8);
            else
             */
            txt = getFile(fileloc, QuranSetting.Default.ReciterID);
            //txt = getSoundContain(QuranSetting.Default.ReciterID);

            //MessageBox.Show(QuranSetting.Default.ReciterID.ToString());

            wavePoint = txt.Split(new string[] { "\r\n" }, StringSplitOptions.None);
            modifiedWave();
            //MessageBox.Show(wavePoint[0] + "\n"
            //   + wavePoint[1] + "\n"
            //   + wavePoint[2] + "\n"
            //    );
            ReaderMustChange = true;
        }

        private string getSoundContain(int index)
        {
            //MessageBox.Show("Getting sound : " + index.ToString());
            string fileloc = Quran.proglocation + @"Data\loImg";//LocSound";

            string path2 = Quran.proglocation + "Sound\\" + Quran.Reciter[index].location
                + "\\s.bin";

            return getFile(fileloc, index);

        }

        //  Check the wheather sound is first or last or mid
        public void soundInitial()
        {
            for (int i = 0; i < nsoundItem; i++)
            {
                if (i == 0)
                {
                    soundItem[i].isStart = true;
                }
                else
                {
                    if (soundItem[i].sura == soundItem[i - 1].sura && soundItem[i].aya == soundItem[i - 1].aya + 1 && soundItem[i].mediaSrc == soundItem[i - 1].mediaSrc)
                    {
                        soundItem[i].isStart = false;
                    }
                    else
                    {
                        soundItem[i].isStart = true;
                        soundItem[i - 1].isEnd = true;
                    }

                    //if (soundItem[i].aya == 0)
                   // {
                   //     soundItem[i].isStart = true;
                   //     soundItem[i - 1].isEnd = true;
                   // }
                   // if (soundItem[i].sura == soundItem[i - 1].sura && soundItem[i].aya < soundItem[i - 1].aya)
                   // {
                   //     soundItem[i].isStart = true;
                   //     soundItem[i - 1].isEnd = true;
                   // }

                }
            }
            soundItem[nsoundItem - 1].isEnd = true;
            isInvalidate = false;
        }

        ///////////////////////////// load sound functions and utilities

        private void getFileInfo(int sura, int aya, ref string wavefile, ref double startpos, ref double endpos)
        {
            int no = 0;
            int curline = Quran.SuraTable[sura - 1].line;
            if (aya > 0) curline += aya - 1;

            double posStart = 0, posEnd = 0;

            if (wavePoint.Length > 5)
            {
                string[] position = wavePoint[curline].Split(new char[] { ',' });

                posStart = Convert.ToDouble(position[0]);
                posEnd = Convert.ToDouble(position[1]);
                if (position.Length == 3)
                {
                    no = Convert.ToInt32(position[2]);
                }
            }

            string soundDir;
            soundDir = Quran.soundlocation;

            if (!soundDir.EndsWith("\\")) soundDir += "\\";

            if (aya == 0)
            {
                soundDir = soundDir + Quran.Reciter[QuranSetting.Default.ReciterID].location + "\\" + "besm.wav";
                posStart = 0.0;
                posEnd = 99999;
            }
            else
            {
                soundDir = soundDir + Quran.Reciter[QuranSetting.Default.ReciterID].location + "\\" + getSoundName(sura, aya, no);
            }

            wavefile = soundDir;
            startpos = posStart;
            endpos = posEnd;
        }

        public string getSoundName(int sura, int aya, int no)
        {
            string soundname = "";
            if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "saadghamidi")
            {
                soundname = "S" + sura.ToString() + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "menshawy")
            {
                soundname = "MN" + getLast(no, 2) + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "hosari")
            {
                soundname = "hsr" + no.ToString() + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "sudes")
            {
                soundname = "S" + sura.ToString() + ".wav";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "huthi")
            {
                soundname = "htf" + no.ToString() + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "ajmi")
            {
                soundname = "S" + sura.ToString() + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "basit")
            {
                soundname = "S" + sura.ToString() + ".wav";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "basfar")
            {
                soundname = getLast(no, 3) + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "qahtani")
            {
                soundname = getLast(no, 2) + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "thubaiti")
            {
                soundname = getLast(sura, 3) + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "mishari")
            {
                soundname = "msr" + no.ToString() + ".mp3";
            }
            else if (Quran.Reciter[QuranSetting.Default.ReciterID].location.ToLower() == "shatiri")
            {
                soundname = "str" + no.ToString() + ".mp3";
            }
            else
            {
                soundname = sura.ToString() + ".mp3";
            }

            return soundname;
        }

        public string getLast(int no, int length)
        {
            string tx = "000" + no;
            return tx.Substring(tx.Length - length, length);
        }

        public string getFile(string compactfile, int lineno)
        {
            Cab rom = new Cab();
            Cab.CabInfo usercab = rom.getCabInfo(compactfile, "I love SdWr & Fiyah");
            byte[] myByte = rom.ExportRawString(usercab, lineno);
            if (myByte == null) return "";
            string content = System.Text.Encoding.GetEncoding(1256).GetString(myByte);
            content = content.Trim();
            if (content.EndsWith("\r\n")) content = content.Substring(0, content.Length - 2);
            return content;
        }

        ////////////////////  utilities

        public void addAya(int sura, int aya)
        {

            isRepeat = false;

            string wavefile = "";
            double startpos = 0, endpos = 0;
            getFileInfo(sura, aya, ref wavefile, ref startpos, ref endpos);

            if (nsoundItem >= soundItem.Length)
            {
                Array.Resize(ref soundItem, soundItem.Length + 500);
            }

            soundItem[nsoundItem].mediaSrc = wavefile;
            soundItem[nsoundItem].startPos = startpos;
            soundItem[nsoundItem].endPos = endpos;
            soundItem[nsoundItem].sura = sura;
            soundItem[nsoundItem].aya = aya;

            // MessageBox.Show(soundItem[nsoundItem].mediaSrc);

            nsoundItem++;

        }

        public void readThisSura(int sura)
        {
            readThisSura(sura, 1);
        }

        public void readThisSura(int sura, int repeatcount)
        {
            clsSound();
            addAyas(sura, 0, sura, -1, repeatcount);
            startPlaySound();
        }

        public void readThisSura(int sura, int repeatcount, int repeatrange)
        {
            clsSound();
            addAyas(sura, 0, sura, -1, repeatcount);
            if (repeatrange > 1) makeRepeat(repeatrange);
            startPlaySound();
        }

        public void makeRepeat(int count)
        {
            int currSoundItem = nsoundItem;
            int nextcountsounditem = currSoundItem * count;
            Array.Resize(ref soundItem, nextcountsounditem);
            if (count > 1)
            {
                for (int o = 1; o < count; o++)
                {
                    int startno = currSoundItem * o;
                    //soundItem[startno - 1].isStart = true;
                    //soundItem[startno - 1].isEnd = true;
                    for (int i = 0; i < currSoundItem; i++)
                    {
                        soundItem[startno + i].mediaSrc = soundItem[i].mediaSrc;
                        soundItem[startno + i].startPos = soundItem[i].startPos;
                        soundItem[startno + i].endPos = soundItem[i].endPos;
                        soundItem[startno + i].sura = soundItem[i].sura;
                        soundItem[startno + i].aya = soundItem[i].aya;
                    }
                }
            }
            nsoundItem = nextcountsounditem;
        }

        public void readThisPart(int sura, int aya)
        {
            int sura1 = 0, aya1 = 0, sura2 = 0, aya2 = 0;
            int part = Quran.getPartFromAya(sura, aya);
            clsSound();
            if (part < 1) part = 1;
            if (part > 30) part = 30;
            Quran.loadPartInfo(part, ref sura1, ref aya1, ref sura2, ref aya2);
            addAyas(sura1, aya1, sura2, aya2);
            startPlaySound();
        }

        public void readThisPart(int part)
        {
            readThisPart(part, 1, 0);
        }

        public void readThisPart(int part, int repeatcount, int zero)
        {
            int sura1 = 0, aya1 = 0, sura2 = 0, aya2 = 0;
            clsSound();
            if (part < 1) part = 1;
            if (part > 30) part = 30;
            Quran.loadPartInfo(part, ref sura1, ref aya1, ref sura2, ref aya2);
            addAyas(sura1, aya1, sura2, aya2, repeatcount);
            startPlaySound();
        }

        public void readThisPart(int part, int repeatcount, int zero, int repeatrange)
        {
            int sura1 = 0, aya1 = 0, sura2 = 0, aya2 = 0;
            clsSound();
            if (part < 1) part = 1;
            if (part > 30) part = 30;
            Quran.loadPartInfo(part, ref sura1, ref aya1, ref sura2, ref aya2);
            addAyas(sura1, aya1, sura2, aya2, repeatcount);
            if(repeatrange > 1) makeRepeat(repeatrange);
            startPlaySound();
        }

        public void addFromThisAyaToEndSura(int sura, int aya)
        {
            clsSound();
            addAyas(sura, aya, sura, -1);
            startPlaySound();
        }

        public void addFromThisAyaToEndPart(int sura, int aya)
        {
            clsSound();
            int part = Quran.getPartFromAya(sura, aya);
            int sura1 = 0, aya1 = 0, sura2 = 0, aya2 = 0;
            Quran.loadPartInfo(part, ref sura1, ref aya1, ref sura2, ref aya2);
            addAyas(sura, aya, sura2, aya2);
            startPlaySound();
        }

        public void addFromThisSuraToEndPart(int sura, int aya)
        {
            clsSound();
            int part = Quran.getPartFromAya(sura, aya);
            int sura1 = 0, aya1 = 0, sura2 = 0, aya2 = 0;
            Quran.loadPartInfo(part, ref sura1, ref aya1, ref sura2, ref aya2);
            addAyas(sura, 0, sura2, aya2);
            startPlaySound();
        }

        public void addFromThisAya(int sura, int aya)
        {
            clsSound();
            addAyas(sura, aya, 114, -1);
            startPlaySound();
        }

        public void addFromThisSura(int sura)
        {
            clsSound();
            addAyas(sura, 0, 114, -1);
            startPlaySound();
        }

        public void readThisAya(int sura, int aya)
        {
            clsSound();
            addAyas(sura, aya, sura, aya);
            startPlaySound();
        }

        public void addAyas(int suraStart, int ayaStart, int suraEnd, int ayaEnd)
        {
            addAyas(suraStart, ayaStart, suraEnd, ayaEnd, 1);
        }

        public void addAyas(int suraStart, int ayaStart, int suraEnd, int ayaEnd, int repeatcount)
        {
            if (suraStart < 1 || suraEnd < 1) return;

            Random rnd = new Random(DateTime.Now.Second);
            int loop = rnd.Next(100) + 100;
            for (int i = 0; i < loop; i++)
            {
                int b = i;
                b += i * 2;
                if (b == 400) break;
                if (b == 1000) break;
                if (b == 30000) break;
            }

            if (!Quran.ActiveOK)
            {
                loop = rnd.Next(2000) + 1000;
                for (int i = 0; i < loop; i++)
                {
                    int b = i;
                    b += i * 2;
                    if (b == 400) break;
                    if (b == 1000) break;
                    if (b == 30000) break;
                }

                if (suraStart > 2 || suraEnd > 2)
                {
                    loop = rnd.Next(2000) + 1000;
                    for (int i = 0; i < loop; i++)
                    {
                        int b = i;
                        b += i * 2;
                        if (b == 400) break;
                        if (b == 1000) break;
                        if (b == 30000) break;
                    }
                    Quran.showMessageActivateRequired();

                    return;
                }
            }


            int ayacount = 0;
            int startAya = 0;
            int endAya = 0;
            int repeatreset = 1;

            for (int o = suraStart; o <= suraEnd; o++)
            {
                ayacount = Quran.SuraTable[o - 1].ayaCount;

                if (o == suraStart)
                    startAya = ayaStart;
                else
                    startAya = 0;

                if (o == suraEnd)
                    endAya = ayaEnd;
                else
                    endAya = ayacount;

                if (endAya == -1) endAya = ayacount;

                for (int i = startAya; i <= endAya; i++)
                {
                    if ((o == 1 && i == 0) || (o == 9 && i == 0)) i++;
                    if (i == 0 && QuranSetting.Default.ReciterID == 1) i++;
                    repeatreset = repeatcount;

                    if (i == 0) repeatreset = 1;
                    for (int u = 1; u <= repeatreset; u++)
                    {
                        addAya(o, i);
                    }
                }
            }
        }


        private void modifiedWave()
        {
            //MessageBox.Show(QuranSetting.Default.ReciterID.ToString());
            //return;


            /*
            if (QuranSetting.Default.ReciterID == 1)
            {
                //double addon = 0.090; // file1
                double[] AllAddon = { 202.4499486, 202.4085732, 202.807855, 202.5777272, 204.6942857, 204.7884335, 204.7395364, 204.4341996, 202.6355667, 202.4427481, 202.5288945, 202.6577995, 205.8807698, 205.8597895, 205.5904928, 205.6494186, 205.127907, 205.2445652, 205.1196875, 204.992399, 204.8547036, 204.7805511, 205.8727273, 205.7944535, 205.6023375, 205.4606742, 204.9333442, 204.5931478, 205.6266238, 205.391055, 204.6891139, 204.1686315, 204.9900032, 204.5708661, 205.5461095, 205.3908785, 204.9759798, 205.0808694, 203.8197549, 204.0191388 };
                int lastindex = 0;
                int id = 0;

                for (int i = 0; i < wavePoint.Length; i++)
                {
                    string[] a = wavePoint[i].Split(",".ToCharArray());
                    double l1 = Convert.ToDouble(a[0]) * 1000;
                    double l2 = Convert.ToDouble(a[1]) * 1000;
                    int l3 = Convert.ToInt32(a[2]);

                   

                    if (lastindex != l3)
                    {
                        lastindex = l3;
                        id = 0;

                        l1 /= 1000;
                        l2 /= 1000;
                    }
                    else
                    {
                        id++;
                        l1 += (l1 / AllAddon[l3 - 1]) - 10;
                        l2 += (l2 / AllAddon[l3 - 1]);

                        l1 /= 1000;
                        l2 /= 1000;
                    }
                    wavePoint[i] = l1.ToString() + "," + l2.ToString() + "," + l3;
                }
                //System.IO.File.WriteAllLines(@"D:\Documents and Settings\Terabus\Desktop\2.txt", wavePoint);
            }
            */
            return;
            if (QuranSetting.Default.ReciterID == 4)
            {
                //MessageBox.Show("Sudes");
                //double[] AllAddon = { 62.2959381044487, 790.225396825397, 640.483797178803, 725.701829008932, 818.943523634131, 635.978095663835, 547.600677724273, 558.377541998232, 662.096455070074, 557.549249836921, 515.54540213318, 509.326941826454, 601.672985781991, 483.007448789572, 192.878634639697, 495.768045649073, 489.856958762887, 457.126841768097, 301.7759634226, 293.359447004608, 349.104271356784, 511.222990492653, 272.280360664976, 664.688284518828, 343.438818565401, 201.58502119642, 353.173661360347, 498.775417298938, 379.851657940663, 396.121071612571, 427.519867549669, 281.146911519199, 552.983237759153, 418.25249343832, 483.31007751938, 280.407379798733, 150.536697247706, 271.249727767695, 486.662292213473, 482.809377401998, 390.064229765013, 484.76348773842, 294.448882374496, 149.829651448208, 402.765451664025, 504.124183006536, 355.967828418231, 444.393570807993, 393.395294117647, 257.62786377709, 189.482621648461, 198.038186157518, 164.355698075974, 151.058556284705, 156.279740154283, 178.342637822749, 553.698328935796, 533.511737089202, 379.052863436123, 459.695431472081, 242.573729863693, 254.372945638432, 276.442105263158, 299.004744958482, 379.765644171779, 323.501253132832, 234.986565910999, 161.028708133971, 186.992844364937, 154.114634146341, 187.330065359477, 217.798679867987, 248.906285714286, 117.705352676338, 89.9605911330049, 177.410134600158, 106.751037344398, 110.970149253731, 132.75, 105.77, 94.9570247933884, 101.453631284916, 156.410334346505, 113.706689536878, 120.134199134199, 68.339226519337, 72.1219512195122, 67.2582728006457, 103.836833602585, 80.5363636363636, 65.5489260143198, 77.4143337066069, 49.135, 31.9936628643853, 58.0341340075853, 88.4528944381385, 61.321083172147, 123.769038701623, 55.4854614412137, 60.8397040690506, 58.6713021491783, 47.0049566294919, 36.4314115308151, 47.407960199005, 64.4803149606299, 55.9647058823529, 63.9961089494163, 34.4074074074074, 57.1322957198444, 52.6804733727811, 56.6568047337278, 27.7354260089686, 53.9979466119097, 56.6568047337278 };
                double[] AllAddon = { 62.2959381044487, 30.225396825397, 640.483797178803, 725.701829008932, 818.943523634131, 635.978095663835, 547.600677724273, 558.377541998232, 662.096455070074, 557.549249836921, 515.54540213318, 509.326941826454, 601.672985781991, 483.007448789572, 192.878634639697, 495.768045649073, 489.856958762887, 457.126841768097, 301.7759634226, 293.359447004608, 349.104271356784, 511.222990492653, 272.280360664976, 664.688284518828, 343.438818565401, 201.58502119642, 353.173661360347, 498.775417298938, 379.851657940663, 396.121071612571, 427.519867549669, 281.146911519199, 552.983237759153, 418.25249343832, 483.31007751938, 280.407379798733, 150.536697247706, 271.249727767695, 486.662292213473, 482.809377401998, 390.064229765013, 484.76348773842, 294.448882374496, 149.829651448208, 402.765451664025, 504.124183006536, 355.967828418231, 444.393570807993, 393.395294117647, 257.62786377709, 189.482621648461, 198.038186157518, 164.355698075974, 151.058556284705, 156.279740154283, 178.342637822749, 553.698328935796, 533.511737089202, 379.052863436123, 459.695431472081, 242.573729863693, 254.372945638432, 276.442105263158, 299.004744958482, 379.765644171779, 323.501253132832, 234.986565910999, 161.028708133971, 186.992844364937, 154.114634146341, 187.330065359477, 217.798679867987, 248.906285714286, 117.705352676338, 89.9605911330049, 177.410134600158, 106.751037344398, 110.970149253731, 132.75, 105.77, 94.9570247933884, 101.453631284916, 156.410334346505, 113.706689536878, 120.134199134199, 68.339226519337, 72.1219512195122, 67.2582728006457, 103.836833602585, 80.5363636363636, 65.5489260143198, 77.4143337066069, 49.135, 31.9936628643853, 58.0341340075853, 88.4528944381385, 61.321083172147, 123.769038701623, 55.4854614412137, 60.8397040690506, 58.6713021491783, 47.0049566294919, 36.4314115308151, 47.407960199005, 64.4803149606299, 55.9647058823529, 63.9961089494163, 34.4074074074074, 57.1322957198444, 52.6804733727811, 56.6568047337278, 27.7354260089686, 53.9979466119097, 56.6568047337278 };
                int lastindex = 0;
                int id = 0;
                int sura0 = 0;
                int aya0 = 0;

                for (int i = 0; i < wavePoint.Length; i++)
                {
                    string[] a = wavePoint[i].Split(",".ToCharArray());
                    double l1 = Convert.ToDouble(a[0]) * 1000;
                    double l2 = Convert.ToDouble(a[1]) * 1000;
                    Quran.AyaFromLine(i, ref sura0, ref aya0);
                    int l3 = sura0;//Convert.ToInt32(a[2]);

                    if (lastindex != l3)
                    {
                        lastindex = l3;
                        id = 0;
                    }
                    else
                    {
                        id++;
                        l1 += (l1 / AllAddon[l3 - 1]) - 10;
                        l2 += (l2 / AllAddon[l3 - 1]);
                        l1 /= 1000;
                        l2 /= 1000;
                    }
                    wavePoint[i] = l1.ToString() + "," + l2.ToString();
                }

            }

        }

    }
}
