using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace QuranNavigator
{

    public class userMnu
    {
        ////////////////////////  menuclass
        public class menuitems
        {
            public string Text;
            public string Tag;
            public int Index;
            public bool Selected;
            public EventHandler ClickEventHandler;
            public bool isExistChild;
            public bool isCheckStyle;
            public menuitems[] child;
            public int childcount;
            public menuitems parent;
            public RectangleF bk;
            public Font Font;
            public bool Visible;
            public bool Enable;
            public bool useChildColor;
            public Color BackColor;
            public Color ForeColor;
            public bool barVisible;
            public Color barColor;
            public Image Icon;


            public void addChild(string txt)
            {
                addChild(txt, "");
            }

            public void addChild(string txt, string tag)
            {
                addChild(txt, tag, null);
            }

            public void addChild(string txt, string tag, EventHandler handler)
            {
                addChild(txt, tag, handler, BackColor);
            }

            public void addChild(string txt, string tag, EventHandler handler, Font font)
            {
                addChild(txt, tag, handler, BackColor, ForeColor, font);
            }

            public void addChild(string txt, string tag, EventHandler handler, Color BackColor)
            {
                addChild(txt, tag, handler, BackColor, ForeColor);
            }

            public void addChild(string txt, string tag, EventHandler handler, Color backColor, Color foreColor)
            {
                addChild(txt, tag, handler, backColor, foreColor, Font);
            }

            public void addChild(string txt, string tag, EventHandler handler, Color backColor, Color foreColor, Font font)
            {
                menuitems subitem = new menuitems();
                subitem.Text = txt;
                subitem.Tag = tag;
                subitem.Selected = false;
                subitem.isExistChild = false;
                subitem.BackColor = QuranSetting.Default.BackColor;
                subitem.ForeColor = QuranSetting.Default.ForeColor;
                // new version new color
                //subitem.BackColor = Quran.bgColor;
                //subitem.ForeColor = Quran.foColor;
                ////////////
                subitem.Font = font;
                subitem.Enable = true;
                subitem.ClickEventHandler = handler;
                addChild(subitem);

            }

            public void addChild(menuitems subitem)
            {
                childcount++;
                Array.Resize(ref child, childcount);
                subitem.parent = this;
                child[childcount - 1] = subitem;
                isExistChild = true;
            }

            bool isExit(string txt, string[] txt2)
            {
                if (txt2.Length == 0) return false;
                for (int i = 0; i < txt2.Length; i++)
                {
                    if (txt == txt2[i]) return true;
                }
                return false;
            }

            public void clearChild()
            {
                child = null;
                childcount = 0;
                isExistChild = false;
            }

            public void selectChild(string tag)
            {
                if (childcount == 0) return;
                for (int i = 0; i < childcount; i++)
                {
                    menuitems subitem = (menuitems)child[i];
                    if (subitem.Tag == tag)
                    {
                        subitem.Selected = true;
                    }
                    else
                        subitem.Selected = false;
                }
            }

            public void selectChild(string[] tag)
            {
                if (childcount == 0) return;
                for (int i = 0; i < childcount; i++)
                {
                    menuitems subitem = (menuitems)child[i];
                    if (isExit(subitem.Tag, tag))
                    {
                        subitem.Selected = true;
                    }
                    else
                        subitem.Selected = false;
                }
            }


            public menuitems()
            {
                int fontsize = (int)(10 * QuranSetting.Default.zoom);
                if (fontsize < 7) fontsize = 7;
                if (fontsize > 12) fontsize = 12;

                Font = new Font("Tahoma", fontsize);

                BackColor = QuranSetting.Default.BackColor;
                ForeColor = QuranSetting.Default.ForeColor;

                Selected = false;
                childcount = 0;
                Visible = true;
                useChildColor = false;

            }

        }

        public class userMenu
        {
            public userMenu()
            {
                bgBarColor = Color.Blue;
                selectColor = QuranSetting.Default.BarSelectColor;
                mouseOnColor = QuranSetting.Default.BarMoveColor;

                bgColor = Color.WhiteSmoke;
               
                useChildColor = false;

                myMenu = new menuitems[200];
                nmyMenu = 0;
                imgArrow = createArrow();
                imgChk = createChk();
            }

            private Bitmap createBar(int width, int height)
            {
                Bitmap tmp = new Bitmap(width, height);

                Graphics g = Graphics.FromImage(tmp);
                Rectangle imageRect = new Rectangle(0, 0, width, height);
                Color firstColor = bgBarColor;

                LinearGradientBrush brush = new LinearGradientBrush(new Rectangle(0, 0, width, height),
                QuranSetting.Default.BackColor, QuranSetting.Default.TitleBarColor
                , LinearGradientMode.Horizontal);

                g.FillRectangle(brush, imageRect);
                g.Dispose();
                return tmp;
            }

            private Bitmap createArrow()
            {
                Bitmap tmp = new Bitmap(4, 7);
                Graphics g = Graphics.FromImage(tmp);
                for (int i = 0; i < 3; i++)
                {
                    g.DrawLine(new Pen(new SolidBrush(QuranSetting.Default.ForeColor), 1), i, i, i, 6 - i);
                }
                g.DrawLine(new Pen(new SolidBrush(QuranSetting.Default.ForeColor), 1), 0, 3, 3, 3);
                g.Dispose();
                return tmp;
            }

            private Bitmap createChk()
            {
                Bitmap tmp = new Bitmap(19, 19);
                Graphics g = Graphics.FromImage(tmp);

                //g.Clear(Color.FromArgb(100, 255, 199, 79));
                g.Clear(Color.FromArgb(100, QuranSetting.Default.CheckBgColor.R, QuranSetting.Default.CheckBgColor.G, QuranSetting.Default.CheckBgColor.B));

                // ͺҧ͡
                g.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.CheckFrameColor), 1), 0, 0, 18, 18);

                // 礶١
                g.DrawLine(new Pen(new SolidBrush(QuranSetting.Default.CheckCheckColor), 2), 6, 9, 8, 11);
                g.DrawLine(new Pen(new SolidBrush(QuranSetting.Default.CheckCheckColor), 2), 8, 11, 12, 7);

                g.DrawLine(new Pen(Brushes.Black, 1), 6, 10, 8, 12);
                g.DrawLine(new Pen(Brushes.Black, 1), 8, 12, 12, 8);

                g.Dispose();
                return tmp;
            }

            public userMenu(menuitems parentitem)
            {
                isCheckStyle = parentitem.isCheckStyle;
                doRefresh(parentitem);
                loadMenu();
            }

            public void doRefresh(menuitems parentitem)
            {
                parentMenuitem = parentitem;
                myMenu = new menuitems[200];
                nmyMenu = 0;
                imgArrow = createArrow();
                imgChk = createChk();

                clearItem();

                if (parentitem.childcount == 0) return;
                for (int i = 0; i < parentitem.childcount; i++)
                {
                    addItem(parentitem.child[i]);
                }
            }

            public menuitems parent;

            public bool isCheckStyle;

            public menuitems[] myMenu;
            public int nmyMenu;
            public Form frmMenu;
            public Color bgBarColor;
            public Color selectColor;
            public Color mouseOnColor;
            public Color bgColor;
            public bool useChildColor;

            Bitmap imgArrow;
            Bitmap imgChk;

            int curBK = -1;
            int lastBk = -1;
            Bitmap bt;
            userMenu mySubMenu;
            userMenu myParentMenu;
            menuitems parentMenuitem;
            int menuHeight = 0;

            public void setColor(Color newBgColor, Color newBarColor)
            {
                bgColor = newBgColor;
                bgBarColor = newBarColor;
                if (mySubMenu != null)
                {
                    mySubMenu.setColor(newBgColor, newBarColor);
                }
                paintImage();
            }

            public menuitems findItem(string tag)
            {
                menuitems tmpitem = new menuitems();
                if (nmyMenu == 0) return tmpitem;
                for (int i = 0; i < nmyMenu; i++)
                {
                    if (myMenu[i].Tag == tag) return myMenu[i];
                }
                return tmpitem;
            }

            public menuitems fintItemFromTagName(menuitems curmenu, string tag, bool includeSubChild)
            {
                menuitems tmpitem = new menuitems();
                if (curmenu.childcount == 0) return tmpitem;

                for (int i = 0; i < curmenu.childcount; i++)
                {
                    if (curmenu.child[i].Tag == tag) return curmenu.child[i];
                    if (curmenu.child[i].childcount > 0 && includeSubChild)
                    {
                        tmpitem = fintItemFromTagName(curmenu.child[i], tag, true);
                        if (tmpitem.Tag == tag) return tmpitem;
                    }
                }
                return tmpitem;
            }

            public menuitems fintItemFromTextName(menuitems curmenu, string text, bool includeSubChild)
            {
                menuitems tmpitem = new menuitems();
                if (curmenu.childcount == 0) return tmpitem;

                for (int i = 0; i < curmenu.childcount; i++)
                {
                    if (curmenu.child[i].Text == text) return curmenu.child[i];
                    if (curmenu.child[i].childcount > 0 && includeSubChild)
                    {
                        tmpitem = fintItemFromTextName(curmenu.child[i], text, true);
                        if (tmpitem.Text == text) return tmpitem;
                    }
                }
                return tmpitem;
            }

            public void addItem(string text, string index, EventHandler eventHandler, bool selected)
            {
                myMenu[nmyMenu] = new menuitems();
                myMenu[nmyMenu].Text = text;
                myMenu[nmyMenu].Tag = index;
                myMenu[nmyMenu].ClickEventHandler = eventHandler;
                myMenu[nmyMenu].childcount = 0;
                myMenu[nmyMenu].child = null;
                myMenu[nmyMenu].isExistChild = false;
                myMenu[nmyMenu].Selected = selected;
                // myMenu[nmyMenu].parent = parent;
                nmyMenu++;
            }

            public void addItem(menuitems thisitem)
            {
                myMenu[nmyMenu] = thisitem;
                nmyMenu++;
            }

            public void dispose()
            {
               
                if (mySubMenu != null) mySubMenu.dispose();
                if (frmMenu != null)
                {
                    //frmMenu.TopLevel = false;
                    frmMenu.Hide();
                    frmMenu.Dispose();
                    Quran.menuCount--;
                    frmMenu = null;
                }

            }

            public void clearItem()
            {
                nmyMenu = 0;
            }

            private void loadMenu()
            {
                loadMenu(true);
            }

            private void loadMenu(bool newLoad)
            {
                if (newLoad)
                {
                    frmMenu = new Form();

                    frmMenu.Width = 200;
                    frmMenu.Height = 200;
                    frmMenu.BackColor = Color.White;
                    frmMenu.FormBorderStyle = FormBorderStyle.None;
                    frmMenu.ShowInTaskbar = false;
                    frmMenu.Paint += new PaintEventHandler(frmMenu_Paint);
                    frmMenu.MouseMove += new MouseEventHandler(frmMenu_MouseMove);
                    frmMenu.Click += new EventHandler(frmMenu_Click);
                }

                int lastHeight = 0;
                int curHeight = 0;
                int marginX = 30;
                int curSizeWidth = 0;
                int curSizeHeight = 0;

                for (int i = 0; i < nmyMenu; i++)
                {
                    float w = frmMenu.CreateGraphics().MeasureString(myMenu[i].Text, myMenu[i].Font).Width;
                    float h = frmMenu.CreateGraphics().MeasureString(myMenu[i].Text, myMenu[i].Font).Height;
                    if (w > curSizeWidth) curSizeWidth = (int)w;
                    if (h > curSizeHeight) curSizeHeight = (int)h;
                }

                curSizeWidth += 10;
                curSizeHeight += 4;
                curHeight = 2;

                for (int i = 0; i < nmyMenu; i++)
                {
                    if (myMenu[i].Visible)
                    {
                        if (myMenu[i].Text == "-")
                        {
                            myMenu[i].bk.X = marginX + 2;
                            myMenu[i].bk.Y = curHeight + 2;
                            myMenu[i].bk.Width = curSizeWidth + 40;
                            myMenu[i].bk.Height = 1;
                            // curHeight += 4;
                        }
                        else
                        {
                            myMenu[i].bk.X = marginX;
                            myMenu[i].bk.Y = curHeight;
                            myMenu[i].bk.Width = curSizeWidth;
                            myMenu[i].bk.Height = curSizeHeight;
                            lastHeight = (int)myMenu[i].bk.Y + (int)myMenu[i].bk.Height;
                            curHeight += curSizeHeight + 1;
                            //curHeight += curSizeHeight + 5;
                        }
                    }
                }

                menuHeight = lastHeight + 5;

                frmMenu.Width = curSizeWidth + marginX + 10;

                if (menuHeight > Screen.PrimaryScreen.WorkingArea.Height)
                {
                    frmMenu.Height = Screen.PrimaryScreen.WorkingArea.Height;
                    frmMenu.AutoScroll = true;
                    Label lblBorder = new Label();
                    lblBorder.Top = menuHeight;
                    lblBorder.Height = 5;
                    lblBorder.BackColor = Color.White;
                    lblBorder.Visible = true;

                    frmMenu.Controls.Add(lblBorder);
                }
                else
                {
                    frmMenu.Height = menuHeight;
                }

                paintImage();
            }

            void frmMenu_Click(object sender, EventArgs e)
            {
                if (curBK < 0) return;
                if (myMenu[curBK].isExistChild) return;

                if (myMenu[curBK].ClickEventHandler != null)
                {
                    myMenu[curBK].ClickEventHandler(myMenu[curBK], null);

                    if (isCheckStyle)
                    {
                        for (int i = 0; i < myMenu[curBK].parent.childcount; i++)
                        {
                            myMenu[curBK].parent.child[i].Selected = false;
                        }
                        myMenu[curBK].Selected = true;

                        paintImage();

                    }
                    if (myParentMenu != null) myParentMenu.paintImage();
                }

            }

            void frmMenu_MouseMove(object sender, MouseEventArgs e)
            {
                Quran.CloseMenuID = Quran.CloseMenuTick;
                if (!Quran.frmBoard.timer2.Enabled) Quran.frmBoard.timer2.Enabled = true;

                if (nmyMenu == 0) return;

                int eY = e.Y - frmMenu.AutoScrollPosition.Y;

                for (int i = 0; i < nmyMenu; i++)
                {
                    if (e.X >= 0 && e.X <= frmMenu.Width && eY >= myMenu[i].bk.Y && eY <= myMenu[i].bk.Y + myMenu[i].bk.Height && myMenu[i].Text != "-" && myMenu[i].Visible)
                    {
                        curBK = i;
                        if (curBK != lastBk)
                        {                           
                            frmMenu_Paint(null, null);

                            //showSubMenu(curBK, e.X + frmMenu.Left , e.Y + frmMenu.Top);
                            showSubMenu(curBK, frmMenu.Left + frmMenu.Width - 5, frmMenu.Top + (int)myMenu[curBK].bk.Top);
                        }
                        lastBk = curBK;
                    }
                }
            }

            public void showSubMenu(int bkid, int xPos, int yPos)
            {
                if (mySubMenu != null)
                {
                    mySubMenu.CloseMenu();
                    mySubMenu = null;
                }

                if (!myMenu[bkid].isExistChild)
                {
                    return;
                }

                //int x = (int)myMenu[bkid].bk.Left + (int)myMenu[bkid].bk.Width + 7;
                //int y = (int)myMenu[bkid].bk.Top;
                int x = xPos;
                int y = yPos;

                mySubMenu = new userMenu(myMenu[bkid]);

                mySubMenu.bgBarColor = bgBarColor;
                mySubMenu.selectColor = selectColor;
                mySubMenu.mouseOnColor = mouseOnColor;
                mySubMenu.bgColor = bgColor;
                mySubMenu.useChildColor = myMenu[bkid].useChildColor;
                mySubMenu.myParentMenu = this;
                //mySubMenu.ShowMenu(frmMenu, x, y);
                mySubMenu.ShowMenu(x, y);
            }

            public void CloseMenu()
            {
                dispose();
            }

            public int getXPos(Control ctl)
            {
                if (Quran.menuFrom == 0) return Quran.frmBoard.Left;

                int x = 0;
                if (ctl != null)
                {
                    if (ctl.Parent != null)
                    {
                        if (ctl.Parent.Parent != null)
                        {
                            x += ctl.Parent.Parent.Left;
                        }
                        x += ctl.Parent.Left;
                    }
                    x += ctl.Left;
                }
                return x;
            }

            public int getYPos(Control ctl)
            {
                if (Quran.menuFrom == 0) return Quran.frmBoard.Top;
                int y = 0;
                if (ctl != null)
                {
                    if (ctl.Parent != null)
                    {
                        if (ctl.Parent.Parent != null)
                        {
                            y += ctl.Parent.Parent.Top;
                        }
                        y += ctl.Parent.Top;
                    }
                    y += ctl.Top;
                }
                return y;
            }

            public void ShowMenu(int x, int y)
            {
                if (nmyMenu == 0) return;
                if (frmMenu == null) frmMenu = new Form();

                curBK = -1;
                loadMenu();

                int ScreenHeight = Screen.PrimaryScreen.WorkingArea.Height;
                int ScreenWidth = Screen.PrimaryScreen.WorkingArea.Width;

                if (x + frmMenu.Width > ScreenWidth)
                {
                    if (Quran.menuCount == 0)
                    {
                        x = ScreenWidth - frmMenu.Width;
                    }
                    else
                    {
                        x = Quran.menuMain.Left - frmMenu.Width;
                    }

                    if (x < 0) x = ScreenWidth - this.frmMenu.Width;
                }

                if (y + menuHeight > ScreenHeight)
                {
                    y = ScreenHeight - menuHeight;
                }
                if (y < 2) y = 2;



                frmMenu.Left = x;
                frmMenu.Top = y;
                //frmMenu.TopLevel = true;
                frmMenu.Show(Quran.frmBoard);
                //frmMenu.ShowDialog(frmBoard.qBoard);

                Quran.menuCount++;

                if (Quran.menuCount == 1)
                {
                    Quran.menuMain = new Rectangle(frmMenu.Left, frmMenu.Top, frmMenu.Width, frmMenu.Height);
                    Quran.CloseMenuID = Quran.CloseMenuTick;
                    Quran.frmBoard.timer2.Enabled = true;
                }
                else
                    Quran.menuSub = new Rectangle(frmMenu.Left, frmMenu.Top, frmMenu.Width, frmMenu.Height);

            }

            public void paintImage()
            {
                if (frmMenu == null) return;
                if (bt == null) bt = new Bitmap(frmMenu.Width, menuHeight);
                if (frmMenu == null) return;

                Graphics myE = Graphics.FromImage(bt);

                //myE.Clear(bgColor);
                myE.Clear(QuranSetting.Default.BackColor);

                myE.DrawImage(createBar(25, menuHeight), 0, 0);

                for (int i = 0; i < nmyMenu; i++)
                {
                    if (myMenu[i].Visible)
                    {
                        if (myMenu[i].Text != "-")
                        {
                            // brush for backColor
                            SolidBrush sbBackColor = new SolidBrush(myMenu[i].BackColor);

                            // brush for foreColor
                            SolidBrush sbForeColor = new SolidBrush(myMenu[i].ForeColor);


                            // Draw Background color
                            if (useChildColor)
                                myE.FillRectangle(sbBackColor, myMenu[i].bk.Left - 5, myMenu[i].bk.Top, frmMenu.Width - 6, myMenu[i].bk.Height + 5);
                            else
                                myE.FillRectangle(new SolidBrush(QuranSetting.Default.BackColor), myMenu[i].bk.Left - 5, myMenu[i].bk.Top, frmMenu.Width - 6, myMenu[i].bk.Height + 5);

                            if (curBK == i) // Mouse current on
                            {
                                myE.FillRectangle(new SolidBrush(mouseOnColor), 3, myMenu[i].bk.Top, frmMenu.Width - 6, myMenu[i].bk.Height);
                                myE.DrawRectangle(new Pen(Brushes.DarkGray, 1), 3, myMenu[i].bk.Top, frmMenu.Width - 6, myMenu[i].bk.Height);

                            }
                            else if (myMenu[i].Selected)  // Selected Item
                            {
                                myE.FillRectangle(new SolidBrush(selectColor), myMenu[i].bk.Left - 2, myMenu[i].bk.Top + 4, frmMenu.Width - 6, myMenu[i].bk.Height);
                            }

                            if(useChildColor)
                                myE.DrawString(myMenu[i].Text, myMenu[i].Font, sbForeColor, new Point((int)myMenu[i].bk.X, (int)myMenu[i].bk.Y + 5));
                            else
                                myE.DrawString(myMenu[i].Text, myMenu[i].Font, new SolidBrush(QuranSetting.Default.ForeColor), new Point((int)myMenu[i].bk.X, (int)myMenu[i].bk.Y + 5));

                            if (myMenu[i].isExistChild)  // Draw Child sign
                            {
                                myE.DrawImage(imgArrow, new Point(((int)myMenu[i].bk.Left + (int)myMenu[i].bk.Width), (int)(myMenu[i].bk.Top + ((myMenu[i].bk.Height - imgArrow.Height) / 2))));
                            }

                            // paint chk  // draw check sign
                            if (myMenu[i].Selected) myE.DrawImage(imgChk, new Point(4, (int)(myMenu[i].bk.Top + ((myMenu[i].bk.Height - imgChk.Height) / 2) + 2)));

                            // Draw Bar in Tone
                            if (myMenu[i].barVisible)
                            {
                                Rectangle r = new Rectangle(30, (int)(myMenu[i].bk.Top + ((myMenu[i].bk.Height - imgChk.Height) / 2) + 2), 20, (int) myMenu[i].bk.Height);
                                myE.FillRectangle(new SolidBrush(myMenu[i].barColor), r);
                            }

                            // Draw Icon
                            if (myMenu[i].Icon != null)
                            {
                                Point p = new Point(3, (int)(myMenu[i].bk.Top));
                                myE.DrawImage(myMenu[i].Icon, p);
                            }

                        }
                    }
                }

                for (int i = 0; i < nmyMenu; i++)
                {
                    if (myMenu[i].Visible)
                    {
                        if (myMenu[i].Text == "-")
                        {
                            myE.DrawLine(new Pen(Brushes.DarkGray, 1), (int)myMenu[i].bk.X, (int)myMenu[i].bk.Y, (int)myMenu[i].bk.Width - 2, (int)myMenu[i].bk.Y);
                        }
                    }
                }

                myE.DrawRectangle(new Pen(Brushes.Black, 1), 1, 1, frmMenu.Width - 3, menuHeight - 2);
                myE.DrawRectangle(new Pen(new SolidBrush(QuranSetting.Default.ForeColor), 1), 2, 2, frmMenu.Width - 5, menuHeight - 4);

                frmMenu.CreateGraphics().DrawImage(bt, 0, frmMenu.AutoScrollPosition.Y);

                myE.Dispose();
                GC.Collect();
            }

            void frmMenu_Paint(object sender, PaintEventArgs e)
            {
                paintImage();
            }

        }

    }
}
